// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js

//var appVersion = "0.6.2";
angular.module('app', ['ionic', 'app.controllers', 'app.routes', 'app.directives','app.services','ngCordova','tmh.dynamicLocale',
  'pascalprecht.translate', 'ngProgress','ngSegment'])

.constant('availableLanguages', ['en-US','fr-FR'])
//.constant('defaultLanguage','fr-FR')
.constant('defaultLanguage','en-US')
.config(function($ionicConfigProvider, $sceDelegateProvider){
  $sceDelegateProvider.resourceUrlWhitelist([ 'self','*://www.youtube.com/**', '*://player.vimeo.com/video/**']);
})


.config(function(tmhDynamicLocaleProvider,$translateProvider, defaultLanguage, segmentProvider){
  tmhDynamicLocaleProvider.localeLocationPattern('locales/angular-locale_{{locale}}.js');
  $translateProvider.useStaticFilesLoader({
    'prefix': 'i18n/',
    'suffix': '.json'
  });
  $translateProvider.preferredLanguage(defaultLanguage);
  $translateProvider.useSanitizeValueStrategy('escape');
  segmentProvider
        .setKey('zHVPxERdrDl8uBK06uoTp2cDtAV8sN0q')
        //.setCondition(function ($rootScope) {
            //return $rootScope.isProduction;
        //})
        .setDebug(false)
})

.run(function($ionicPlatform, $cordovaPush, $http, $cordovaDialogs, $cordovaGlobalization,
  availableLanguages, defaultLanguage, tmhDynamicLocale, $translate, $window, Saving, $state, Globales,$timeout,Option, $cordovaStatusbar) {

  $http.defaults.headers.common = { 'X-API-Key' : 'mogo_&pp_key!is!here@' }

  $window.notif_Outback = function(data,callback){
      Saving.load(function(){
        // console.log(JSON.stringify(data));
        var storage = window.localStorage;
        var req = {
             method: 'POST',
             url: 'https://app.getluko.com/msg/notifoutback',
             headers: {
                'Authorization': 'jwt '+ storage.token,
                'Content-Type': 'application/json'
             },
             data: '{"data": '+ JSON.stringify(data) + '}'
        };
        $http(req).then(callback);
      });
    }

  $window.yes = function(data){
    // console.log(JSON.stringify(data));
    data = data.additionalData;
    data.validate = 1;
    $window.notif_Outback(data,function(){
      $window.push.finish(null, null, data.notId);
    })
  }

  $window.no = function(data) {
    data = data.additionalData;
    data.validate = 2;
    $window.notif_Outback(data,function(){
      $window.push.finish(null, null, data.notId);
    })
  };

  $window.maybe = function(data) {
    data = data.additionalData;
    data.validate = 0;
    $window.notif_Outback(data,function(){
      $window.push.finish(null, null, data.notId);
    })
  };

  //var db = null;

  $ionicPlatform.ready(function() {

    var storage = window.localStorage;

    document.addEventListener("pause", function (event) {
        // console.log('run() -> cordovaPauseEvent');
        $rootScope.$broadcast('cordovaPauseEvent');
    });

    document.addEventListener("resume", function (event) {
        // console.log('run() -> cordovaResumeEvent');
        $rootScope.$broadcast('cordovaResumeEvent');
    });

    // console.log("Platform ready !")

    var redirect = function(){
        var res = Globales.getHardwareStatus(storage.token).then(function(data){
            if (data==0){
                console.log("Error in hardware status1")
                try{window.plugins.toast.showLongBottom($translate.instant("ANERRORHAPPEN"))}catch(err){}
                //$cordovaDialogs.alert($translate.instant('ANERRORHAPPEN'), $translate.instant('ERROR'), "OK");
                //$cordovaDialogs.alert($translate.instant('ANERRORHAPPEN'), 'Hello', "OK");
                return 0;
            }
            else if (data.data==0){
                console.log("Error in hardware status2")
                $state.go('myLuko.settings');
                return 1;
            }
            else{
                data = data.data;
                console.log(data);
                if (data.sensor_id){
                    return 0;
                } else {
                    $state.go('myLuko.settings');
                    return 1
                }
            }
            return 0;
        });
        console.log("Res redirect: " + res);
        return res;
    };



    /*
    *** Set notifications function
    */

    var startup = function($cordovaStatusbar){
      // console.log("load DB")
      try{StatusBar.hide();}catch(err){console.log(err)};
      Saving.load(function(){
        // console.log("trig now");
        if((storage.Email !== '')&&(storage.Email !== 'null')&&(storage.Email !== 'undefined')&&(typeof(storage.Email) !== 'undefined')){
          // console.log("got email")
          if((storage.token !== '')&&(typeof(storage.token) !== 'undefined')){
            // console.log("got token" +  storage.token)
            if(typeof intercom !== 'undefined') {
              intercom.registerIdentifiedUser({email: storage.Email});
            }
            else{
              // console.log("no intercom plugins");
            }

            
              Option.getDeviceID(storage.token).then(function(resp){ 
                console.log("resp : " + resp);
                if (resp != 0){ 
                  console.log("luko validation : " + resp);
                  storage.isLukoValidated = true; 
                } 
                console.log("storage1 : " + storage.introDone) 
                if (!storage.introDone && !storage.isLukoValidated) { 
                  console.log("Start with intro1"); 
                  $state.go('myLuko.intro').then(function(){try{navigator.splashscreen.hide();}catch(err){console.log("no splashscreen to hide")}}); 
                } 
                else { 
                    redirect().then(function(redirect){
                        console.log("Redirect : " + redirect);
                        if (redirect == 1) {
                            $state.go('myLuko.settings').then(function(){try{navigator.splashscreen.hide();}catch(err){console.log("no splashscreen to hide")}});
                        } else {
                            console.log("Start with consumption"); 
                            $state.go('myLuko.consumption').then(function(){try{navigator.splashscreen.hide();}catch(err){console.log("no splashscreen to hide")}}); 
                            //$state.go('myLuko.intro').then(function(){try{navigator.splashscreen.hide();}catch(err){console.log("no splashscreen to hide")}}); 
                        } 
                      })
                } 
              },function(err){
                  $state.go('myLuko.consumption').then(function(){try{navigator.splashscreen.hide();}catch(err){console.log("no splashscreen to hide")}}); 
                } ) 
            } else { 
                console.log("storage2 : " + storage.isLukoValidated) 
                console.log("storage2 : " + storage.introDone) 
                if (!storage.introDone && !storage.isLukoValidated) { 
                  console.log("Start with intro2"); 
                  $state.go('myLuko.intro').then(function(){try{navigator.splashscreen.hide();}catch(err){console.log("no splashscreen to hide")}}); 
                } 
                else { 
                    redirect().then(function(redirect){
                        console.log("Redirect : " + redirect);
                        if (redirect == 1) {
                            $state.go('myLuko.settings').then(function(){try{navigator.splashscreen.hide();}catch(err){console.log("no splashscreen to hide")}});
                        } else {
                            console.log("Start with consumption"); 
                            $state.go('myLuko.consumption').then(function(){try{navigator.splashscreen.hide();}catch(err){console.log("no splashscreen to hide")}}); 
                            //$state.go('myLuko.intro').then(function(){try{navigator.splashscreen.hide();}catch(err){console.log("no splashscreen to hide")}}); 
                        } 
                      }) 
                } 
            }

            try{
              cordova.getAppVersion.getVersionNumber().then(function (version) {
                Globales.valideMuffinAndVersion(storage.token, version).then(function(out){
                  if(out==1){
                    // console.log("valide")
                    Globales.logInToken().then(function(resp){
                      if (resp==0){
                        $state.go('myLuko.login');
                      }
                      else {
                        console.log("NEW TOKEN : ", resp.token)
                        storage.token=resp.token;
                        Saving.save(null);
                      }
                    })
                  }
                  else if(out == 10){
                    // console.log("Not up to date");
                    $cordovaDialogs.alert($translate.instant("PLEASEUPDATEYOURAPP"), $translate.instant("OLDVERSION"), "OK");
                  }
                  else if(out==2){
                    // console.log("not validity")
                    storage.token = "";
                    Saving.save(null);
                    $state.go('myLuko.login');
                  }
                  else{
                    // console.log("no internet");
                  }
                });
              });
            }
            catch(err){
              // console.log("No app version");
              Globales.valideMuffin(storage.token).then(function(out){
                  if(out==1){
                    // console.log("valide")
                    Globales.logInToken().then(function(resp){
                      if (resp==0){
                        $state.go('myLuko.login');
                      }
                      else {
                        storage.token=resp.token;
                        Saving.save(null);
                      }
                    })
                  }
                  else if(out==2){
                    // console.log("not validity")
                    storage.token = "";
                    Saving.save(null);
                    $state.go('myLuko.login');
                  }
                  else{
                    // console.log("no internet");
                  }
                });
            }
          }
        else{
            $state.go('myLuko.login');
            storage.Email = '';
            navigator.splashscreen.hide();
        }
      });
    };

    /*
    *** Set notifications function
    */


    var redirect_alert_event = function (data) {
      if (data.additionalData.notId % 2 == 0)
      {
            // console.log("Luko - Redirect to event")
            storage.currentCard = data.additionalData.appliance;
            $state.go('myLuko.appliance');
      }
      else
      {
            // console.log("Luko - Redirect to alert")
            Globales.getAlertById(storage.token, (data.additionalData.notId -1) / 2).then(function(alertData){
              // console.log(JSON.stringify(alertData));

              storage.alertData = JSON.stringify(alertData.data);
              $state.go('myLuko.alertCard');
            });
      }
    };

    var setNotifications = function () {
      // console.log("Start notif")
      //GCM notification for android
      if(typeof PushNotification !== 'undefined') {
        // console.log("notification initialisation")
        $window.push = PushNotification.init({
          android: {
            senderID: "853049769037",
            messageKey: "message",
            titleKey: 'title',
            icon: "iconpush",
            iconColor: "#fa5050",
            sound: true,
            vibrate: true
          },
          ios: {
            alert: "true",
            badge: "true",
            sound: "true",
            senderID: "853049769037",
            gcmSandbox: "false",
            "categories": {
              "ways3": {
                "yes": {
                  "callback": $translate.instant('YES'),
                  "title": $translate.instant('THANKSLUKO'),
                  "foreground": false,
                  "destructive": true
                },
                "no": {
                  "callback": $translate.instant('NO'),
                   "title": $translate.instant('YOUAREWRONG'),
                   "foreground": false,
                   "destructive": true
                },
                "maybe": {
                  "callback": $translate.instant('MAYBE'),
                  "title": $translate.instant('NOTSURE'),
                  "foreground": false,
                  "destructive": true
                }
              },
              "ways2": {
                "yes": {
                  "callback": $translate.instant('YES'),
                  "title": $translate.instant('THANKSLUKO'),
                  "foreground": false,
                  "destructive": true
                },
                "no": {
                  "callback": $translate.instant('NO'),
                  "title": $translate.instant('YOUAREWRONG'),
                  "foreground": false,
                  "destructive": true
                }
              }
            }
          },
          windows: {}
        });

        $window.push.on('registration', function(data) {
          // console.log("registered")
          // console.log(data.registrationId)
          storage.setItem('registrationId', data.registrationId);
          if(ionic.Platform.isIOS()){
            var platformString = "IOS";
          }
          else if (ionic.Platform.isAndroid()){
            var platformString = "GCM";
          }
          else{
            var platformString = "OTHER";
          }
          // console.log(platformString);
          cordova.getAppVersion.getVersionNumber().then(function (version) {
            $http.post('https://app.getluko.com/msg/subscribePush', {token: data.registrationId, platform: platformString, user_id: user_id_here, appversion: version, language: $translate.use()})
            .success(function(data){
            })
            .error(function(err){
            });
          });
        });

        $window.push.on('notification', function(data) {
          // console.log("- message notification -")
          // console.log(JSON.stringify(data));

          // console.log(data.additionalData.notId);
          storage.received_notification = JSON.stringify({'notId': data.additionalData.notId, 'appliance': data.additionalData.appliance});
          // console.log(storage.received_notification);
          if(data.additionalData.notId == "wr"){
            $cordovaDialogs.alert(data.message, data.title, "OK");
          }
          else {
            //The app is open so make a popup with the possibility to get redirected to the card
            if (data.additionalData.foreground == true && data.additionalData.coldstart == false)
            {
              // console.log("The app open");
              $cordovaDialogs.confirm(data.message,  data.title,
                [$translate.instant("SHOWME"),
                $translate.instant("CANCEL")]).then(function(response){
                  if(response==1){
                    redirect_alert_event(data);
                  }
                });
            }
            // The app is in background, send notification and open the app on the card if notif clicked
            else if (data.additionalData.foreground == false && data.additionalData.coldstart == false)
            {
              // console.log("The app closed in foreground");
              redirect_alert_event(data);
            }
            // The app is closed, send notification and open the app on the card if notif clicked
            else if (data.additionalData.foreground == false && data.additionalData.coldstart == true)
            {
              // console.log("The app closed coldstart");
              $timeout(function(){
                // console.log("Now !!! ---------------------->");
                redirect_alert_event(data);
              },500);
            }
        	}
            // $cordovaDialogs.confirm(data.message, data.title,
            //   [$translate.instant('THANKSLUKO'), $translate.instant('YOUAREWRONG')])
            //   .then(function(buttonIndex){
            //     var btnIndex = buttonIndex;
            //     if((storage.token !== '')&&(typeof(storage.token) !== 'undefined')){
            //       user_id_here = storage.token
            //     }
            //     // console.log(btnIndex);
            //     if(user_id_here!=0){
            //       validateAlert = btnIndex
            //       data = data.additionalData;
            //       data.validate = validateAlert;
            //       // console.log(btnIndex);
            //       $window.notif_Outback(data,function(){
            //         // console.log("message transmis");
            //         push.finish();
            //       });
            //     }
            // });
          //}
        });

        $window.push.on('error', function(e) {
          // console.log("error");
          // console.log(e.message);
        });

      }
      else{
        // console.log("no notification !!")
      }
      // console.log("End notif")
    }

    languageApplied = false;
    var setLanguage = function(){
      if (typeof navigator.globalization !== 'undefined') {
        navigator.globalization.getPreferredLanguage(function(result){
          //// console.log(JSON.stringify(result));
          var language = getSuitableLanguage(result.value);
          //// console.log(language);
          applyLanguage(language);
          $translate.use(language);
          setNotifications();
          startup();
        },null);
      }
      else{
        // console.log("No language service");
        setNotifications();
        startup();
      }
      languageApplied = true;
    }

    var getSuitableLanguage = function(language){
      for (var index=0; index< availableLanguages.length; index++){
        if (availableLanguages[index].toLowerCase().substring(0,2) === language.toLocaleLowerCase().substring(0,2)){
          return availableLanguages[index];
        }
      }
      return defaultLanguage;
    }

    var applyLanguage = function(language){
      tmhDynamicLocale.set(language.toLowerCase());
    }

    // console.log("Setting language")
    setLanguage();
    //languageApplied = true;

    if (window.cordova && window.cordova.plugins && window.Keyboard) {
      console.log("Setting up keyboard")
      window.Keyboard.hideFormAccessoryBar(false);
      //cordova.plugins.Keyboard.disableScroll(true);
      console.log("Check IOS sprecific")
      if(ionic.Platform.isIOS()){
        // console.log("Ios is me")
        //cordova.plugins.Keyboard.shrinkView(false);
        //cordova.plugins.Keyboard.disableScrollingInShrinkView(false);
      }
    }
    // console.log("Status Bar")
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }

    //window.addEventListener("orientationchange", function() {
    //  window.location.reload(true);
    //}, false);

/*    // console.log("Analytics Google")
    if(typeof analytics !== 'undefined') {
      analytics.startTrackerWithId('UA-96475691-1',15);
      cordova.getAppVersion.getVersionNumber().then(function (version) {
          analytics.setAppVersion(version);
          // console.log(version);
      });
      analytics.debugMode();
      if((storage.Email !== '')&&(typeof(storage.Email) !== 'undefined')){
        analytics.setUserId(storage.Email);
      }
    } else {
      // console.log("Google Analytics Unavailable");
    }
    */

    var user_id_here = 0;
    if((storage.token !== '')&&(typeof(storage.token) !== 'undefined')){
      user_id_here = storage.token
    }


    // var startupAfterLanguage = function(){
    //   if(languageApplied){
    //     startup();
    //   }else{
    //     setTimeout(startupAfterLanguage(), 50)
    //   };
    // };
    //
    // startupAfterLanguage();

  });

})

/*
  This directive is used to disable the "drag to open" functionality of the Side-Menu
  when you are dragging a Slider component.
*/
.directive('disableSideMenuDrag', ['$ionicSideMenuDelegate', '$rootScope', function($ionicSideMenuDelegate, $rootScope) {
    return {
        restrict: "A",
        controller: ['$scope', '$element', '$attrs', function ($scope, $element, $attrs) {

            function stopDrag(){
              $ionicSideMenuDelegate.canDragContent(false);
            }

            function allowDrag(){
              $ionicSideMenuDelegate.canDragContent(true);
            }

            $rootScope.$on('$ionicSlides.slideChangeEnd', allowDrag);
            $element.on('touchstart', stopDrag);
            $element.on('touchend', allowDrag);
            $element.on('mousedown', stopDrag);
            $element.on('mouseup', allowDrag);

        }]
    };
}])

/*
  This directive is used to open regular and dynamic href links inside of inappbrowser.
*/
.directive('hrefInappbrowser', function() {
  return {
    restrict: 'A',
    replace: false,
    transclude: false,
    link: function(scope, element, attrs) {
      var href = attrs['hrefInappbrowser'];

      attrs.$observe('hrefInappbrowser', function(val){
        href = val;
      });

      element.bind('click', function (event) {

        window.open(href, '_system', 'location=yes');

        event.preventDefault();
        event.stopPropagation();

      });
    }
  };
});
