angular.module('app.controllers')

.controller('alertCardCtrl', ['$scope', '$rootScope', '$stateParams', '$ionicPopup', 'Globales', '$state', '$timeout', '$ionicHistory', 
'Option', '$translate', 'Price', 'Saving', 'Feedback', 'Advice', '$cordovaDialogs', '$cordovaInAppBrowser', 'ngProgressFactory','segment',  // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller

// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $rootScope, $stateParams, $ionicPopup, Globales, $state, $timeout, $ionicHistory, 
  Option, $translate, Price, Saving, Feedback, Advice, $cordovaDialogs, $cordovaInAppBrowser, ngProgressFactory, segment) {
 var analytics = segment;
  var storage = window.localStorage;
  $scope.options = {};
  var todayPowerGraph = Array.apply(null, Array(24)).map(Number.prototype.valueOf,3);

  /* **********************************************
    1 - Graph
    2 - Alerts
    3 - Functions
    4 - Initialisation
   **********************************************	*/


  /* 1 - Chart functions and variables definitions  */
  /*
  // start Graph variables
  var ctx;
  var dataGraph;
  var barData;
  var myChart;
  var optionBar;
  var tooltipsUnits;
  var todayApplianceGraph;

  // Get the data to create the Graph

  var createData = function(id){

      // Get today
      if (id == 0) {
          var d = new Date();
          var fuseTime = d.getHours()-d.getUTCHours();
          dataGraph.datasets[0].data = [];
          for (i = 0; i < 24; i++){
              dataGraph.datasets[0].data[i] = todayApplianceGraph[(48+i+4-fuseTime)%24];
          }
          for (i = 0; i < 24; i++){
              if(i%2==0){
                  dataGraph.labels[i] = ((i+3)%24)+1;
              }
              else{
                  dataGraph.labels[i] = '';
              }
              var n = (24 + d.getHours()-4)%24;
              if(i<=n){
                  dataGraph.datasets[0].backgroundColor[i] = '#3a68c2';
              }
              else{
                  dataGraph.datasets[0].backgroundColor[i] = '#dedede';
              }
          }
      }
      // Get period hours
      else {

      }
    }

    // Restore the data for the graph not useful I think
    var restoreData = function(){

        try {
            consumptionData = JSON.parse(storage.consumptionData);
        }
        catch(err) {
            consumptionData=0;
        }

        if(consumptionData != 0){
            $timeout(function(){
                // Alert moment consumtion data
                todayPowerGraph = consumptionData.data.today.hour_consumption_UTC;
                myChart.update();
                createData(0);
            });
        }
    }

  // Sets options and BarData variables needed for the model Chart
  var setGraphOptions = function(){
      optionBar = {
          tooltips: {
              enabled: true,
              intersect: false,
              backgroundColor: 'rgba(0,0,0,0.6)' ,
              displayColors: false,
              callbacks: {
                label: function(tooltipItem, data) {
                  if(tooltipItem.yLabel <= 0){
                      return $translate.instant("NODATARECEIVED")
                  }
                  if(tooltipsUnits=="kWh"){
                      timeTypeGraph = 1
                      if($scope.timeActive==4){
                          timeTypeGraph = 3
                      }
                      return [Price.formatLargeNumber(Math.round(tooltipItem.yLabel), 0) + ' ' + tooltipsUnits, Price.cur(Price.auto(tooltipItem.yLabel,0,timeTypeGraph))]
                  }
                  else{
                      return Price.formatLargeNumber(Math.round(tooltipItem.yLabel), 0) + ' ' + tooltipsUnits;
                  }
                },
                title: function() {
                  return null;
                }
              }
          },
          responsive: true,
          maintainAspectRatio: false,
          legend: {
              display: false,
              labels: {
                  padding: 0,
              }
          },
          layout:{
              padding: 10
          },
          scales: {
              xAxes: [{
                  gridLines: {
                      display: false
                  },
                  ticks: {
                      fontSize: 10,
                      maxRotation: 0,
                  }
              }],
              yAxes: [{
                  gridLines: {
                      display: false
                  },
                  gridLines: {
                      display: false,
                      lineWidth: 0,
                      drawTicks: false,
                      zeroLineWidth: 0,
                      drawBorder: false,
                  },
                  ticks: {
                      display: true,
                      fontSize: 12,
                      maxRotation: 0,
                      beginAtZero:true,
                      suggestedMax: 1,
                      mirror: true,
                      maxTicksLimit: 10,
                      callback: function (value, index, values) {
                          if(index==0){
                              return(Price.formatLargeNumber(value, 0) + tooltipsUnits);
                          }
                      }
                  },
              }]
          },
          zoom: {
              enabled: false
          },
          pan: {
              enabled: false
          }
      };
      dataGraph = {
            labels: [],
            datasets: [{
                  data: [],
                  backgroundColor: []
                  }]
          };
      barData = {
          type: 'bar',
          data: dataGraph,
          options: optionBar,
      };
    }


    // defineGraph create the new Graph model
    var defineGraph = function(){
      ctx = document.getElementById("AlertChart");
      tooltipsUnits = "Wh";
      todayApplianceGraph = Array.apply(null, Array(24)).map(Number.prototype.valueOf,0);
      setGraphOptions();
      createData(0);
      myChart = new Chart(ctx, barData);
    }
    */
    /* 2 - Alert validation and Other Alerts */

    // Function to change the validation of the Alert
    $scope.changeValidation = function(alert){
      if(alert.validate == 0 || alert.validate == 2){
        $scope.validCheckIcon = "img/consumption/validateGreen.png";
        data = {
          'id' : alert.id,
          'seen' : true,
          'validate' : 1,
          'deleted' : false,
        };
        $scope.alertCard.validate = 1;
      }
      else if (alert.validate == 1){
        $scope.validCheckIcon = "img/consumption/noValidateRed.png";
        data = {
          'id' : alert.id,
          'seen' : true,
          'validate' : 2,
          'deleted' : false,
        };
        $scope.alertCard.validate = 2;
      }
      if(typeof(data) != "undefined"){
          Globales.setAlerts(storage.token, data).then(function(out){
              console.log(out);
          });
        }
    }

    // Change bell alert icon
    $scope.setAlertIcon = function(bool){
       return bool ? "img/alert/alert_on.png" : "img/alert/alert_off.png"
    }

    // change function allows to relaod the "alerts options" of the user and sync them with the Back-end
    $scope.change = function(value){
        Option.setOption(storage.token, $scope.options).then(function(out){
            console.log(out);
        });
    }

    /* 3 - Navigation and Other functions */


    // trigger history return
    $scope.back = function(){
        window.history.go(-1);
    };

    // applianceChanged is used beforeEnter and to reload the card
    $scope.applianceChanged = function(event, data){

        // if problem with Google analytics
        //if(typeof analytics !== 'undefined') {analytics.trackView($ionicHistory.currentStateName());}
        if(typeof analytics !== 'undefined') {analytics.track("APP :" + $ionicHistory.currentStateName());}

        // Keyboard problem for iOS
        window.removeEventListener('native.keyboardshow', kSFTrue);
        window.removeEventListener('native.keyboardhide', kSFFalse);
        window.addEventListener('native.keyboardshow', kSFTrue);
        window.addEventListener('native.keyboardhide', kSFFalse);

        storage.print_target = false;
        //defineGraph();
        $scope.initializeValues();
        hasBeenSeen();

        Option.getOption(storage.token).then(function(out){
            $scope.options = out;
            $timeout(function(){
                //defineGraph();
                //restoreData();
            }, 100);
          });
    }

    // Keyboard Problem iOS
    $scope.keyboardOpen = false;
    var keyboardShowFeedback = function(open){
        if(ionic.Platform.isIOS()){
            $timeout(function(){
                $scope.keyboardOpen = open;
            }, 20);
        };
    };
    var kSFTrue = function(){keyboardShowFeedback(true);};
    var kSFFalse = function(){keyboardShowFeedback(false);};

    // These 3 lines are the ones triggered when opening the card
    $scope.$on("$ionicView.beforeEnter", $scope.applianceChanged);
    $scope.$on("applianceChanged", $scope.applianceChanged);
    $scope.$on("$ionicView.afterEnter",function(){
        //if(typeof analytics !== 'undefined') { analytics.trackView($ionicHistory.currentStateName()); }
        if(typeof analytics !== 'undefined') {analytics.track("APP :" + $ionicHistory.currentStateName());}
    });

    // Send Feedback and resert it
    $scope.sendFeedback = function(event){
        if($scope.feedbackCard.value != ""){
            data = {
                'alertId': $scope.alertCard.id,
                'alertName': $scope.alertCard.db_name,
                'alertTypeId': $scope.alertCard.type,
                'feedback': $scope.feedbackCard.value
            };
            Feedback.sendFeedback(storage.token, data).then(function(out){
                if(out == 0){
                    $cordovaDialogs.alert($translate.instant('PROBLEM FEEDBACK MESSAGE'), $translate.instant('PROBLEM FEEDBACK TITLE'), "OK");
                }else{
                    $scope.feedbackCard.value = "";
                    $cordovaDialogs.alert($translate.instant('THANKS FEEDBACK MESSAGE'), $translate.instant('THANKS FEEDBACK TITLE'), "OK");
                }

            });
        };
    };

    $scope.resetFeedback = function(){
        $scope.feedbackCard.value = "";
    };

    // Go to the applince card option
    $scope.goToApplianceCard = function(){
        storage.currentCard = $scope.alertCard.appliance;
        $state.go('myLuko.appliance');
    };


    // hasBeenSeen function serves to tell set the alert as Seen
    var hasBeenSeen = function(){
      data = {
        'id' : $scope.alertCard.id,
        'seen' : true,
        'validate' : $scope.alertCard.validate,
        'deleted' : false,
      };
      if (typeof(data) != "undefined"){
        Globales.setAlerts(storage.token, data).then(function(out){
          if(out == 0){
							$cordovaDialogs.alert($translate.instant('ERRORFROMOURSERVER'), $translate.instant('SORRY'))
					}
				});
      }
    }

    // hoursminutes form
    $scope.hoursminutes = function(elem){
    	var f = new Date();
    	f.setTime(Date.parse(elem+"Z"));
    	return(("0" + f.getHours()).slice(-2)+":"+("0" + f.getMinutes()).slice(-2));
    }

    /* 4 - Init values  */

    $scope.initializeValues = function(){

      var old2new = function(old){
          newID = [3103, 3130, 3131, 3106, 3301, 4601, 3203, 3230, 3231, 3206, 4807, 2001]
          return newID[old-1];
      }

      try {
          downData = JSON.parse(storage.alertData);
          console.log("alertData parsed");
          console.log(JSON.stringify(downData))
      }
      catch(err) {
          downData = 0;
          console.log("alertData parsed ERROR");
      }
      if (downData.img == undefined)
      {
        if(downData.alert_type_id<999){
            downData.alert_type_id = old2new(downData.alert_type_id);
        }
        if(downData.alert_type_id>2999){
            downData.img = (Math.floor(downData.alert_type_id/100)*100) + "_01";
        }
        else{
            downData.img = downData.alert_type_id + "_01";
        }
      }
      $scope.cardHeaderIcon = "picto/".concat(downData.img).concat(".png");
      $scope.cardGreyIcon = "picto/".concat(downData.img).slice(0, -1).concat("2.png");


      if (downData.validate == 0)
        $scope.validCheckIcon = "img/consumption/questionMark.png";
      else if (downData.validate == 1)
        $scope.validCheckIcon = "img/consumption/validateGreen.png";
      else if (downData.validate == 2)
        $scope.validCheckIcon = "img/consumption/noValidateRed.png";

      alert = {
        'id' : downData.id,
        'name' : downData.name,
        'db_name' : downData.db_name,
        'info' : downData.info,
        'type' : downData.alert_type_id,
        'dateCreated' : downData.datecreated,
        'appliance' :  downData.appliance,
        'message' : downData.message,
        'validate' : downData.validate,
         model : function(value){
            if (angular.isDefined(value)) {
                $scope.options[downData.db_name] = value;
                $scope.change();
            }else{
               return $scope.options[downData.db_name];
            };
        },
      }
      $scope.alertCard = alert;

      try {
        allAlerts = JSON.parse(storage.consumptionData);
        allOtherAlerts = allAlerts.data[alert.appliance].notifications.notifications;
      }
      catch(err) {
        allOtherAlerts = 0;
        console.log("allApplianceAlerts parsed ERROR" + JSON.stringify(err));
      }
      $scope.alerts = [];
      for (var i = 0; i < allOtherAlerts.length; i++){
        if (allOtherAlerts[i].name != downData.db_name){
          alert = allOtherAlerts[i]
          alertItem = {
              id: i,
              get title (){return allOtherAlerts[this.id].title;},
              model: function(value){
                  if (angular.isDefined(value)) {
                      $scope.options[allOtherAlerts[this.id].name] = value;
                      $scope.change();
                  }else{
                     return $scope.options[allOtherAlerts[this.id].name];
                  };
              },
              get has_explanation (){return allOtherAlerts[this.id].has_explanation;},
              get explanation (){return allOtherAlerts[this.id].explanation;}
          };

          $scope.alerts.push(alertItem);
          };
        }

      // Feedback
      $scope.feedbackCard = {
        'defaultValue' : '',
        'value' : '',
      }

      // Show sections Alert me, other alerts and go to appliance
      $scope.showOtherAlerts = function (){
        return (allOtherAlerts.length != 0 && allOtherAlerts.length != undefined) ? true : false;
      };
      $scope.showGoApplianceCard = function(){
        return ($scope.alertCard.appliance != undefined && $scope.alertCard.appliance != "") ? true : false;
      };
      $scope.showAlertMe = function(){
        return ($scope.alertCard.appliance != undefined && $scope.alertCard.appliance != "") ? true : false;
      };
    }
}])
