angular.module('app.controllers')

.controller('alertsCtrl', ['$scope', '$stateParams','Globales', '$state', '$ionicHistory', '$translate', 'Saving','segment',// The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, Globales, $state, $ionicHistory, $translate, Saving, segment) {
    var analytics = segment;
    $scope.data = {
        alerts: [],
        spacerDay: [],
        spacerDayText: [],
        validCheck: [],
    };

    var icon_color = 1; //Red

    $scope.showCards = true;
    var storage = window.localStorage;

    var onloadFunction = function(){
        $scope.showCards = true;
        Globales.getAlerts(storage.token).then(function(out){
            if(out == 0){
                try {
                    window.plugins.toast.showLongBottom($translate.instant("NOINTERNET"))
                } catch(err) {
                }
            }
            else{
                console.log("alerts download")
                storage.alertsData = JSON.stringify(out.data)
                Saving.save();
                var alertsData = out.data;
                addPowerfullInfo(alertsData);
                $scope.data.alerts = alertsData;
                if($scope.data.alerts.length > 0){$scope.showCards = true;}
                else{$scope.showCards = false;}
                //console.log(out.data);
            }
        });

        if("alertsData" in storage){
            try {
                //console.log(storage.alertsData);
                var alertsData = JSON.parse(storage.alertsData);
                console.log("data parsed")
            }
            catch(err) {
                var alertsData = 0;
                console.log("data error")
            }
            if(alertsData!=0){
                addPowerfullInfo(alertsData);
                $scope.data.alerts = alertsData;
            }
        }

        if($scope.data.alerts.length > 0){
            $scope.showCards = true;
        }
        else{
            $scope.showCards = false;
        }
    };

    $scope.$on("$ionicView.beforeEnter",function(){
        //if(typeof analytics !== 'undefined') { analytics.trackView($ionicHistory.currentStateName()); }
        if(typeof analytics !== 'undefined') {analytics.track("APP :" + $ionicHistory.currentStateName());}
        onloadFunction();
    });

    var old2new = function(old){
        newID = [3103, 3130, 3131, 3106, 3301, 4601, 3203, 3230, 3231, 3206, 4807, 2001]
        return newID[old-1];
    }


    function addPowerfullInfo(dataAlerts){
        var today = new Date();
        today = new Date(today.getFullYear(), today.getMonth(), today.getDate());
        var lastDiff = 0;
        //console.log(today);

        for (var alert2 of dataAlerts){
            console.log(alert2);
            //Set dateSpacer
            if(alert2.alert_type_id<999){
                alert2.alert_type_id = old2new(alert2.alert_type_id);
            }
            alert2.name = $translate.instant("A"+alert2.alert_type_id)
            if(alert2.alert_type_id>2999){
                alert2.img = (Math.floor(alert2.alert_type_id/100)*100) + "_0" + icon_color;
            }
            else{
                alert2.img = alert2.alert_type_id + "_0" + icon_color;
            }
            var f = new Date();
            f.setTime(Date.parse(alert2.datecreated));
            f = new Date(f.getFullYear(), f.getMonth(), f.getDate());
            var dayDiff = Math.round((today-f)/(1000*60*60*24));
            if(dayDiff>lastDiff){
                $scope.data.spacerDay[alert2.id] = false;
                lastDiff = dayDiff;
                var text = "";

                var monthNames = ["JANUARY", "FEBRUARY", "MARCH", "APRIL", "MAY", "JUNE",
                    "JULY", "AUGUST", "SEPTEMBER", "OCTOBER", "NOVEMBER", "DECEMBER"
                ];

                if(dayDiff==1){
                    text = $translate.instant("YESTERDAY");
                }
                else{
                    if($translate.instant("INVERTED")=="false"){
                        text = $translate.instant("AGO") + " " + dayDiff + " " + $translate.instant("DAYS");
                        text = text + " - "  + f.getDate() + " " + $translate.instant(monthNames[f.getMonth()])
                    }
                    else{
                        text = dayDiff + " " + $translate.instant("DAYS") + "  " + $translate.instant("AGO");
                        text = text + " - " + $translate.instant(monthNames[f.getMonth()]) + " " + f.getDate();
                    }
                }

                $scope.data.spacerDayText[alert2.id] = text;
            }
            else{
                $scope.data.spacerDay[alert2.id] = true;
                $scope.data.spacerDayText[alert2.id] = "";
            }

            //Set checkColor
            if (alert2.validate == 0){
                $scope.data.validCheck[alert2.id]="{}"
            }
            else if (alert2.validate==1){
                $scope.data.validCheck[alert2.id]='{"color":"#48d2a0"}';
            }
            else{
                $scope.data.validCheck[alert2.id]='{"color":"#e24f4f"}';
            }
        }

        //console.log($scope.data.spacerDay);
        //console.log($scope.data.spacerDayText);
        //console.log($scope.data.validCheck);

    }

    $scope.daySpacert = function(id){
        var text = id;
        var model = '<ion-list><ion-item class="item-divider">' + text + '</ion-item></ion-list>';
        return model;
    }

    $scope.hoursminutes = function(elem){
        var f = new Date();
        f.setTime(Date.parse(elem+"Z"));
        return(("0" + f.getHours()).slice(-2)+":"+("0" + f.getMinutes()).slice(-2));
    }

    $scope.durationFormat = function(elem){
        if(elem==null){
            return
        }
        hours = Math.floor(elem/3600);
        minutes = Math.floor(elem/60)%60;
        seconde = elem%60;
        if(hours==0){
            if (minutes==0){
                if (seconde==0){
                    return;
                }
                else{
                    return(seconde+"sec")
                }
            }
            else{
                return(minutes+"min "+("0" + seconde).slice(-2)+"sec")
            }
        }
        else{
            return(hours+"h "+("0" + minutes).slice(-2)+"min")
        }
    }

    $scope.remove = function(alert){
        alert.deleted = true;
        Globales.setAlerts(storage.token,alert).then(function(out){
            if(out == 0){
                $cordovaDialogs.alert($translate.instant('ERRORFROMOURSERVER'), $translate.instant('SORRY')).then(function(){
                    storage.removeItem('token');
                    Saving.save();
                    $state.go('login');
                });
            }
            else{
                addPowerfullInfo(out.data);
                $scope.data.alerts = out.data;
            }
        });
        $scope.data.alerts = $scope.data.alerts.filter(function(el) {return el.id !== alert.id;});
    }

    $scope.nomore = function(alert){
        Globales.noMore(storage.token,alert).then(function(out){
            //console.log(out);
        });
        $scope.remove(alert);
    }

    $scope.getValidationIcon = function (validate){
        if (validate == 0)
            return "img/consumption/questionMark.png";
        else if (validate == 1)
            return "img/consumption/validateGreen.png";
        else if (validate == 2)
            return "img/consumption/noValidateRed.png";
    }



    $scope.goToAlertCard = function(alertData){
        storage.alertData = JSON.stringify(alertData);
        $state.go('myLuko.alertCard');
    };

    $scope.changeValidationCard = function(alert){
      if(alert.validate == 0 || alert.validate == 2){
        data = {
          'id' : alert.id,
          'seen' : true,
          'validate' : 1,
          'deleted' : false,
        };
        for (var i=0 ; i < $scope.data.alerts.length ; i++) {
            if ($scope.data.alerts[i].id == alert.id){
                $scope.data.alerts[i].validate = 1;
            }
        }
      }
      else if (alert.validate == 1){        
        data = {
          'id' : alert.id,
          'seen' : true,
          'validate' : 2,
          'deleted' : false,
        };
        for (var i=0 ; i < $scope.data.alerts.length ; i++) {
            if ($scope.data.alerts[i].id == alert.id){
                $scope.data.alerts[i].validate = 2;
            }
        }
      }
      if(typeof(data) != "undefined"){
          Globales.setAlerts(storage.token, data).then(function(out){
              console.log(out);
          });
        }
    }



}])