angular.module('app.controllers')

.controller('applianceCtrl', ['$scope', '$rootScope', '$stateParams', '$ionicPopup', 'Globales', '$state', '$timeout', '$ionicHistory', 'Option', 
'$translate', 'Price', 'Saving', 'Feedback', 'Advice', '$cordovaDialogs', '$cordovaInAppBrowser', 'ngProgressFactory', 'segment', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller

// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $rootScope, $stateParams, $ionicPopup, Globales, $state, $timeout, $ionicHistory, Option, 
    $translate, Price, Saving, Feedback, Advice, $cordovaDialogs, $cordovaInAppBrowser, ngProgressFactory, segment) {
    var analytics = segment;
    var storage = window.localStorage;
    try {
        $scope.options = JSON.parse(storage.options);
        $scope.advice = JSON.parse(storage.advice);
        $scope.contractInfo = storage.contractInfo;
    } catch(err){
        console.log("No storage options or design to show")
        $scope.options = {};
        $scope.advice = {};
    }


    // start Graph variables
    var ctx;
    var dataGraph;
    var barData;
    var myChart;
    var optionBar;

    var todayApplianceGraph = Array.apply(null, Array(24)).map(Number.prototype.valueOf,0);
    var weekApplianceGraph = Array.apply(null, Array(7)).map(Number.prototype.valueOf,0);
    var monthApplianceGraph = Array.apply(null, Array(31)).map(Number.prototype.valueOf,0);
    var yearApplianceGraph = Array.apply(null, Array(12)).map(Number.prototype.valueOf,0);

    $scope.feedback_send=false;


    // change function allows to relaod the "alerts options" of the user and sync them with the Back-end
    $scope.change = function(value){
        Option.setOption(storage.token, $scope.options).then(function(out){
            console.log(out);
        });
    }

    $scope.validateAdvice = function(advice_id){
        for(var i=0; i<$scope.advice_list.length; i++){
            if($scope.advice_list[i].advice_id == advice_id){
                if($scope.advice_list[i].rightIconId == "consumption/validateGrey.png"){
                    $scope.advice_list[i].rightIconId = "consumption/validateGreen.png";
                    data = {
                        "advice_id": advice_id,
                        "validate": true
                    };
                }else if($scope.advice_list[i].rightIconId == "consumption/validateGreen.png"){
                    $scope.advice_list[i].rightIconId = "consumption/validateGrey.png";
                    data = {
                        "advice_id": advice_id,
                        "validate": false
                    };
                };
                if(typeof(data) != "undefined"){
                    Advice.setAdvice(storage.token, data).then(function(out){
                        console.log(out);
                    });
                };
            };
        };
    };

    // triggers browser history return
    $scope.back = function(){
        window.history.go(-1);
    };

    $scope.applianceChanged = function(event, data){
        window.removeEventListener('native.keyboardshow', kSFTrue);
        window.removeEventListener('native.keyboardhide', kSFFalse);
        window.addEventListener('native.keyboardshow', kSFTrue);
        window.addEventListener('native.keyboardhide', kSFFalse);
        if(typeof intercom !== 'undefined') { intercom.registerIdentifiedUser({email: storage.Email}); }

        storage.print_target = false;
        defineGraphVariables();

        Globales.getContract().then(function(resp){
            if (resp != 0) {
                    if (resp.contract.firm) {
                        storage.contractInfo = $translate.instant("CONTRACTSET");
                    } else {
                        storage.contractInfo = $translate.instant("PLEASE SET CONTRACT");
                    }
                    
            } else {
                try {
                    if (storage.contractInfo) {} //If contractInfo is set, jump to next task
                } catch(err) {
                    storage.contractInfo = $translate.instant("PLEASE SET CONTRACT");
                }  
            }
            $scope.contractInfo = storage.contractInfo;
            Saving.save(null);
           }, function(){ 
            storage.contractInfo = $translate.instant("PLEASE SET CONTRACT");
            Saving.save(null);
            $scope.contractInfo = storage.contractInfo ;
        });
        Option.getOption(storage.token).then(function(out){
            if (out != 0) {
                storage.options = JSON.stringify(out);
            }
            try {
                $scope.options = JSON.parse(storage.options);
            } catch(err) {
                $scope.options = {};
            }
            Advice.getAdvice(storage.token).then(function(out){
                if (out != 0) {
                    storage.advice = JSON.stringify(out);
                    Saving.save(null);
                }
                try {
                    $scope.advice = JSON.parse(storage.advice);  
                } catch(err) {
                    $scope.advice = {};
                }
                           
                $scope.initializeValues();
                //if(typeof analytics !== 'undefined') {analytics.trackView($ionicHistory.currentStateName());}
                if(typeof analytics !== 'undefined') {analytics.track("APP :" + $ionicHistory.currentStateName()  +":"+ storage.currentCard);}
                $timeout(function(){
                    if(storage.currentCard == "activity"){
                        $scope.toggleTime(0);
                    }else{
                        $scope.toggleTime(1);
                    }
                    restoreData();
                }, 100);
            });
        });
    }

    $scope.goToSurvey = function(){
        var options = {
            location: 'yes',
            clearcache: 'yes'
        };
        $cordovaInAppBrowser.open('https://luko.typeform.com/to/VPggG4','_blank', options);
    };

    var exitEventAlreadyTriggered = false;

    $scope.onBrowserExit = function(event){
        $timeout(function() {
            if(exitEventAlreadyTriggered){return;};
            exitEventAlreadyTriggered = true;
            /*$cordovaDialogs.alert($translate.instant('THANKS SURVEY MESSAGE'), $translate.instant('THANKS SURVEY TITLE'), "OK")
            .then(function(){
                $timeout(function() {
                    lang = $translate.use();
                    Globales.getPower3(storage.token, lang).then(function(downData){
                        if(downData.success){
                            storage.consumptionData = JSON.stringify(downData);
                            storage.consumptionTime = Math.floor(Date.now() / 1000);
                        };
                        $state.transitionTo($state.current, $stateParams, { reload: true, inherit: false, notify: true });
                    });
                }, 10000);
            });*/
        }, 500);
    };

    $scope.keyboardOpen = false;
    var keyboardShowFeedback = function(open){
        if(ionic.Platform.isIOS()){
            $timeout(function(){
                $scope.keyboardOpen = open;
            }, 20);
        };
    };
    var kSFTrue = function(){keyboardShowFeedback(true);};
    var kSFFalse = function(){keyboardShowFeedback(false);};

    $scope.$on("$ionicView.beforeEnter", $scope.applianceChanged);
    $scope.$on("applianceChanged", $scope.applianceChanged);

    $scope.$on("$ionicView.afterEnter",function(){
        //if(typeof analytics !== 'undefined') { analytics.trackView($ionicHistory.currentStateName()); }
        if(typeof analytics !== 'undefined') {analytics.track("APP :" + $ionicHistory.currentStateName() +":"+ storage.currentCard);}
        $scope.feedback_send=false;
        $scope.feedback_picto = 'img/global/heart_feedback.png'
    });

    $rootScope.$on('$cordovaInAppBrowser:exit', $scope.onBrowserExit);

    var findMatchingDiv = function(id) {
        return function(element) {
            return element.id == id;
        }
    }

// initializeValues : defines the values seted and de sections of the Cards

    $scope.initializeValues = function(){

        try {
            downData = JSON.parse(storage.consumptionData);
            console.log("init data parsed");
            console.log("init downdata = ");
            console.log(downData);
        }
        catch(err) {
            downData=0;
            console.log("init data error")
        }
        $scope.feedback_send=false;

        $scope.showAdviceCard = true;
        $scope.showFiguresCard = true;
        $scope.showAlertsCard = true;
        $scope.showTimelineCard = true;
        $scope.showGraphCard = true;
        $scope.showTodayGraph = false;

        $scope.showNotificationsCard = false;
        $scope.showContractCard = false;
        $scope.showTargetCard = false;
        $scope.showTarifCard = false;
        $scope.showSetContractCard = false;
        $scope.showDiagnosticCard = true;
        $scope.showFeedbackCard = true;

        $scope.isCoach = storage.currentCard == "coach";
        var toSortDivs = document.getElementById("contentCards").children;
        toSortDivs = Array.prototype.slice.call(toSortDivs, 0);
        var sortedDivs = [];
        var contentCards = [];

        if(storage.currentCard == "coach"){
            $scope.showFiguresCard = false;
            $scope.showAlertsCard = false;
            $scope.showTimelineCard = false;
            $scope.showGraphCard = false;
            if ($scope.more_feature) {
                $scope.showInfoZone = true;
                contentCards = ["diagnosticCard", "CTACard", "adviceCard", "figuresCard", "timelineCard", "alertsCard", "graphCard"];
            } else {
                $scope.waitingCoachZone = true;
                contentCards = ["waitingCoachCar"];
            }
        }else if(storage.currentCard == "activity"){
            $scope.showInfoZone = false;
            $scope.showTodayGraph = true;
            contentCards = ["diagnosticCard", "figuresCard", "timelineCard", "alertsCard", "graphCard"];
        }else if(storage.currentCard == "always_on"){
            $scope.showInfoZone = true;
            contentCards = ["diagnosticCard", "adviceCard", "graphCard"];
        }else if(storage.currentCard == "fridge" | storage.currentCard == "cooking"){
            $scope.showInfoZone = true;
            contentCards = ["diagnosticCard", "figuresCard", "graphCard", "alertsCard"];
            year_consumption = downData.data[storage.currentCard].year_consumption
            total_consumption = 0
            for(var i=0; i<year_consumption.length; i++){total_consumption = total_consumption + year_consumption[i]};
            $scope.showFiguresCard = total_consumption>0
            $scope.showAlertsCard = total_consumption>0
            $scope.showGraphCard = total_consumption>0
        }else if(storage.currentCard == "waterheater" | storage.currentCard == "electric_heater" | storage.currentCard == "electric_car"){
            $scope.showInfoZone = true;
            contentCards = ["diagnosticCard", "figuresCard", "graphCard", "alertsCard", "timelineCard"];
            year_consumption = downData.data[storage.currentCard].year_consumption
            total_consumption = 0
            for(var i=0; i<year_consumption.length; i++){total_consumption = total_consumption + year_consumption[i]};
            $scope.showFiguresCard = total_consumption>0
            $scope.showAlertsCard = total_consumption>0
            $scope.showGraphCard = total_consumption>0
        }else if(storage.currentCard == "other"){
            $scope.showInfoZone = false;
            $scope.showGraphCard = false;
            contentCards = ["diagnosticCard", "graphCard"];
        }else if(storage.currentCard == "myTarget"){
            $scope.showInfoZone = true;
            $scope.showGraphCard = false;
            $scope.showNotificationsCard = true;
            $scope.showAlertsCard = true;
            $scope.showContractCard = true;
            $scope.showTargetCard = true;
            contentCards = ["diagnosticCard", "authorizeNotificationsCard", "alertsCard", "setContractCard", "targetCard", "graphCard"];
        }else if(storage.currentCard == "contract"){
            $scope.showInfoZone = true;
            $scope.showGraphCard = false;
            $scope.showDiagnosticCard = false;
            $scope.showSetContractCard = true;
            contentCards = ["figuresCard", "contractTariffsCard", "setMyContractButtonCard", "graphCard"];
        }else if(storage.currentCard == "max_power"){
            $scope.showInfoZone = false;
            $scope.showGraphCard = false;
            contentCards = ["diagnosticCard", "figuresCard", "graphCard"];
        }

        for(var i = 0; i < contentCards.length; i++) {
            sortedDivs.push(toSortDivs.find(findMatchingDiv(contentCards[i])));
        }
        sortedDivs.push(toSortDivs.find(findMatchingDiv("feedbackCard")));

        var parent = document.getElementById("contentCards");
        parent.innerHTML = "";

        for(var i = 0; i < sortedDivs.length; i++) {
            parent.appendChild(sortedDivs[i]);
        }
        console.log("storage current card : " + storage.currentCard);
        $scope.cardTitle = downData.data[storage.currentCard].cardTitle;
        $scope.cardHeaderIcon = downData.data[storage.currentCard].cardHeaderIcon;

        // Xmas hack
        if((storage.currentCard == "coach")&&(time > Date.parse("2017-12-18"))&&(time < Date.parse("2018-01-07"))){
            $scope.cardHeaderIcon = "consumption/coachXmas.png"
        }

        $scope.infos = downData.data[storage.currentCard].infos; // Les deux chiffres a droite du titre

        $scope.diagnosticCard = downData.data[storage.currentCard].diagnostic; // Details
        $scope.full_diagnostic = $scope.diagnosticCard.ribbon ? "reducedDiagnosticText" : "fullDiagnosticText" // Pour alert faire full
        $scope.CTACard = downData.data[storage.currentCard].call_to_action;
        $scope.showCTACard = $scope.CTACard.display;

        $scope.alertsTitle = downData.data[storage.currentCard].notifications.alertsTitle; // Le titre de la Section Alerts
        alerts = downData.data[storage.currentCard].notifications.notifications; // Json avec les data titre et reff dans la DB
        $scope.alerts = [];
        for(var i = 0; i < alerts.length; i++){
            alert = alerts[i]
            alertItem = {
                id: i,
                get title (){return alerts[this.id].title;},
                model: function(value){
                    if (angular.isDefined(value)) { // update du toggle, qui permet d eupdate la value
                        $scope.options[alerts[this.id].name] = value;
                        $scope.change();
                    }else{
                        return $scope.options[alerts[this.id].name]; //ouverture de la page
                    };
                },
                get has_explanation (){return alerts[this.id].has_explanation;},
                get explanation (){return alerts[this.id].explanation;}
            };
            $scope.alerts.push(alertItem);
        };
        if($scope.alerts.length == 0){
            $scope.showAlertsCard = false;
        }
        // Tableau de chiffres (ex: average usage)
        $scope.figuresTitle = downData.data[storage.currentCard].figures.figuresTitle
        $scope.figures = downData.data[storage.currentCard].figures.figures
        for(var i=0; i<$scope.figures.length; i++){
            if($scope.figures[i].value == "ON" | $scope.figures[i].value == "ACTIVE"| $scope.figures[i].value == "ACTIF"){
                $scope.figures[i].style = "figureGreenRightText";
            }else if($scope.figures[i].value == "OFF" | $scope.figures[i].value == "INACTIVE"| $scope.figures[i].value == "INACTIF"){
                if(storage.currentCard == "fridge"){
                    $scope.figures[i].style = "figureRedRightText";
                }else{
                    $scope.figures[i].style = "figureGreyRightText";
                };
            }else{
                $scope.figures[i].style = "figureRightText";
            };
        };
        if($scope.figures.length == 0){
            $scope.showFiguresCard = false;
        }

        $scope.adviceCard = {
            title: downData.data[storage.currentCard].advice.title,
            message: downData.data[storage.currentCard].advice.advice_description
        }
        $scope.advice_list = downData.data[storage.currentCard].advice.advice;

        for(var i=0; i<$scope.advice_list.length; i++){
            if($scope.advice_list[i].validatable){
                current_advice = $scope.advice.filter(function(item){
                        return item.advice_id == $scope.advice_list[i].advice_id;
                    }
                    )
                if(current_advice.length > 0){
                    validate = current_advice[0].validate
                    $scope.advice_list[i].rightIconId = validate ? "consumption/validateGreen.png" : "consumption/validateGrey.png";
                }else{
                    $scope.advice_list[i].rightIconId = "consumption/validateGrey.png";
                }
            };
        };
        if($scope.advice_list.length == 0){
            $scope.showAdviceCard = false;
        }
        $scope.timelineTitle = downData.data[storage.currentCard].timeline.title
        $scope.timeline_events = downData.data[storage.currentCard].timeline.events
        for(var i=0; i<$scope.timeline_events.length; i++){
            $scope.timeline_events[i].style = $scope.timeline_events[i].isEvent ? "figure-line" : "period-line";
            $scope.timeline_events[i].leftBarStyle = $scope.timeline_events[i].activity ? "greenSideBarLeft" : "greySideBarLeft";
            if(i>0){
                if(!$scope.timeline_events[i-1].isEvent){
                    $scope.timeline_events[i].leftBarStyle += " roundTopSideBar";
                };
            };
            if(i<$scope.timeline_events.length-1){
                if(!$scope.timeline_events[i+1].isEvent){
                    $scope.timeline_events[i].leftBarStyle += " roundBottomSideBar";
                };
            };
            if(i == $scope.timeline_events.length-1){
                $scope.timeline_events[i].leftBarStyle += " roundBottomSideBar";
            }
        };

        $scope.contractTariffsCard = {
            "leftTitle": downData.data[storage.currentCard].contract_tariffs.leftTitle,
            "rightTitle": downData.data[storage.currentCard].contract_tariffs.rightTitle
        };
        $scope.tariffPeriods = downData.data[storage.currentCard].contract_tariffs.tariffPeriods;

        $scope.feedbackCard = downData.data[storage.currentCard].feedback;
        $scope.targetCard = downData.data[storage.currentCard].target;
        $scope.targetCard.value = $scope.options.consumption_active ? $scope.options.consumption_limit : "";
        if(storage.currentCard == "myTarget" & !$scope.options.consumption_period_year){
            $scope.targetCard.value = Math.round($scope.targetCard.value / 12);
            var currencies = ["€", "$", "£"];
            var current_target = $scope.infos[0].value;
            var current_proj = $scope.infos[1].value;
            if(currencies.indexOf(current_target.substring(0, 1)) != -1){
                $scope.infos[0].value = current_target.substring(0, 1) + Math.round(parseInt(current_target.substring(1)) / 12).toString();
                $scope.infos[1].value = current_proj.substring(0, 1) + Math.round(parseInt(current_proj.substring(1)) / 12).toString();
            }else{
                $scope.infos[0].value = Math.round(parseInt(current_target.substring(0, current_target.length-1)) / 12).toString() + current_target.substring(current_target.length-1);
                $scope.infos[1].value = oaMath.round(parseInt(current_proj.substring(0, current_proj.length-1)) / 12).toString() + current_proj.substring(current_proj.length-1);
            };
        }
        $scope.targetCard.styleYear = $scope.options.consumption_period_year ? "contentOnText": "contentOffText";
        $scope.targetCard.styleMonth = $scope.options.consumption_period_year ? "contentOffText": "contentOnText";
        $scope.targetCard.period = $scope.options.consumption_period_year ? $translate.instant("YEAR") : $translate.instant("MONTH");
        $scope.targetCard.consumption_period_year = function(value){
            if (angular.isDefined(value)) {
                $scope.targetCard.styleYear = value ? "contentOnText": "contentOffText";
                $scope.targetCard.styleMonth = value ? "contentOffText": "contentOnText";
                var old_value = $scope.options.consumption_period_year;
                $scope.options.consumption_period_year = value;
                var currencies = ["€", "$", "£"];
                var current_target = $scope.infos[0].value;
                var current_proj = $scope.infos[1].value;
                if(value & !old_value){
                    $scope.targetCard.value = $scope.targetCard.value * 12;
                    $scope.targetCard.period = $translate.instant("YEAR");
                    if(currencies.indexOf(current_target.substring(0, 1)) != -1){
                        $scope.infos[0].value = current_target.substring(0, 1) + (parseInt(current_target.substring(1)) * 12).toString();
                        $scope.infos[1].value = current_proj.substring(0, 1) + (parseInt(current_proj.substring(1)) * 12).toString();
                    }else{
                        $scope.infos[0].value = (parseInt(current_target.substring(0, current_target.length-1)) * 12).toString() + current_target.substring(current_target.length-1);
                        $scope.infos[1].value = (parseInt(current_proj.substring(0, current_proj.length-1)) * 12).toString() + current_proj.substring(current_proj.length-1);
                    };
                }else if(old_value & !value){
                    $scope.targetCard.value = Math.round($scope.targetCard.value / 12);
                    $scope.targetCard.period = $translate.instant("MONTH");
                    if(currencies.indexOf(current_target.substring(0, 1)) != -1){
                        $scope.infos[0].value = current_target.substring(0, 1) + Math.round(parseInt(current_target.substring(1)) / 12).toString();
                        $scope.infos[1].value = current_proj.substring(0, 1) + Math.round(parseInt(current_proj.substring(1)) / 12).toString();
                    }else{
                        $scope.infos[0].value = Math.round(parseInt(current_target.substring(0, current_target.length-1)) / 12).toString() + current_target.substring(current_target.length-1);
                        $scope.infos[1].value = Math.round(parseInt(current_proj.substring(0, current_proj.length-1)) / 12).toString() + current_proj.substring(current_proj.length-1);
                    };
                };
                $scope.change();
            }else{
                return $scope.options.consumption_period_year;
            };
        }

        $scope.target_5_button = "TargetButtonGrey";
        $scope.target_10_button = "TargetButtonGrey";
        $scope.target_15_button = "TargetButtonGrey";

        if($scope.cardTitle == "Default"){
            $scope.setMyContractButton = $translate.instant("AUTOSETCONTRACT");
        }else{
            $scope.setMyContractButton = $translate.instant("UPDATECONTRACT");
        }

    }

// HERE STARTS GRAPHS

    $scope.toggleTime = function(id){
        $scope.time_selecter_Active_Class = ["","","","",""];
        $scope.timeActive = id;
        $scope.time_selecter_Active_Class[id] = "time-selected-white";
        if(storage.currentCard == "activity"){
            tooltipsUnits = "h";
        }else{
            tooltipsUnits = "Wh";
        }
        defineGraphVariables();
        createData(id);
    }

    var restoreData = function(){
        try {
            downData = JSON.parse(storage.consumptionData);
            console.log(" restore data parsed")
        }
        catch(err) {
            downData=0;
            console.log(" restore data error")
        }

        if(downData != 0){
            $timeout(function(){
                todayApplianceGraph = downData.data[storage.currentCard].hour_consumption_UTC;
                weekApplianceGraph = downData.data[storage.currentCard].week_consumption;
                monthApplianceGraph = downData.data[storage.currentCard].month_consumption;
                yearApplianceGraph = downData.data[storage.currentCard].year_consumption;

                if(storage.currentCard != "activity"){
                    weekApplianceGraph = weekApplianceGraph.map(function(x){return 1000 * x;});
                    monthApplianceGraph = monthApplianceGraph.map(function(x){return 1000 * x;});
                    yearApplianceGraph = yearApplianceGraph.map(function(x){return 1000 * x;});
                }

                createData($scope.timeActive);
            });
        }
    }

    var createData = function(id){
        if (id==0) {  //today
            var d = new Date();
            var fuseTime = d.getHours()-d.getUTCHours();
            dataGraph.datasets[0].data = [];
            for (i = 0; i < 24; i++){
                dataGraph.datasets[0].data[i] = todayApplianceGraph[(48+i+4-fuseTime)%24];
            }
            for (i = 0; i < 24; i++){
                if(i%2==0){
                    dataGraph.labels[i] = ((i+3)%24)+1;
                }
                else{
                    dataGraph.labels[i] = '';
                }
                var n = (24 + d.getHours()-4)%24;
                if(i<=n){
                    dataGraph.datasets[0].backgroundColor[i] = '#3a68c2';
                }
                else{
                    dataGraph.datasets[0].backgroundColor[i] = '#dedede';
                }
            }
        }
        else if (id == 1){ //week
            if($translate.use()==['fr-FR']){
                dataGraph.labels = ['L','M','M','J','V','S','D'];
            }
            else{
                dataGraph.labels = ['M','T','W','T','F','S','S'];
            }
            dataGraph.datasets[0].data = weekApplianceGraph
            for (i = 0; i < 7; i++){
                var d = new Date();
                var n = (d.getDay()+13)%7;  // n = 0 Monday : n=6 Sunday
                if(i<n){
                    if(i<5){
                        dataGraph.datasets[0].backgroundColor[i] = '#3a68c2';
                    }
                    else{
                        dataGraph.datasets[0].backgroundColor[i] = '#859CDE';
                    }
                }
                else{
                    if(i<5){
                        dataGraph.datasets[0].backgroundColor[i] = '#cccccc';
                    }
                    else{
                        dataGraph.datasets[0].backgroundColor[i] = '#dddddd';
                    }
                }
            }
        }
        else if (id == 2){ //month
            dataGraph.datasets[0].data = monthApplianceGraph;
            var d = new Date();
            var today = d.getDate();
            //This fonction create color and subtiltes for day d
            var dealDay = function(day){
                var i = day.getDate()-1
                week_day = (day.getDay()+13)%7;
                if(i%2==0){
                    dataGraph.labels[i] = i+1;
                }
                else{
                    dataGraph.labels[i] = '';
                }
                if(i<(today-1)){
                    if(week_day<5){
                        dataGraph.datasets[0].backgroundColor[i] = '#3a68c2';
                    }
                    else{
                        dataGraph.datasets[0].backgroundColor[i] = '#859CDE';
                    }
                }
                else{

                    if(week_day<5){
                        dataGraph.datasets[0].backgroundColor[i] = '#cccccc';
                    }
                    else{
                        dataGraph.datasets[0].backgroundColor[i] = '#dddddd';
                    }
                }
            }
            dealDay(d);
            d.setDate(d.getDate()-1);
            var n =d.getDate();

            //For each day, create that color
            while(n!=today){
                dealDay(d);
                d.setDate(d.getDate()-1);
                n =d.getDate();
            }
            if (dataGraph.labels.length==30){
                dataGraph.labels[30]='';
            }
        }
        else if (id == 3){ //year
            if($translate.use()==['fr-FR']){
                dataGraph.labels = ['J','F','M','A','M','J','J','A','S','O','N','D'];
            }
            else{
                dataGraph.labels = ['J','F','M','A','M','J','J','A','S','O','N','D'];
            }
            dataGraph.datasets[0].data = yearApplianceGraph;
            for (i = 0; i < 12; i++){
                var d = new Date();
                var n = d.getMonth();
                if(i<=n){
                    dataGraph.datasets[0].backgroundColor[i] = '#3a68c2';
                }
                else{
                    dataGraph.datasets[0].backgroundColor[i] = '#dedede';
                }
            }
        }
        myChart.update();
    }

    var barGraphMode = function(){
        optionBar = {
            tooltips: {
                enabled: $scope.timeActive > 0,
                intersect: false,
                backgroundColor: 'rgba(0,0,0,0.6)' ,
                displayColors: false,
                callbacks: {
                  label: function(tooltipItem, data) {
                    if(tooltipItem.yLabel <= 0){
                        throw ''
                    }
                    if(storage.currentCard != "activity"){
                        return [Price.formatLargeNumber(Math.round(tooltipItem.yLabel), 0) + ' ' + tooltipsUnits, Price.cur(Price.auto(tooltipItem.yLabel / 1000,0,0))]
                    }else{
                        return [Price.formatLargeNumber(Math.round(tooltipItem.yLabel), 0) + ' ' + tooltipsUnits]
                    }
                  },
                  title: function() {
                    return null;
                  }
                }
            },
            responsive: true,
            maintainAspectRatio: false,
            legend: {
                display: false,
                labels: {
                    padding: 0,
                }
            },
            layout:{
                padding: 10
            },
            scales: {
                xAxes: [{
                    gridLines: {
                        display: false
                    },
                    ticks: {
                        fontSize: 10,
                        maxRotation: 0,
                    }
                }],
                yAxes: [{
                    gridLines: {
                        display: false
                    },
                    gridLines: {
                        display: false,
                        lineWidth: 0,
                        drawTicks: false,
                        zeroLineWidth: 0,
                        drawBorder: false,
                    },
                    ticks: {
                        display: true,
                        fontSize: 12,
                        maxRotation: 0,
                        beginAtZero:true,
                        suggestedMax: storage.currentCard == "activity" ? 1 : 500,
                        mirror: true,
                        maxTicksLimit: 10,
                        callback: function (value, index, values) {
                            if(index==0){
                                return(Price.formatLargeNumber(value, 0) + (storage.currentCard == "activity" ? 'h' : 'W'));
                            }
                        }
                    }
                }]
            },
            zoom: {
                enabled: false
            },
            pan: {
                enabled: false
            }
        };

        dataGraph = {
            labels: [],
            datasets: [{
                    data: [],
                    backgroundColor: []
                }]
        };
        barData = {
            type: 'bar',
            data: dataGraph,
            options: optionBar
        };
    }

    var defineGraphVariables = function(){
        try{
            myChart.destroy();
        }catch(err){};
        ctx = document.getElementById("ApplianceChart");
        barGraphMode();
        myChart = new Chart(ctx, barData);
    }

    $scope.setContract = function(){
        storage.currentCard = "contract";
        $rootScope.$broadcast('applianceChanged');
        $state.reload()
    };

    $scope.goToAlertCard = function(alertData){
        storage.alertData = alertData;
        $state.go('myLuko.alertCard');
      };

    $scope.setAlertIcon = function(bool){
        var path = bool ? "alert_on" : "alert_off"
        return "img/alert/" + path + ".png"
    }


    $scope.setTarget = function(){
        if(isNaN(parseInt($scope.targetCard.value))){
            return;
        }
        $scope.options.consumption_active = true;
        if($scope.options.consumption_period_year){
            var new_target = $scope.targetCard.value;
        }else{
            var new_target = 12 * $scope.targetCard.value;
        }
        $scope.options.consumption_limit = new_target;
        $scope.change();
        var currencies = ["€", "$", "£"];
        if(currencies.indexOf($scope.infos[0].value.substring(0, 1)) != -1){
            $scope.infos[0].value = $scope.infos[0].value.substring(0, 1) + $scope.targetCard.value.toString();
            downData.data[storage.currentCard].infos[0].value = $scope.infos[0].value.substring(0, 1) + new_target.toString();
        }else{
            $scope.infos[0].value = $scope.targetCard.value.toString() + $scope.infos[0].value.substring($scope.infos[0].value.length-1);
            downData.data[storage.currentCard].infos[0].value =new_target.toString() + $scope.infos[0].value.substring($scope.infos[0].value.length-1)
        };
        storage.consumptionData = JSON.stringify(downData);
        storage.setup_target = true;
        $scope.setup_target = true;
        Saving.save(null);
    };

// HERE STOPS GRAPHS

    $scope.resetTarget = function(){
        $scope.options.consumption_active = false;
        $scope.options.consumption_limit = 0;
        $scope.targetCard.value = "";
        $scope.change();
        var currencies = ["€", "$", "£"];
        var current_target = $scope.infos[0].value;
        if(currencies.indexOf(current_target.substring(0, 1)) != -1){
            $scope.infos[0].value = current_target.substring(0, 1) + "0";
        }else{
            $scope.infos[0].value = "0" + current_target.substring(current_target.length-1);
        };
        downData.data[storage.currentCard].infos[0].value = $scope.infos[0].value;
        storage.consumptionData = JSON.stringify(downData);
    };

    $scope.reduceTarget = function(value){
        if(value == .05){
            $scope.target_5_button = "TargetButtonBlue";
            $scope.target_10_button = "TargetButtonGrey";
            $scope.target_15_button = "TargetButtonGrey";
        }else if(value == .10){
            $scope.target_5_button = "TargetButtonGrey";
            $scope.target_10_button = "TargetButtonBlue";
            $scope.target_15_button = "TargetButtonGrey";
        }else if(value == .15){
            $scope.target_5_button = "TargetButtonGrey";
            $scope.target_10_button = "TargetButtonGrey";
            $scope.target_15_button = "TargetButtonBlue";
        };
        var currencies = ["€", "$", "£"];
        var forecast = $scope.infos[1].value;
        if(currencies.indexOf(forecast.substring(0, 1)) != -1){
            var new_target = Math.round(parseInt(forecast.substring(1)) * (1 - value));
            $scope.infos[0].value = forecast.substring(0, 1) + new_target.toString();
        }else{
            var new_target = Math.round(parseInt(forecast.substring(0, forecast.length-1)) * (1 - value));
            $scope.infos[0].value = new_target.toString() + forecast.substring(forecast.length-1);
        };
        $scope.options.consumption_active = 1;
        if(!$scope.options.consumption_period_year){
            year_target = 12 * new_target;
        }else{
            year_target = new_target;
        };
        $scope.options.consumption_limit = year_target;
        $scope.targetCard.value = new_target;
        if(currencies.indexOf(forecast.substring(0, 1)) != -1){
            downData.data[storage.currentCard].infos[0].value = forecast.substring(0, 1) + year_target.toString();
        }else{
            downData.data[storage.currentCard].infos[0].value = year_target.toString() + forecast.substring(forecast.length-1);
        };
        storage.consumptionData = JSON.stringify(downData);
        $scope.change();
        storage.setup_target = true;
        $scope.setup_target = true;
        Saving.save(null);
    };

    appliancesId = {
        "activity": 2001,
        "contract": 2500,
        "max_power": 2700,
        "fridge": 3100,
        "electric_car": 3500,
        "other": 3700,
        "cooking": 4400,
        "always_on": 5300,
        "waterheater": 5700,
        "coach": "coach",
        "myTarget": "my_target",
        "electric_heater": 4200
        // Set alerts type applianceID
    }


    $scope.sendFeedback = function(event){
        if($scope.feedbackCard.value != ""){
            data = {
                "appliance": appliancesId[storage.currentCard],
                "feedback": $scope.feedbackCard.value
            };
            Feedback.sendFeedback(storage.token, data).then(function(out){
                $scope.feedback_send=true;
                if(out == 0){
                    $scope.feedback_css = {
                        'background-color': '#f3a82c',
                        opacity : 1
                    }
                    $scope.feedback_msg_1 = $translate.instant("PROBLEM FEEDBACK MESSAGE");
                    $scope.feedback_msg_2 = ""
                    $scope.feedback_msg_3 = ""
                    $scope.feedback_picto = 'img/global/error_feedback.png'
                    //$cordovaDialogs.alert($translate.instant('PROBLEM FEEDBACK MESSAGE'), $translate.instant('PROBLEM FEEDBACK TITLE'), "OK");
                }else{
                    $scope.feedback_css = {
                        'background-color': '#3ADCB3',
                        opacity : 1
                    }
                    $scope.feedbackCard.value = "";
                    $scope.feedback_msg_1 = $translate.instant("THANKS FEEDBACK TITLE");
                    $scope.feedback_msg_2 = $translate.instant("THANKS FEEDBACK MESSAGE 1");
                    $scope.feedback_msg_3 = $translate.instant("THANKS FEEDBACK MESSAGE 2");
                    $scope.feedback_picto = 'img/global/heart_feedback.png'
                    //$cordovaDialogs.alert($translate.instant('THANKS FEEDBACK MESSAGE'), $translate.instant('THANKS FEEDBACK TITLE'), "OK");
                }
                $(".feedbackSend").animate({"opacity": "1"}, 300);
                //$(".feedbackSend").addClass("transform-active");
                //$('.transform').toggleClass('transform-active');
            });

            try {
                intercom.logEvent("feedback_appliance", "test");
            } catch(err){
                try{window.plugins.toast.showLongBottom("intercom logEvent" + err)}catch(err){}
            }
        };
    };

    $scope.resetFeedback = function(){
        $scope.feedbackCard.value = "";
        $scope.feedback_css = {
            'background-color': 'transparent',
            opacity : 0
        }
        $scope.feedback_send = false;
    };

    $scope.autoset = function(){
        if(typeof analytics !== 'undefined') {analytics.track("APP :" + $ionicHistory.currentStateName()+":UPDATECONTRACT");}
        $cordovaDialogs.confirm($translate.instant("WEWILLSETYOURCONTRACT"), $translate.instant("MYCONTRACT"),  [$translate.instant("OK"),$translate.instant("CANCEL")]).then(function(data){
            if(data==1){
                setByPhoto();
            }
        });
    };

    $scope.progressbar = ngProgressFactory.createInstance();
    try{$scope.progressbar.setColor("#85D2A0");} catch(err){console.log(JSON.stringify(err));}

    var setByPhoto = function(){
        var optionCam = {
            quality: 50,
            destinationType: Camera.DestinationType.NATIVE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            saveToPhotoAlbum: false
        };
        if(ionic.Platform.isAndroid()){
            $cordovaDialogs.confirm($translate.instant("WANTDOYOUWANT"), "",  [$translate.instant("TAKEPICTURE"),$translate.instant("CHOOSEFILE")]).then(function(data){
                if(data==2){
                    fileChooser.open(function(uri){uploadURI(uri, true)}, function(){});
                }
                else if(data==1){
                    navigator.camera.getPicture(function(uri){uploadURI(uri, false)}, function(){},optionCam);
                }
                else{
                    return;
                }
            });
        }
        else{
            $cordovaDialogs.confirm($translate.instant("WANTDOYOUWANT"), "",  [$translate.instant("TAKEPICTURE"),$translate.instant("CHOOSEFILE")]).then(function(data){
                if(data==2){
                    optionCam.sourceType = Camera.PictureSourceType.PHOTOLIBRARY;
                    navigator.camera.getPicture(function(uri){uploadURI(uri, false)}, function(){},optionCam);
                }
                else if(data==1){
                    navigator.camera.getPicture(function(uri){uploadURI(uri, false)}, function(){},optionCam);
                }
                else{
                    return;
                }
            });
        }
    };

    var uploadURI = function(imageURI, fromFile){
        if(fromFile){
            var fileURL = imageURI[0];
            var fileName = imageURI[1];
        }
        else{
            var fileURL = imageURI;
            var fileName = fileURL.substr(fileURL.lastIndexOf('/') + 1);
        }
        console.log(fileURL);
        console.log(fileName);
        var authoriseExtension = ["txt", "pdf", "png", "jpg", "jpeg", "gif", "heic"];
        var authorizedFormat = false;
        for(var i=0; i<authoriseExtension.length; i++){
            if(fileName.toLowerCase().lastIndexOf(authoriseExtension[i])!=-1){
                authorizedFormat = true;
            }
        }
        if(!authorizedFormat){
             $cordovaDialogs.alert($translate.instant("ONLYTHISFILEAREALLOWED"), $translate.instant("FILETYPE"));
             return;
        }
        function win(r) {
            $scope.progressbar.complete();
            $cordovaDialogs.alert($translate.instant("WEWILLSETANDCONTACTYOUSOON"), $translate.instant("OK"));
        }
        function fail(error) {
            $scope.progressbar.reset();
            $cordovaDialogs.alert($translate.instant("ERRORUPLOADCONTRACT"), $translate.instant("OK"));
            console.log(error);
        }
        var uri = encodeURI("https://app.getluko.com/api/users/self/upload_contract");

        var options = new FileUploadOptions();
        options.fileKey = "files";
        options.fileName = fileName;
        if (fileURL.slice(-3).toLowerCase() === "pdf"){
          options.mimeType = "application/pdf";
        }
        else if (fileURL.slice(-3).toLowerCase() === "png"){
          options.mimeType = "image/png";
        }
        else if (fileURL.slice(-3).toLowerCase() === "txt"){
          options.mimeType = "text/plain";
        }
        else if (fileURL.slice(-3).toLowerCase() === "gif"){
          options.mimeType = "image/gif";
        }
        else {
        options.mimeType = "image/jpeg";
        }
        options.chunkedMode = false;

        var headers={'Authorization': 'jwt '+ storage.token};
        options.headers = headers;

        var ft = new FileTransfer();
        $scope.progressbar.start();
        $scope.progressbar.set(10);
        ft.onprogress = function(progressEvent) {
            console.log(progressEvent.loaded / progressEvent.total);
            $scope.progressbar.set(Math.floor(progressEvent.loaded / progressEvent.total * 100));
        };
        ft.upload(fileURL, uri, win, fail, options, true);
    };

}])
