angular.module('app.controllers')

.controller('homesettingsCtrl', ['$scope', '$stateParams', 'Globales', '$state', '$http', '$cordovaDialogs', '$ionicHistory', '$translate', 'Option', 
'Price', 'ngProgressFactory', 'segment', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, Globales, $state, $http, $cordovaDialogs, $ionicHistory, $translate, Option, 
    Price, ngProgressFactory, segment) {
    var analytics = segment;
    var storage = window.localStorage;

    $scope.zipcode = '';
    $scope.contract = {
        name: "",
        country: "",
        hour_dependant: false,
    };
    $scope.showTimeZone = false;
    $scope.timeZone = "";
    $scope.progressbar = ngProgressFactory.createInstance();
    try{$scope.progressbar.setColor("#85D2A0");} catch(err){console.log(JSON.stringify(err));}  

    var listCities = [];
    var config = {
        title: $translate.instant("SELECTYOURCITY"), 
        items: listCities,
        selectedValue: "",
        doneButtonLabel: "Ok",
        cancelButtonLabel: $translate.instant("CANCEL")
    };

    var downloadCities = function(){
        var listCities = [];
        Globales.lowCostTS($scope.contract.country,$scope.zipcode,0).then(function(data){
            for (var i=0; i<data.length; i++){
                console.log(data[i].City)
                listCities.push({text: data[i].City, value: data[i].id});
            }
            listCities.push({text: $translate.instant("OTHER"), value: 0});
            console.log(JSON.stringify(listCities));
            config.items = listCities;
        })
    }

    var onLoadFunct = function(){
        console.log("Home settings");
        var firstOut = false;
        Option.getOption(storage.token).then(function(data){
            //console.log(JSON.stringify(data));
            storage.option = data;
            $scope.zipcode = data.zip_code;
            $scope.timeZone = ts2string(data.low_cost_time);
            if(firstOut){downloadCities();}
            firstOut=true;
        });
        Globales.getContract().then(function(data){
            //storage.contract = JSON.stringify(data.contract);
            $scope.contract.name = data.contract.name;
            $scope.contract.country = data.contract.country;
            $scope.contract.hour_dependant = data.contract.hour_dependant;
            if ($scope.contract.hour_dependant){
                $scope.showTimeZone = true;
            }
            else{
                $scope.showTimeZone = false;
            }
            if(firstOut){downloadCities();}
            firstOut=true;
        });
    };

    $scope.$on("$ionicView.beforeEnter",onLoadFunct);

    $scope.back = function(){
        window.history.go(-1);
    };

    $scope.setContract = function(){
        $state.go('myLuko.setcontract');
    };

    $scope.autoset = function(){
        $cordovaDialogs.confirm($translate.instant("WEWILLSETYOURCONTRACT"), $translate.instant("MYCONTRACT"),  [$translate.instant("OK"),$translate.instant("CANCEL")]).then(function(data){
            if(data==1){
                setByPhoto();
            }
        });
    }

    $scope.setZIP = function(){
        $cordovaDialogs.prompt($translate.instant("ENTERYOURZIPCODE"),$translate.instant("MYZIPCODE") ,  [$translate.instant("OK"),$translate.instant("CANCEL")], '').then(function(data){
            if((data.buttonIndex==1)&&(data.input1.length>0)){
                Globales.setZIP(data.input1).then(function(){
                    onLoadFunct();
                })               
            }
        });
        
    }

    var ts2string = function(ts){
        tsp = JSON.parse(ts);
        console.log(ts)
        var out = "";
        if(!Array.isArray(tsp[0])){
            var trans  = [];
            trans[0] = tsp;
            tsp = JSON.parse(JSON.stringify(trans));
        }
        for(var j=0; j<tsp.length;j++){
            hourDeb = Math.floor(tsp[j][0]).toString();
            minutesDeb = Math.floor(((tsp[j][0]*60)%60)).toString();
            if(minutesDeb.length==1){minutesDeb = "0"+minutesDeb;}
            hourFin = Math.floor(tsp[j][1]).toString();
            minutesFin = Math.floor(((tsp[j][1]*60)%60)).toString();
            if(minutesFin.length==1){minutesFin = "0"+minutesFin;}
            out += "de " + hourDeb +"h" + minutesDeb + " à " + hourFin +"h" + minutesFin + ", ";
        }
        out = out.substring(0, out.length - 2);
        return(out)
    }
    
    var setTimeSlot = function(ts){
        Globales.setLowCostTS(ts).then(function(data){
            console.log(JSON.stringify(data));
            onLoadFunct()
        });
    }

    var timeSlotCreator = function(){
        $cordovaDialogs.confirm($translate.instant("WEDONTKNOWYOUCONTRACT"), $translate.instant("SORRY"),  [$translate.instant("OK"),$translate.instant("CANCEL")]).then(function(data){
            if(data==1){
                setByPhoto();
            }
        });
    }

    var uploadURI = function(imageURI, fromFile){
        if(fromFile){
            var fileURL = imageURI[0];
            var fileName = imageURI[1];
        }
        else{
            var fileURL = imageURI;
            var fileName = fileURL.substr(fileURL.lastIndexOf('/') + 1);
        }
        console.log(fileURL);
        console.log(fileName);
        var authoriseExtension = ["txt", "pdf", "png", "jpg", "jpeg", "gif", "heic"];
        var authorizedFormat = false;
        for(var i=0; i<authoriseExtension.length; i++){
            if(fileName.toLowerCase().lastIndexOf(authoriseExtension[i])!=-1){
                authorizedFormat = true;
            }
        }
        if(!authorizedFormat){
             $cordovaDialogs.alert($translate.instant("ONLYTHISFILEAREALLOWED"), $translate.instant("FILETYPE"));
             return;
        }
        function win(r) {
            $scope.progressbar.complete();
            $cordovaDialogs.alert($translate.instant("WEWILLSETANDCONTACTYOUSOON"), $translate.instant("OK"));
        }
        function fail(error) {
            $scope.progressbar.reset();
            $cordovaDialogs.alert($translate.instant("ERRORUPLOADIMAGE"), $translate.instant("OK"));
        }
        var uri = encodeURI("https://app.getluko.com/api/users/self/upload_contract");

        var options = new FileUploadOptions();
        options.fileKey = "files";
        options.fileName = fileName;
        options.mimeType = "image/jpeg";
        options.chunkedMode = false;

        var headers={'Authorization': 'jwt '+ storage.token};
        options.headers = headers;

        var ft = new FileTransfer();
        $scope.progressbar.start();
        $scope.progressbar.set(10);
        ft.onprogress = function(progressEvent) {
            console.log(progressEvent.loaded / progressEvent.total);
            $scope.progressbar.set(Math.floor(progressEvent.loaded / progressEvent.total * 100));
        };
        ft.upload(fileURL, uri, win, fail, options, true);
    }

    var setByPhoto = function(){
        var optionCam = {
            quality: 50,
            destinationType: Camera.DestinationType.NATIVE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            saveToPhotoAlbum: false
        };
        if(ionic.Platform.isAndroid()){
            $cordovaDialogs.confirm($translate.instant("WANTDOYOUWANT"), "",  [$translate.instant("TAKEPICTURE"),$translate.instant("CHOOSEFILE")]).then(function(data){
                if(data==2){
                    fileChooser.open(function(uri){uploadURI(uri, true)}, function(){$cordovaDialogs.alert('Failed');});
                }
                else if(data==1){
                    navigator.camera.getPicture(function(uri){uploadURI(uri, false)}, function(){$cordovaDialogs.alert('Failed');},optionCam);
                }
                else{
                    return;
                }
            });
        }
        else{
            $cordovaDialogs.confirm($translate.instant("WANTDOYOUWANT"), "",  [$translate.instant("TAKEPICTURE"),$translate.instant("CHOOSEFILE")]).then(function(data){
                if(data==2){
                    optionCam.sourceType = Camera.PictureSourceType.PHOTOLIBRARY;
                    navigator.camera.getPicture(function(uri){uploadURI(uri, false)}, function(){$cordovaDialogs.alert('Failed');},optionCam);
                }
                else if(data==1){
                    navigator.camera.getPicture(function(uri){uploadURI(uri, false)}, function(){$cordovaDialogs.alert('Failed');},optionCam);
                }
                else{
                    return;
                }
            });
        }
    }

    $scope.setTimeZone = function(){
        window.plugins.listpicker.showPicker(config, 
            function(item) {
                if(item==0){
                    console.log("select other : go to timeslot creator");
                    timeSlotCreator();
                }
                else{
                    Globales.lowCostTS($scope.contract.country,$scope.zipcode,item).then(function(data){
                        var key = Object.keys(data[0]);
                        data = data[0];
                        var listTimeSlot = [];  
                        for(var i=0; i<9; i++){
                            console.log(key[i+2]);
                            console.log(data[key[i+2]]);
                            if(data[key[i+2]]!="[]"){
                                listTimeSlot.push({text: "Zone "+(i+1)+" " + ts2string(data[key[i+2]]), value: data[key[i+2]]});
                            }
                        }
                        console.log(JSON.stringify(listTimeSlot));
                        listTimeSlot.push({text: $translate.instant("OTHER"), value: 0});

                        var config2 = {
                            title: $translate.instant("SELECTYOURZONE"), 
                            items: listTimeSlot,
                            selectedValue: "",
                            doneButtonLabel: "Ok",
                            cancelButtonLabel: $translate.instant("CANCEL")
                        };

                        window.plugins.listpicker.showPicker(config2, 
                            function(item) {
                                if(item==0){
                                    console.log("select other : go to timeslot creator");
                                    timeSlotCreator();
                                }
                                else{
                                    setTimeSlot(item);
                                }
                                setTimeSlot(item);
                            },
                            function() { 
                                console.log("change nothing again");
                            }
                        );
                    });
                }
            },
            function() { 
                console.log("change nothing");
            }
        );
    }
}
])