angular.module('app.controllers', [])

.controller('myLukoCtrl', ['$scope', '$stateParams', '$rootScope', '$state', '$http','$ionicScrollDelegate','Saving','$translate','$ionicHistory','segment','Globales', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $rootScope,$state,$http,$ionicScrollDelegate,Saving,$translate,$ionicHistory,segment, Globales) {
    var analytics = segment;
    var storage = window.localStorage;

    //X-mas option
    $scope.house = "img/home.jpg";
    $scope.coach = "img/consumption/coach.png ";
    $scope.coachgrey = "img/consumption/coachgrey.png";

    $scope.more_feature = true;
    $scope.validation = storage.setup_sensor;

    time = Date.now();
    if((time > Date.parse("2017-12-18"))&&(time < Date.parse("2018-01-07"))){
        $scope.house = "img/homeXmas.gif"
        $scope.coach = "img/consumption/coachXmas.png"
    }

    $scope.$on("$ionicView.afterEnter",function(){
        console.log("Menu");
        try{
            downDataMenu = JSON.parse(storage.consumptionData);
            $scope.more_feature = downDataMenu.data.older_than_a_week; 
        } catch(err){
            $scope.more_feature = false;
        }
        
        console.log('more_feature = ' + $scope.more_feature)
        //$scope.more_feature = false;
    });


    $scope.$on("$ionicView.beforeEnter", function(){
        Globales.getHardwareStatus(storage.token).then(function(data){
            if (data==0){
                console.log("Error in hardware status1")
            }
            else if (data.data==0){
                console.log("Error in hardware status2")
            }
            else{
                data = data.data;
                console.log(data);
                if (data.sensor_id){
                    storage.setup_sensor = true;
                } else {
                    storage.setup_sensor = false;
                }
            }
            Saving.save(null);
            $scope.validation = storage.setup_sensor;
        });
    })


    $scope.logout = function(){
        storage.token = "";
        window.localStorage.clear();
        if(ionic.Platform.isIOS()){
          var platformString = "IOS";
        }
        else if (ionic.Platform.isAndroid()){
          var platformString = "GCM";
        }
        else{
          var platformString = "OTHER";
        }
        try{
            cordova.getAppVersion.getVersionNumber().then(function (version) {
              $http.post('https://app.getluko.com/msg/subscribePush', {token: storage.registrationId, platform: platformString, user_id: '', appversion: version, language: $translate.use()})
              .success(function(data){
              })
              .error(function(err){
              });
            })
        }
        catch(err){
            console.log("No app version, no notification user - unsucbribed ")
        }
        Saving.save(null)
        if(typeof intercom !== 'undefined') {intercom.reset();}

        $state.go('myLuko.login');
    }

    function keyboardShowHandler(){
        console.log('keyboard up')
        $ionicScrollDelegate.scrollBottom(true);
    }

    $scope.slaask = function(){
        intercom.displayMessenger();
        if(typeof analytics !== 'undefined') {analytics.track("APP :" + $ionicHistory.currentStateName() + ":HELP-INTERCOM");}
        console.log('Show INTERCOM')
    }

    $scope.goToCoach = function(){
        storage.currentCard = "coach";
        $state.go('myLuko.appliance');
    }

    $scope.goToActivity = function(){
        storage.currentCard = "activity";
        $rootScope.$broadcast('applianceChanged');
        $state.go('myLuko.appliance');
    }

}])
