angular.module('app.controllers')

.controller('setupStartCtrl', ['$scope', '$stateParams','LukoDevicePairing','$state', '$ionicHistory', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams,LukoDevicePairing, $state, $ionicHistory) {
    console.log("Ready");
    var storage = window.localStorage;

    //if(typeof analytics !== 'undefined') { analytics.trackView($ionicHistory.currentStateName()); }
    analytics.track($ionicHistory.currentStateName());

    $scope.logout = function(){
        storage.removeItem('token');
        $state.go('login');
    }

    $scope.startSetup = function(){
        $state.go('myLuko.scannQRcode');
        //$state.go('myLuko.MeterPhoto');
        //$state.go('myLuko.WaitingForValidation');
        //$state.go('myLuko.PlugSensor');
    }

}])

.controller('scannQRcode', ['Globales','$scope', '$stateParams','LukoDevicePairing','$state', '$ionicHistory', '$translate', '$cordovaDialogs',
function (Globales, $scope, $stateParams,LukoDevicePairing, $state, $ionicHistory , $translate, $cordovaDialogs) {

  var storage = window.localStorage;

    var qrCodeSetted = false;

   /*  Navigation  */

  $scope.back = function(){
      console.log("back");
      window.history.go(-1);
  };

  $scope.next = function(){
      console.log("next");
      $state.go('myLuko.PlugTheBridge');
  };

  $scope.supportOpen = function(){
    console.log("support");
    intercom.displayMessenger();
    console.log('Show intercom')
  };

  /* Display specific content if QR Code scanned or not  */
  $scope.$on("$ionicView.beforeEnter",function(){
    Globales.getHardwareStatus(storage.token).then(function(data){
          if(data==0){
              qrCodeSetted = false ;
              return;
          }
          else{
              if (data.data.sensor_id != null) 
                {
                  console.log(data.data.sensor_id)
                  qrCodeSetted = true ;
                }
              else {
                qrCodeSetted = false ;
              }
              isQRCodeSetted();
          }
        });
    isQRCodeSetted();
  });

  // Sert dans le bouton camera ??
  $scope.buttonClass = function(){
      if($scope.buttonDisable){
          return("activated")
      }
  }

  var isQRCodeSetted = function() {
    if (qrCodeSetted){
      $scope.showSettedQRcontent = true;
      $scope.showSetQR = false;
    }
    else {
      $scope.showSettedQRcontent = false;
      $scope.showSetQR = true;
    }
  };

  /* Checking functions - correct id */
  var isQRCodeValid = function(code){
    var newCode = code.substring(1);
    code = "1" + newCode;
    console.log("New code with the 1 in front ---- " + code);
    if (isNaN(code) || parseInt(code) < 100000)
    {
      message = $translate.instant('QRNOTVALID');
      title = $translate.instant('QRNOTVALIDTITLE');
      $cordovaDialogs.alert(message, title, 'OK');
    } else {
      console.log("code = " + code)
      var data = {
        "code": code
      }
      LukoDevicePairing.verifElecSensorId(data).then(function(ret){
          if (ret == 0){ // Request error
            title = $translate.instant('ERROR');
            message = $translate.instant('LUKONOTFOUND');
            $cordovaDialogs.alert(message, title, 'OK');
          } else {
            if (ret.good != 1){

              message = $translate.instant('QRNOTVALID');
              title = $translate.instant('QRNOTVALIDTITLE');
              $cordovaDialogs.alert(message, title, 'OK');
            } else {
              //QR Code good
              qrCodeSetted = true;
              isQRCodeSetted();
              $scope.next();
            }
          }
        });
    }
  };


  /* Scann function and mannual entering function */
      $scope.startScann = function() {
      //window.screen.orientation.unlock();
      //console.log("unlock")
      cordova.plugins.barcodeScanner.scan(
        function (result) {
            console.log("Result: " + result.text);
            if (result.cancelled){
              return ;
            } else {
              var code = result.text;
              isQRCodeValid(code);
            }
        },
        function (error) {
            console.log("ERROR - Scanning failed: " + error);
        },
        {
            preferFrontCamera : false, // iOS and Android
            showFlipCameraButton : true, // iOS and Android
            showTorchButton : true, // iOS and Android
            torchOn: false, // Android, launch with the torch switched on (if available)
            saveHistory: false, // Android, save scan history (default false)
            prompt : $translate.instant("PLACEBARCODEINSIDESCAN"), // Android
            resultDisplayDuration: 500, // Android, display scanned text for X ms. 0 suppresses it entirely, default 1500
            formats : "QR_CODE", // default: all but PDF_417 and RSS_EXPANDED
            //orientation : "portrait", // Android only (portrait|landscape), default unset so it rotates with the device
            disableAnimations : false, // iOS
            disableSuccessBeep: false // iOS and Android
        }
     );
  }

  $scope.manualCode = function (){
    title = $translate.instant('MANUALQRTITLE');
    msg = $translate.instant('MANUALQRMESSAGE');
    buttonArray = [$translate.instant("CANCEL"),'OK'];
    defaultText = "";
    $cordovaDialogs.prompt(msg, title, buttonArray, defaultText).then(function(result) {
        var code = result.input1;
        var btnIndex = result.buttonIndex;
        if(btnIndex == 2 && code.length > 0){
          isQRCodeValid(code);
          }
    });
  }

}])


.controller('plugTheBridgeCtrl', ['$scope', '$stateParams','LukoDevicePairing','$state', '$ionicHistory',
function ($scope, $stateParams,LukoDevicePairing, $state, $ionicHistory) {
    console.log("plugTheBridgeCtrl");
    var storage = window.localStorage;

    $scope.back = function(){
        console.log("back");
        window.history.go(-1);
    };

    $scope.next = function(){
        console.log("next");
        if(ionic.Platform.isIOS()){
            console.log("IOS");
            $state.go('myLuko.ConnectLukoconfig')
        }
        else if(ionic.Platform.isAndroid()){
            console.log("Android");
            $state.go('myLuko.AllowGeoLoc')
        }
        else{
            console.log("WEB");
            $state.go('myLuko.SelectDomesticWifi')
        }
    };

    $scope.supportOpen = function(){
        console.log("support");
        intercom.displayMessenger();
        console.log('Show intercom')
    };

}])

.controller('allowGeoLocCtrl', ['$scope', '$stateParams','LukoDevicePairing','$state', '$ionicHistory', '$translate', '$cordovaDialogs',
function ($scope, $stateParams,LukoDevicePairing, $state, $ionicHistory, $translate, $cordovaDialogs) {
    console.log("allowGeoLocCtrl");
    var storage = window.localStorage;
    var numEssai = 0;

    $scope.back = function(){
        console.log("back");
        window.history.go(-1);
    };

    $scope.next = function(){
        cordova.plugins.diagnostic.requestLocationAuthorization(function(status){
            console.log("Successfully requested location authorization: authorization was " + status);
            if(status == cordova.plugins.diagnostic.permissionStatus.GRANTED){
                $state.go('myLuko.ConnectLukoconfig')
            }
            else{
                if(numEssai>1){
                    $state.go('myLuko.ConnectLukoconfig');
                }
                else{
                    cordova.plugins.diagnostic.getPermissionsAuthorizationStatus(function(statuses){
                        for (var permission in statuses){
                            if(statuses[permission] == cordova.plugins.diagnostic.permissionStatus.GRANTED){
                                $state.go('myLuko.ConnectLukoconfig')
                                return;
                            }
                        }
                        $cordovaDialogs.alert($translate.instant('LUKONEEDLOCALISATIONAUTHORIZATIONFORSETUP'), $translate.instant('ERROR'),'OK').then();
                        numEssai++;

                    }, function(error){
                       $cordovaDialogs.alert($translate.instant('LUKONEEDLOCALISATIONAUTHORIZATIONFORSETUP'), $translate.instant('ERROR'),'OK').then();
                       numEssai++;
                    },[
                        cordova.plugins.diagnostic.permission.ACCESS_FINE_LOCATION,
                        cordova.plugins.diagnostic.permission.ACCESS_COARSE_LOCATION
                    ]);
                }
            }
        }, function(error){
            $state.go('myLuko.ConnectLukoconfig');
            console.error(error);
        });
    };

    $scope.supportOpen = function(){
        console.log("support");
        intercom.displayMessenger();
        console.log('Show intercom')
    };

}])

.controller('connectLukoconfigCtrl', ['$scope', '$stateParams','LukoDevicePairing','$state', '$ionicHistory', '$timeout',
function ($scope, $stateParams,LukoDevicePairing, $state, $ionicHistory, $timeout) {
    console.log("plugTheBridgeCtrl");
    if (!String.prototype.includes) {String.prototype.includes = function(search, start) {'use strict';if (typeof start !== 'number') {start = 0;}if (start + search.length > this.length) {return false;} else {return this.indexOf(search, start) !== -1;}};}

    var storage = window.localStorage;
    var canceled = false;
    var listWifiLuko = [];

    $scope.back = function(){
        console.log("back");
        canceled = true;
        window.history.go(-1);
    };

    $scope.cancel = function(){
        canceled = true;
        console.log("back");
        $state.go('myLuko.settings');
    };

    $scope.next = function(){
        console.log("next");
        canceled = true;
        $state.go('myLuko.SelectDomesticWifi')
    };

    $scope.supportOpen = function(){
        console.log("support");
        intercom.displayMessenger();
        console.log('Show intercom')
    };

    // Set the image of settings
    imageContainer = function(){
      if(ionic.Platform.isIOS()){
          $scope.imageContainer = "img/setup/setup_connecttolukoconfig.png"
      }
      else if(ionic.Platform.isAndroid()){
          console.log("Android");
          $scope.imageContainer = "img/setup/setup_connecttolukoconfig_android.png"
      }
      else{
          console.log("WEB");
          $scope.imageContainer = "img/setup/setup_connecttolukoconfig_android.png"
      }
    }

    // Check if cordova plugin is present
    isOpenSettings = function(){
      if (window.cordova && window.cordova.plugins.settings) {
        console.log('openNativeSettingsTest is active');
        $scope.showGoToSettings = true;
      } else {
          console.log('openNativeSettingsTest is not active!');
          $scope.showGoToSettings = false;
      }
    }

    // Open wifi settings
    $scope.OpenSettings = function(){
        window.cordova.plugins.settings.open("wifi", function() {
            console.log('opened settings');
        }, function () {
            $cordovaDialogs.alert($translate.instant('FAILOPENSETTINGS'), $translate.instant('ERROR'),'OK');
            console.log('failed to open settings');
          }
        );
    }

    function checkWifi(num, callback){
        console.log("Checking wifi...");
        if(canceled){return}
        try{
            WifiWizard.getCurrentSSID(
                function(ssid){
                    if(ssid.includes("LUKOCONFIG")){
                        if(num == 1){
                            $timeout(callback,200);
                        }
                        else{
                        $timeout(function(){checkWifi(1, callback);},3000);
                        }
                    }
                    else{
                        $timeout(function(){checkWifi(0, callback);},250);
                    }
                },
                function(){
                    $timeout(function(){checkWifi(0, callback);},500);
                }
            );
        }
        catch(err){
            console.log(err);
            if(!ionic.Platform.isAndroid() && !ionic.Platform.isIOS()){
                $timeout(callback,200);
            }
            else
            {
                $timeout(function(){checkWifi(0, callback);},500);
            }
        }
    }

    $scope.$on("$ionicView.afterEnter",function(){
        canceled = false;
        checkWifi(0,function(){$scope.next()});
    });

    $scope.$on("$ionicView.beforeEnter",function(){
        isOpenSettings();
        imageContainer();
    });

}])

.controller('selectDomesticWifiCtrl', ['$scope', '$stateParams','LukoDevicePairing','$state', '$ionicHistory','$timeout','$cordovaDialogs', '$ionicPopup', '$translate',
function ($scope, $stateParams,LukoDevicePairing, $state, $ionicHistory, $timeout, $cordovaDialogs, $ionicPopup, $translate) {
    console.log("selectDomesticWifiCtrl");

    if (!String.prototype.includes) {String.prototype.includes = function(search, start) {'use strict';if (typeof start !== 'number') {start = 0;}if (start + search.length > this.length) {return false;} else {return this.indexOf(search, start) !== -1;}};}

    var checkFastWifi = function(num, callback){
        console.log("Checking wifi... " + num);
        if(canceled){return}
        if(num>30){
            WifiWizard.getCurrentSSID(
                function(ssid){
                    if(ssid.includes("LUKOCONFIG")){
                        connexionState = "luko";
                        updots();
                        $timeout(function(){checkFastWifi(0, callback);},200);
                    }
                    else{
                        connexionState = "wifi";
                        updots();
                        LukoDevicePairing.pingg().then(function(online){
                            if((online)&&($scope.data.LukoID!=0)){
                                LukoDevicePairing.setDeviceID($scope.data.LukoID, storage.token).then(function(data){
                                    console.log(JSON.stringify(data));
                                    if(data == 0){
                                        checkFastWifi(num++,callback);
                                    }
                                    else if(data.good == 1){
                                        $timeout(function(){
                                            LukoDevicePairing.checkServerOnline().then(function(serverOK){
                                                if(serverOK==null){ //no internet
                                                    num++;
                                                    updots();
                                                   checkFastWifi(num,callback);
                                                }
                                                else if(serverOK==1){ //device online OK
                                                    $scope.next();
                                                }
                                                else{ //device not online
                                                    if(num>1000){
                                                        $cordovaDialogs.alert($translate.instant('CONNECTIONTOLUKOLOST'), $translate.instant('ERROR'),'OK').then($scope.back);
                                                    }
                                                    else{
                                                        num += 100;
                                                        $timeout(function(){checkFastWifi(num,callback);},1000);
                                                    }
                                                }
                                            });
                                        },2000);
                                    }
                                });
                            }
                            else{
                                $cordovaDialogs.alert($translate.instant('CONNECTIONTOLUKOLOST'), $translate.instant('ERROR'),'OK').then($scope.back);
                            }
                        })
                    }
                },
                function(){
                    connexionState = "nothing";
                    updots();
                    LukoDevicePairing.pingg().then(function(online){
                        if((online)&&($scope.data.LukoID!=0)){
                            LukoDevicePairing.setDeviceID($scope.data.LukoID, storage.token).then(function(data){
                                console.log(JSON.stringify(data));
                                if(data == 0){
                                    checkFastWifi(num++,callback);
                                }
                                else if(data.good == 1){
                                    $timeout(function(){
                                        LukoDevicePairing.checkServerOnline().then(function(serverOK){
                                            if(serverOK==null){ //no internet
                                                num++;
                                               checkFastWifi(num,callback);
                                            }
                                            else if(serverOK==1){ //device online OK
                                                $scope.next();
                                            }
                                            else{ //device not online
                                                if(num>1000){
                                                    $cordovaDialogs.alert($translate.instant('CONNECTIONTOLUKOLOST'), $translate.instant('ERROR'),'OK').then($scope.back);
                                                }
                                                else{
                                                    num += 100;
                                                    $timeout(function(){checkFastWifi(num,callback);},1000);
                                                }
                                            }
                                        });
                                    },2000);
                                }
                            });
                        }
                    })
                }
            );
            return;
        }
        else{
            try{
                WifiWizard.getCurrentSSID(
                    function(ssid){
                        console.log("success in ssid read");
                        if(ssid.includes("LUKOCONFIG")){
                            connexionState = "luko";
                            updots();
                            $timeout(callback,200);
                        }
                        else{
                            num++;
                            connexionState = "wifi";
                            updots();
                            $timeout(function(){checkFastWifi(num, callback);},500);
                        }
                    },
                    function(){
                        console.log("error in ssid read");
                        connexionState = "nothing";
                        updots();
                        num++;
                        $timeout(function(){checkFastWifi(num, callback);},500);
                    }
                );
            }
            catch(err){
                console.log(err);
                num++;
                connexionState = "nothing";
                updots();
                if(!ionic.Platform.isAndroid() && !ionic.Platform.isIOS()){
                    console.log("Web");
                    $timeout(callback,2000);
                }
                else
                {
                    $timeout(function(){checkFastWifi(num, callback);},500);
                }
            }
        }
    }

    var storage = window.localStorage;
    var canceled = false;
    $scope.data = {
        PSW: '',
        WifiIndex: 0,
        LukoID: 0,
        WifiName: '',
        step: 0,
        stepname: $translate.instant("INITIALIZATION"),
        dots: '.'
    };
    var connexionState = "luko";

    var updots = function(){
        dotlen  = $scope.data.dots.length;
        dotlen = (dotlen+1)%4;
        switch(connexionState){
            case "luko":
                symbol = ".";
                break;
            case "wifi":
                symbol = "*";
                break;
            case "nothing":
                symbol = "-";
                break;
            default:
                symbol = "_";
                break;
        }
        var dotStr = "";
        for(var i=0; i<dotlen; i++){
            dotStr = dotStr + symbol;
        }
        $scope.data.dots = dotStr;
    }



    $scope.back = function(){
        console.log("back");
        canceled = true;
        window.history.go(-1);
    };

    $scope.cancel = function(){
        console.log("back");
        canceled = true;
        $state.go('myLuko.settings');
    };

    $scope.next = function(){
        console.log("next");
        canceled = true;
        $state.go('myLuko.CongratsBridgeSuccess')
    };

    $scope.supportOpen = function(){
        console.log("support");
        intercom.displayMessenger();
        console.log('Show intercom')
    };

    $scope.$on("$ionicView.afterEnter",function(){
        canceled = false;
        $scope.data = {
            PSW: '',
            WifiIndex: 0,
            LukoID: 0,
            WifiName: '',
            step: 0,
            stepname: $translate.instant("INITIALIZATION"),
            dots: '.'
        };
        checkFastWifi(0,function(){getDeviceID()});
    });

    var getDeviceID = function(){
        if(canceled){return}
        console.log("Getting device ID");
        $scope.data.step = 1;
        $scope.data.stepname = $translate.instant('LOOKINGLUKOCONNECTION');
        LukoDevicePairing.getID().then(function(data){
            console.log(data);
            if(data==0){
                $timeout(function(){checkFastWifi(0,getDeviceID);}, 500);
                return;
            }
            $scope.data.LukoID = data.id;
            if($scope.data.LukoID!=0){
                console.log("Device ID : "+$scope.data.LukoID );
                $timeout(function(){
                    checkFastWifi(0,startDiscussion);
                },1900);
            }
            else{
                $timeout(function(){checkFastWifi(0,getDeviceID);},1000);
            }

        });
    }

    function startDiscussion(){
        console.log("discussion started");
        if(canceled){return}
        $scope.data.step = 2;
        $scope.data.stepname = $translate.instant('LUKOWIFI');
        LukoDevicePairing.getWifiState().then(function(data){
            console.log(data);
            if(data==0){
                $timeout(function(){
                    console.log("error from ESP");
                    checkFastWifi(0,startDiscussion);
                },500);
                return;
            }
            if(data.good == 1){ //Get Wifi connection
                $timeout(reconfigure,300);
            }
            else{ //No wifi set : so go tu setWifiProcess
                $timeout(function(){
                    checkFastWifi(0,setWifiProcess);
                },200);
            }
        })
    }


    var reconfigure = function(){
        if(canceled){return}
        $cordovaDialogs.confirm($translate.instant('YOURLUKOALREADYCONNECTEDTOAWIFI') + ' \n ' + $translate.instant('DOYOUWANTTOCONFIGURENEWWIFI'), $translate.instant("WARNING"),  [$translate.instant("YES"),$translate.instant("NO")]).then(function(data){
            if(data==1){
                checkFastWifi(0,setWifiProcess);
            }
            else if (data==2){
                checkFastWifi(0,checkServer);
            }
            else{
                $scope.back();
            }
        });
    };

    function setWifiProcess(){
        if(canceled){return}
        $scope.data.step = 3;
        $scope.data.stepname = $translate.instant('SETWIFIINFOS');
        LukoDevicePairing.listWifi().then(function(out){
            $scope.askWifi(out);
        });
    }

    $scope.askWifi = function(out){
        try{
            listPopup.close();
        }
        catch(err){
            console.log(err);
        }
        if(out==0){
            $timeout(function(){checkFastWifi(0,setWifiProcess)}, 500);
            return;
        }
        else if(out== 1){
            listPopup = $ionicPopup.show({
                template: '<input type="text" ng-model="data.WifiName" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false">',
                title: $translate.instant('ENTERWIFINAME'),
                scope: $scope,
                buttons: [
                    {
                        text: '<b>' + $translate.instant('CANCEL') + '</b>',
                        type: 'button-positive',
                        onTap: function() {
                            $scope.cancelSetup();
                            return;
                        }
                    },
                    {
                        text: '<b>' + $translate.instant('VALIDATE') +'</b>',
                        type: 'button-positive',
                        onTap: function(e) {
                            if (!$scope.data.WifiName) {
                                e.preventDefault();
                            } else {
                                ssidList = [$scope.data.WifiName];
                                $timeout(function(){$scope.setPSW(0,false);}, 50);
                            }
                        }
                    },
                ]
            });
            return;
        }
        else{
            var ssidList = out.SSID;
            var rssiList = out.RSSI;
            var n = ssidList.length;
            listWifiLuko = []; //globally defined for crossfunciton

            for (var i=0; i<n; i++){
                listWifiLuko.push([ssidList[i], rssiList[i]]);
            }
            listWifiLuko.sort(function(a, b){
                return(parseFloat(b[1])-parseFloat(a[1]));
            })
            console.log(n);

            var percentList = [];
            var temp = '<ion-list>';
            for(var i = 0; i < n; i++){
                percentList[i] = (listWifiLuko[i][1]+100)*2;
                console.log(percentList[i]);
                temp += '<ion-item ng-click="setPSW('+i+',true)">'+listWifiLuko[i][0]+' : '+percentList[i] + ' %</ion-item>';
            }
            temp += '<ion-item ng-click="askWifi(1)">' + $translate.instant('HIDDEN') + ' </ion-item>';
            temp += '</ion-list>';
            listPopup = $ionicPopup.show({
                 template: temp,
                 title: $translate.instant('SELECTYOURWIFINETWORK'),
                 scope: $scope,
            });
        }
    }

    $scope.setPSW = function(index, fromList){
        if(canceled){return}
        $scope.data.WifiIndex = index;
        if(fromList){
            $scope.data.WifiName = listWifiLuko[index][0];
        }
        wifiNameLoc = $scope.data.WifiName;
        $ionicPopup.show({
            template: '<input type="text" ng-model="data.PSW" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false">',
            title: $translate.instant('ENTERWIFIPASSWORD'),
            subTitle: $translate.instant('FORNETWORK')+ wifiNameLoc,
            scope: $scope,
            buttons: [
                {
                    text: '<b>' + $translate.instant('CANCEL') + '</b>',
                    type: 'button-positive',
                    onTap: function() {
                        if(fromList){
                            return;
                        }
                        else{
                            $timeout(function(){checkFastWifi(0,setWifiProcess)}, 20);
                        }
                    }
                },
                {
                    text: '<b>' + $translate.instant('VALIDATE') +'</b>',
                    type: 'button-positive',
                    onTap: function(e) {
                        if (!$scope.data.PSW) {
                            e.preventDefault();
                        } else {
                            listPopup.close();
                            $timeout(function(){checkFastWifi(0,saveWifi)}, 50);
                        }
                    }
                },
            ]
        });
    }

    var saveWifi = function(){
        if(canceled){return}

        var info = {
            ssid: $scope.data.WifiName,
            pwd: $scope.data.PSW
        };

        $scope.data.step = 3;
        $scope.data.stepname = $translate.instant('SENDINGWIFIINFOS');
        LukoDevicePairing.setWifi(info).then(function(data){
            if(data==0){
                $timeout(function(){checkFastWifi(0,saveWifi)}, 50);
                return;
            }
            if(data.good == 1){
                $timeout(function(){
                    checkFastWifi(0,function(){checkWifiConnection(0);});
                }, 3000);
            }
        });
    }

    var checkWifiConnection = function(index){
        if(canceled){return}
        $scope.data.step = 4;
        $scope.data.stepname = $translate.instant('VERIFYINGWIFICONNECTION');
        if (index>20){
             $cordovaDialogs.alert($translate.instant("YOURPASSWORDSEEMSTOBEWRONG"), $translate.instant("NOWIFICONNECTION")).then(function(){
                $timeout(function(){checkFastWifi(0,setWifiProcess)}, 500);
            });
        }
        else{
            LukoDevicePairing.getWifiState().then(function(data){
                console.log(JSON.stringify(data));
                if(data==0){
                    $timeout(function(){checkFastWifi(0,function(){
                        checkWifiConnection(index);
                    })}, 500);
                    return;
                }
                if(data.good == 1){
                    $timeout(function(){checkFastWifi(0,checkServer)},1000);
                }
                else{
                    index++;
                    $timeout(function(){checkFastWifi(0,function(){
                        checkWifiConnection(index);
                    })},1000);
                }
            })
        }
    }

    var checkServer = function(){
        if(canceled){return}
        $scope.data.step = 5    ;
        $scope.data.stepname = $translate.instant('CHECKINGSERVER');
        LukoDevicePairing.getServerConnection().then(function(data){
            console.log(data);
            if(data==0){
                $timeout(function(){checkFastWifi(0,checkServer)},500);
                return;
            }
            if(data.good == 1){
                $timeout(function(){
                    checkFastWifi(0,function(){shutdownServerESP(0);});
                },1500);
            }
            else{
                $timeout(function(){checkFastWifi(0,checkServer)},2000);
            }
        })
    }


    var shutdownServerESP = function(iteration){
        if(canceled){return}
        console.log("Restarting ESP");
        $scope.data.step = 6;
        $scope.data.stepname = $translate.instant('RESTARTINGLUKO');
        LukoDevicePairing.shutdownServer().then(function(data){
            console.log(data);
            if(data==0){
                iteration++;
                if(iteration>15){
                    $timeout(function(){disconnectWifi(0)},100);
                }
                $timeout(function(){ checkFastWifi(0,function(){shutdownServerESP(iteration);});}, 400);
                return;
            }
            if(data.good==1){
                $timeout(function(){disconnectWifi(0)},2000);
            }
            else{
                iteration++;
                if(iteration>15){
                    $timeout(function(){disconnectWifi(0)},100);
                }
                $timeout(function(){checkFastWifi(0,function(){shutdownServerESP(iteration);});}, 500);
                return;
            }

        });
    }

    var disconnectWifi = function(num){
        if(canceled){return}

        WifiWizard.getCurrentSSID(function(ssid){
            if(ssid.includes("LUKOCONFIG")){
                if(num<15){
                    num++;
                    $timeout(function(){disconnectWifi(num);},1000);
                }
                else{
                    $cordovaDialogs.alert($translate.instant('PLEASE') + '<b> ' + $translate.instant('DISCONNECT') + ' </b>' + $translate.instant('YOURPHONETOLUKOCONFIGWIFI'), $translate.instant("DISCONNECTTOLUKOWIFI")).then(function(){disconnectWifi(0);});
                }
            }
            else{
                $timeout(function(){
                    setDeviceID();
                },2000);
            }
        },function(){
            $timeout(function(){setDeviceID();},6000);
        }
        );
    }

    var setDeviceID = function(){
        if(canceled){return}
        $scope.data.step = 7;
        $scope.data.stepname = $translate.instant('SAVINGYOURACCOUNT');
        LukoDevicePairing.setDeviceID($scope.data.LukoID, storage.token).then(function(data){
            console.log(data);
            if(data == 0){
                $cordovaDialogs.alert($translate.instant('YOUNEEDTOBECONNECTEDTOINTERNET'), $translate.instant("NOINTERNETCONNECTION")).then(function(){$timeout(function(){setDeviceID()},3000);});
            }
            else if(data.good == 1){
                $timeout(function(){
                    $scope.next();
                });
            }
            else{
                $timeout(function(){setDeviceID()},1500);
            }

        });
    }

}])

.controller('congratsBridgeSuccessCtrl', ['$scope', '$stateParams','LukoDevicePairing','$state', '$ionicHistory',
function ($scope, $stateParams,LukoDevicePairing, $state, $ionicHistory) {
    console.log("congratsBridgeSuccessCtrl");
    var storage = window.localStorage;

    $scope.back = function(){
        console.log("back");
        window.history.go(-1);
    };

    $scope.cancel = function(){
        console.log("back");
        $state.go('myLuko.settings');
    };

    $scope.next = function(){
        console.log("next");
        $state.go('myLuko.MeterPhoto')
    };

    $scope.supportOpen = function(){
        console.log("support");
        intercom.displayMessenger();
        console.log('Show intercom')
    };

}])

.controller('meterPhotoCtrl', ['$scope', '$stateParams','LukoDevicePairing','$state', '$ionicHistory', 'ngProgressFactory', '$cordovaDialogs', '$translate',
function ($scope, $stateParams,LukoDevicePairing, $state, $ionicHistory, ngProgressFactory, $cordovaDialogs, $translate) {
    console.log("meterPhotoCtrl");
    var storage = window.localStorage;
    $scope.flashlightimg = "FlashlightOFF";
    $scope.progressbar = ngProgressFactory.createInstance();
    try{$scope.progressbar.setColor("#85D2A0");} catch(err){console.log(JSON.stringify(err));}
    $scope.hideNext = true;
    $scope.buttonDisable = false;

    $scope.$on("$ionicView.afterEnter",function(){
        $scope.flashlightimg = "FlashlightOFF";
        window.plugins.flashlight.available(function(isAvailable) {
            if (isAvailable) {
                if(window.plugins.flashlight.isSwitchedOn()){
                    $scope.flashlightimg = "FlashlightON";
                }
                else{
                    $scope.flashlightimg = "FlashlightOFF";
                }
            }
            else{
                 $scope.flashlightimg = "FlashlightOFF";
            }
        });
    });

    $scope.buttonClass = function(){
        if($scope.buttonDisable){
            return("activated")
        }
    }

    $scope.back = function(){
        console.log("back");
        window.history.go(-1);
    };

    $scope.cancel = function(){
        console.log("back");
        $state.go('myLuko.settings');
    };

    $scope.next = function(){
        console.log("next");
        $state.go('myLuko.PlugSensor')
    };

    $scope.flashlight = function(){
        console.log("Toggle light")
        window.plugins.flashlight.available(
            function(isAvailable) {
            if (isAvailable) {
                window.plugins.flashlight.toggle(
                function(){
                    if(window.plugins.flashlight.isSwitchedOn()){
                        $scope.flashlightimg = "FlashlightON";
                    }
                    else{
                        $scope.flashlightimg = "FlashlightOFF";
                    }
                },
                function(){if(window.plugins.flashlight.isSwitchedOn()){$scope.flashlightimg = "FlashlightON";}else{$scope.flashlightimg = "FlashlightOFF";}},
                {intensity: 1});
            }
            else {
                alert("Flashlight not available on this device");
            }
        });
    }

    $scope.takePicture = function(){
        window.plugins.flashlight.switchOff(takePictureLight, takePictureLight);
    };

    var takePictureLight = function(){
        navigator.camera.getPicture(
            function(imageURI){
                var fileURL = imageURI
                console.log(fileURL)
                function win(r) {
                    $scope.progressbar.complete();
                    $scope.$apply(function(){$scope.hideNext = false;});
                    $scope.next();
                }
                function fail(error) {
                    $scope.buttonDisable = false;
                    $scope.progressbar.reset();
                    $cordovaDialogs.alert($translate.instant("ERRORUPLOADIMAGE"), $translate.instant("OK"));
                    console.log(error);
                }
                var uri = encodeURI("https://app.getluko.com/api/users/self/upload_meter_nude");

                var options = new FileUploadOptions();
                options.fileKey = "files";
                options.fileName = fileURL.substr(fileURL.lastIndexOf('/') + 1);

                if (fileURL.slice(-3).toLowerCase() === "pdf"){
                  options.mimeType = "application/pdf";
                }
                else if (fileURL.slice(-3).toLowerCase() === "png"){
                  options.mimeType = "image/png";
                }
                else {
                  options.mimeType = "image/jpeg";
                }
                options.chunkedMode = false;

                var headers={'Authorization': 'jwt '+ storage.token};
                options.headers = headers;

                var ft = new FileTransfer();
                $scope.progressbar.start();
                $scope.progressbar.set(10);
                ft.onprogress = function(progressEvent) {
                    console.log(progressEvent.loaded / progressEvent.total);
                    $scope.progressbar.set(Math.floor(progressEvent.loaded / progressEvent.total * 100));
                };
                ft.upload(fileURL, uri, win, fail, options, true);
            },
            function(){
                $scope.buttonDisable = false;
                $cordovaDialogs.alert($translate.instant("ERRORUPLOADIMAGE"), $translate.instant("OK"));
                console.log('Failed because: ' + message);
            },
            { quality: 50, destinationType: Camera.DestinationType.NATIVE_URI, sourceType: Camera.PictureSourceType.CAMERA, saveToPhotoAlbum: false}
        );
    }

    $scope.supportOpen = function(){
        console.log("support");
        intercom.displayMessenger();
        console.log('Show intercom')
    };

}])


.controller('plugSensorCtrl', ['$scope', '$stateParams','LukoDevicePairing','$state', '$ionicHistory','$translate',
function ($scope, $stateParams,LukoDevicePairing, $state, $ionicHistory,$translate) {
    console.log("plugSensorCtrl");
    var storage = window.localStorage;
    $scope.flashlightimg = "FlashlightOFF";

        $scope.step = 0;
    $scope.IMAGE_SENSOR = "identify_led.gif"
    $scope.INSTRUCTION_TEXT = $translate.instant("IDENTIFYLED")
    $scope.STEP_INDICATION = $translate.instant("MAJSTEP") + " 1/6"
    $scope.sub_indication_show = false;
    $scope.SUBINDICATION = "";
/*
Identifier la led
Placer le support en centrant sur la led
Placer le capteur
Retirer le bloc pile
Fermet le boitier
Posez votre luko sur votre compteur*/

    var update_UI = function()
    {
        if($scope.step == 0)
        {
            $scope.IMAGE_SENSOR = "identify_led.gif"
            $scope.INSTRUCTION_TEXT = $translate.instant("IDENTIFYLED")
            $scope.STEP_INDICATION = $translate.instant("MAJSTEP") + " " + ($scope.step+1) + "/6"
            $scope.sub_indication_show = false;
            $scope.SUBINDICATION = "";
        }
        else if($scope.step == 1)
        {
            $scope.IMAGE_SENSOR = "put_support.gif"
            $scope.INSTRUCTION_TEXT = $translate.instant("PUTSUPPORT")
            $scope.STEP_INDICATION = $translate.instant("MAJSTEP") + " " + ($scope.step+1) + "/6"
            $scope.sub_indication_show = false;
            $scope.SUBINDICATION = "";
        }
        else if($scope.step == 2)
        {
            $scope.IMAGE_SENSOR = "place_sensor.gif"
            $scope.INSTRUCTION_TEXT = $translate.instant("PLACESENSOR")
            $scope.STEP_INDICATION =  $translate.instant("MAJSTEP") + " " + ($scope.step+1) + "/6"
            $scope.sub_indication_show = false;
            $scope.SUBINDICATION = "";
        }
        else if($scope.step == 3)
        {
            $scope.IMAGE_SENSOR = "remove_strip.gif"
            $scope.INSTRUCTION_TEXT = $translate.instant("REMOVESTRIP")
            $scope.STEP_INDICATION = $translate.instant("MAJSTEP") + " " + ($scope.step+1) + "/6"
            $scope.sub_indication_show = true;
            $scope.SUBINDICATION = $translate.instant("IFSTRIPREMOVED");
        }
        else if($scope.step == 4)
        {
            $scope.IMAGE_SENSOR = "close_box.gif"
            $scope.INSTRUCTION_TEXT = $translate.instant("CLOSEBOX")
            $scope.STEP_INDICATION = $translate.instant("MAJSTEP") + " " + ($scope.step+1) + "/6"
            $scope.sub_indication_show = false;
            $scope.SUBINDICATION = "";
        }
        else if($scope.step == 5)
        {
            $scope.IMAGE_SENSOR = "put_sensor_on_top.png"
            $scope.INSTRUCTION_TEXT = $translate.instant("PUTSENSORONTOP")
            $scope.STEP_INDICATION = $translate.instant("MAJSTEP") + " " + ($scope.step+1) + "/6"
            $scope.sub_indication_show = false;
            $scope.SUBINDICATION = "";
        }
        else
        {
            $scope.IMAGE_SENSOR =  "identify_led.gif"
            $scope.INSTRUCTION_TEXT = $translate.instant("ERROR")
            $scope.STEP_INDICATION = $translate.instant("MAJSTEP") + " " + ($scope.step+1) + "/6"
            $scope.sub_indication_show = false;
            $scope.SUBINDICATION = "";
        }

    }

    $scope.$on("$ionicView.afterEnter",function(){
        $scope.flashlightimg = "FlashlightOFF";
        window.plugins.flashlight.available(function(isAvailable) {
            if (isAvailable) {
                if(window.plugins.flashlight.isSwitchedOn()){
                    $scope.flashlightimg = "FlashlightON";
                }
                else{
                    $scope.flashlightimg = "FlashlightOFF";
                }
            }
            else{
                 $scope.flashlightimg = "FlashlightOFF";
            }
        });
    });

    $scope.back = function(){
        console.log("back");
        if($scope.step == 0)
        {
             window.history.go(-1);
        }
        else
        {
            $scope.step--;
            update_UI();
        }
    };

    $scope.cancel = function(){
        console.log("back");
        $state.go('myLuko.settings');
    };

    $scope.next = function(){
        console.log("next");
        if($scope.step == 5)
        {
            $state.go('myLuko.PhotoSensorAndLuko')
        }
        else
        {
            $scope.step++;
            update_UI();
        }
    };

    $scope.supportOpen = function(){
        console.log("support");
        intercom.displayMessenger();
        console.log('Show intercom')
    };

    $scope.flashlight = function(){
        console.log("Toggle light")
        window.plugins.flashlight.available(
            function(isAvailable) {
            if (isAvailable) {
                window.plugins.flashlight.toggle(
                function(){
                    if(window.plugins.flashlight.isSwitchedOn()){
                        $scope.flashlightimg = "FlashlightON";
                    }
                    else{
                        $scope.flashlightimg = "FlashlightOFF";
                    }
                },
                function(){if(window.plugins.flashlight.isSwitchedOn()){$scope.flashlightimg = "FlashlightON";}else{$scope.flashlightimg = "FlashlightOFF";}},
                {intensity: 1});
            }
            else {
                alert("Flashlight not available on this device");
            }
        });
    }
}])

.controller('photoSensorAndLukoCtrl', ['$scope', '$stateParams','LukoDevicePairing','$state', '$ionicHistory', 'ngProgressFactory', '$cordovaDialogs', '$translate',
function ($scope, $stateParams,LukoDevicePairing, $state, $ionicHistory, ngProgressFactory, $cordovaDialogs, $translate) {
    console.log("photoSensorAndLukoCtrl");
    var storage = window.localStorage;
    $scope.flashlightimg = "FlashlightOFF";
    $scope.progressbar = ngProgressFactory.createInstance();
    try{$scope.progressbar.setColor("#85D2A0");} catch(err){console.log(JSON.stringify(err));}
    $scope.hideNext = true;

    $scope.$on("$ionicView.afterEnter",function(){
        $scope.flashlightimg = "FlashlightOFF";
        window.plugins.flashlight.available(function(isAvailable) {
            if (isAvailable) {
                if(window.plugins.flashlight.isSwitchedOn()){
                    $scope.flashlightimg = "FlashlightON";
                }
                else{
                    $scope.flashlightimg = "FlashlightOFF";
                }
            }
            else{
                 $scope.flashlightimg = "FlashlightOFF";
            }
        });
    });

    $scope.back = function(){
        console.log("back");
        window.history.go(-1);
    };

    $scope.cancel = function(){
        console.log("back");
        $state.go('myLuko.settings');
    };

    $scope.next = function(){
        console.log("next");
        $state.go('myLuko.WaitingForValidation')
    };

    $scope.flashlight = function(){
        console.log("Toggle light")
        window.plugins.flashlight.available(
            function(isAvailable) {
            if (isAvailable) {
                window.plugins.flashlight.toggle(
                function(){
                    if(window.plugins.flashlight.isSwitchedOn()){
                        $scope.flashlightimg = "FlashlightON";
                    }
                    else{
                        $scope.flashlightimg = "FlashlightOFF";
                    }
                },
                function(){if(window.plugins.flashlight.isSwitchedOn()){$scope.flashlightimg = "FlashlightON";}else{$scope.flashlightimg = "FlashlightOFF";}},
                {intensity: 1});
            }
            else {
                alert("Flashlight not available on this device");
            }
        });
    }



    $scope.takePicture = function(){
        window.plugins.flashlight.switchOff(takePictureLight, takePictureLight);
    };

    var takePictureLight = function(){
        navigator.camera.getPicture(
            function(imageURI){
                var fileURL = imageURI
                console.log(fileURL)
                function win(r) {
                    $scope.progressbar.complete();
                    $scope.$apply(function(){$scope.hideNext = false;});
                    //$cordovaDialogs.alert($translate.instant("YOUCANCONTINUE"), $translate.instant("THANKS")).then(function(){$scope.next();});
                    $scope.next();
                }
                function fail(error) {
                    $scope.progressbar.reset();
                    $cordovaDialogs.alert($translate.instant("ERRORUPLOADIMAGE"), $translate.instant("OK"));
                }
                var uri = encodeURI("https://app.getluko.com/api/users/self/upload_meter_lukoed");

                var options = new FileUploadOptions();
                options.fileKey = "files";
                options.fileName = fileURL.substr(fileURL.lastIndexOf('/') + 1);
                options.mimeType = "image/jpeg";
                options.chunkedMode = false;

                var headers={'Authorization': 'jwt '+ storage.token};
                options.headers = headers;

                var ft = new FileTransfer();
                $scope.progressbar.start();
                ft.onprogress = function(progressEvent) {
                    console.log(progressEvent.loaded / progressEvent.total);
                    $scope.progressbar.set(Math.floor(progressEvent.loaded / progressEvent.total));
                };
                ft.upload(fileURL, uri, win, fail, options, true);
            },
            function(){
              $cordovaDialogs.alert($translate.instant("ERRORUPLOADIMAGE"), $translate.instant("OK"));
              console.log(message);
            },
            { quality: 50, destinationType: Camera.DestinationType.NATIVE_URI, sourceType: Camera.PictureSourceType.CAMERA, saveToPhotoAlbum: false}
        );
    }

    $scope.supportOpen = function(){
        console.log("support");
        intercom.displayMessenger();
        console.log('Show intercom')
    };

}])

.controller('waitingForValidationCtrl', ['$scope', '$stateParams','Globales','LukoDevicePairing','$state', '$ionicHistory', '$timeout', '$translate', '$cordovaDialogs', '$cordovaInAppBrowser', 'ngProgressFactory','Saving',
function ($scope, $stateParams, Globales, LukoDevicePairing, $state, $ionicHistory, $timeout, $translate,$cordovaDialogs,$cordovaInAppBrowser,ngProgressFactory,Saving) {
    console.log("waitingForValidationCtrl");
    var storage = window.localStorage;
    var lang = $translate.use();
    var canceled = false;
    var date = 0;
    var success433 = false;
    var contract_upload = false;
    var form_set = false;


    $scope.contracttext = $translate.instant("SETMYCONTRACT");
    $scope.formtext = $translate.instant("FILLFORM");
    $scope.validationtext = $translate.instant("WAITINGFORVALIDATION");

    $scope.progressbar = ngProgressFactory.createInstance();

    try{$scope.progressbar.setColor("#85D2A0");} catch(err){console.log(JSON.stringify(err));}


    $scope.dotnum = "...";
    $scope.isLukoValidated = false;
    $scope.formClass = "img/pairing/total32.png";
    $scope.contractClass = "img/pairing/validate32.png";


    $scope.$on("$ionicView.beforeEnter",function(){
        canceled = false;
        date = Math.round(new Date().getTime()/1000);
        $scope.contracttext = $translate.instant("SETMYCONTRACT");
        $scope.formtext = $translate.instant("FILLFORM");
        $scope.validationtext = $translate.instant("WAITINGFORVALIDATION");
        //console.log(date);

        isContractSet();
        isFormSet();
        check433Server();
    });

    $scope.back = function(){
        console.log("back");
        canceled = true;
        window.history.go(-1);
    };

    $scope.cancel = function(){
        console.log("back");
        canceled = true;
        $state.go('myLuko.settings');
    };

    $scope.next = function(){
        console.log("next");
        canceled = true;
        $state.go('myLuko.SetupSuccess')
    };

    $scope.supportOpen = function(){
        console.log("support");
        intercom.displayMessenger();
        console.log('Show intercom')
    };

    $scope.setContract = function (){
        console.log("Luko : Contract ");
        var optionCam = {
            quality: 50,
            destinationType: Camera.DestinationType.NATIVE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            saveToPhotoAlbum: false
        };
        if(ionic.Platform.isAndroid()){
            $cordovaDialogs.confirm($translate.instant("WANTDOYOUWANT"), "",  [$translate.instant("TAKEPICTURE"),$translate.instant("CHOOSEFILE")]).then(function(data){
                if(data==2){
                    fileChooser.open(function(uri){uploadURI(uri, true)}, function(){});
                }
                else if(data==1){
                    navigator.camera.getPicture(function(uri){uploadURI(uri, false)}, function(){},optionCam);
                }
                else{
                    return;
                }
            });
        }
        else{
            console.log("Luko : Contract ");
            $cordovaDialogs.confirm($translate.instant("WANTDOYOUWANT"), "",  [$translate.instant("TAKEPICTURE"),$translate.instant("CHOOSEFILE")]).then(function(data){
                if(data==2){
                    optionCam.sourceType = Camera.PictureSourceType.PHOTOLIBRARY;
                    navigator.camera.getPicture(function(uri){uploadURI(uri, false)}, function(){},optionCam);
                }
                else if(data==1){
                    navigator.camera.getPicture(function(uri){uploadURI(uri, false)}, function(){},optionCam);
                }
                else{
                    return;
                }
            });
        }
    }

    $scope.goToSurvey = function(){
        console.log("Luko : For");
        console.log("Luko : Form");
        var options = {
            location: 'yes',
            clearcache: 'yes'
        }
        console.log("Luko : Form");
        if (lang == "fr-FR")// Trouver l'autre lien en FR
        {
            console.log("Luko : Form fr");
            $cordovaInAppBrowser.open('https://luko.typeform.com/to/Zm3Coz','_blank', options);
            $timeout(function(){form_set = true; isFormSet();},100);
        }
        else
        {
            console.log("Luko : Form fr");
            $cordovaInAppBrowser.open('https://luko.typeform.com/to/VPggG4','_blank', options);
            $timeout(function(){form_set = true; isFormSet();},100);
        }
    };

    isContractSet = function(){
      if (!contract_upload){
        Globales.getContract().then(function(data){
            if(data == 0){
                $scope.contractClass = "img/pairing/contract32.png";
                $scope.contracttext = $translate.instant("SETMYCONTRACT");
            }
            else {
              if (data.contract.firm != "Default"){
                console.log("Contract good");
                contract_upload = true;
                $scope.contractClass = "img/pairing/validate32.png";
                $scope.contracttext = $translate.instant("CONTRACTDONE");
              }
              else{
                console.log("Contrat Default");
                $scope.contractClass = "img/pairing/contract32.png";
                $scope.contracttext = $translate.instant("SETMYCONTRACT");
              }
            }
        });
      }
      else {
        $scope.contractClass = "img/pairing/validate32.png";
        $scope.contracttext = $translate.instant("CONTRACTDONE");
      }
    };

    isFormSet = function(){
      if (!form_set){ //If the form is never set
        LukoDevicePairing.checkFormFilled().then(function(ret){
          if (ret != 0){
            if(ret.good == 1){
              $scope.formClass = "img/pairing/validate32.png";
              $scope.formtext = $translate.instant("FORMDONE");
              form_set = true;
              console.log("Form set");
            }
            else {
              $scope.formClass = "img/pairing/total32.png";
              $scope.formtext = $translate.instant("FILLFORM");
              console.log("Luko : not setted 1");
            }
          }
        });
      }
      else{
        $scope.formClass = "img/pairing/validate32.png";
        $scope.formtext = $translate.instant("FORMDONE");
      }
    };

    var uploadURI = function(imageURI, fromFile){
        if(fromFile){
            var fileURL = imageURI[0];
            var fileName = imageURI[1];
        }
        else{
            var fileURL = imageURI;
            var fileName = fileURL.substr(fileURL.lastIndexOf('/') + 1);
        }
        console.log(fileURL);
        console.log(fileName);
        var authoriseExtension = ["txt", "pdf", "png", "jpg", "jpeg", "gif", "heic"];
        var authorizedFormat = false;
        for(var i=0; i<authoriseExtension.length; i++){
            if(fileName.toLowerCase().lastIndexOf(authoriseExtension[i])!=-1){
                authorizedFormat = true;
            }
        }
        if(!authorizedFormat){
             $cordovaDialogs.alert($translate.instant("ONLYTHISFILEAREALLOWED"), $translate.instant("FILETYPE"));
             return;
        }
        function win(r) {
            $scope.progressbar.complete();
            $cordovaDialogs.alert($translate.instant("WEWILLSETANDCONTACTYOUSOON"), $translate.instant("OK"));
            $timeout(function(){contract_upload = true; isContractSet();},100);
        }
        function fail(error) {
            $scope.progressbar.reset();
            $cordovaDialogs.alert($translate.instant("ERRORUPLOADCONTRACT"), $translate.instant("OK"));
            console.log(error);
        }
        var uri = encodeURI("https://app.getluko.com/api/users/self/upload_contract");

        var options = new FileUploadOptions();
        options.fileKey = "files";
        options.fileName = fileName;
        if (fileURL.slice(-3).toLowerCase() === "pdf"){
          options.mimeType = "application/pdf";
        }
        else if (fileURL.slice(-3).toLowerCase() === "png"){
          options.mimeType = "image/png";
        }
        else if (fileURL.slice(-3).toLowerCase() === "txt"){
          options.mimeType = "text/plain";
        }
        else if (fileURL.slice(-3).toLowerCase() === "gif"){
          options.mimeType = "image/gif";
        }
        else {
          options.mimeType = "image/jpeg";
        }
        options.chunkedMode = false;

        var headers={'Authorization': 'jwt '+ storage.token};
        options.headers = headers;

        var ft = new FileTransfer();
        $scope.progressbar.start();
        $scope.progressbar.set(10);
        ft.onprogress = function(progressEvent) {
            console.log(progressEvent.loaded / progressEvent.total);
            $scope.progressbar.set(Math.floor(progressEvent.loaded / progressEvent.total * 100));
        };
        ft.upload(fileURL, uri, win, fail, options, true);
    }

    var check433Server = function(){
        if(canceled){return;}

        LukoDevicePairing.check433Online(date,storage.token).then(function(data){
            //console.log(data);
            if(data == 0){
                $cordovaDialogs.alert($translate.instant('YOUNEEDTOBECONNECTEDTOINTERNET'), $translate.instant("NOINTERNETCONNECTION")).then(function(){
                        $timeout(function(){check433Server();},1000);
                    });
            }
            else if(data.good == 1){
                $timeout(function () {
                  $scope.isLukoValidated = true;
                  $storage.isLukoValidated = true;
                  Saving.save(null)
                  $scope.validationtext = $translate.instant("VALIDATIONDONE")
                }, 10);
            }
            else{
                $timeout(function(){check433Server()},1000);
            }
        });
    }

    //Verfiy if contract and Form filled
    $scope.checkSetup = function(){
      if (!$scope.isLukoValidated){
        console.log("Not validated yet so don't go next!");
      } else {
        if (contract_upload && form_set){
          $scope.next();
        }
        else{
          var msg = $translate.instant('WENEEDINFO');
          var title = $translate.instant('AREYOUSURE');
          var buttonArray = [$translate.instant('BACK'), $translate.instant('CONTINUE')]
          $cordovaDialogs.confirm(msg, title, buttonArray).then(function(value) {
              console.log(value)
              if (value == 2){
                $scope.next();
              }
          });
        }
      }
    }
}])

.controller('setupSuccessCtrl', ['$scope', '$stateParams','LukoDevicePairing','$state', '$ionicHistory',
function ($scope, $stateParams,LukoDevicePairing, $state, $ionicHistory) {
    console.log("setupSuccessCtrl");
    var storage = window.localStorage;
    $scope.flashlightimg = "FlashlightOFF";

    $scope.$on("$ionicView.beforeEnter",function(){
        window.plugins.flashlight.available(function(isAvailable) {
            if (isAvailable) {
                if(window.plugins.flashlight.isSwitchedOn()){
                    $scope.flashlightimg = "FlashlightON";
                }
                else{
                  $scope.flashlightimg = "FlashlightOFF";
                }
            }
            else {
              $scope.flashlightimg = "FlashlightOFF";
            }
        });
    });

    $scope.back = function(){
        console.log("back");
        window.history.go(-1);
    };

    $scope.cancel = function(){
        console.log("back");
        $state.go('myLuko.settings');
    };

    $scope.next = function(){
        console.log("next");
        $state.go('myLuko.consumption')
    };

    $scope.supportOpen = function(){
        console.log("support");
        intercom.displayMessenger();
        console.log('Show intercom')
    };

}])
