angular.module('app.controllers')


.controller('settingsCtrl', ['$scope', '$stateParams', 'Option', '$http', '$state','$ionicHistory','Saving','Globales','LukoDevicePairing',
'$cordovaInAppBrowser','$timeout','$translate','$cordovaDialogs','segment', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams,Option,$http,$state,$ionicHistory,Saving,Globales,LukoDevicePairing,
    $cordovaInAppBrowser,$timeout,$translate,$cordovaDialogs,segment) {
    var analytics = segment;
    var storage = window.localStorage;
    $scope.setup_bridge = storage.setup_bridge;
    $scope.setup_sensor = storage.setup_sensor;
    $scope.setup_target_available = $scope.more_feature; //to change
    $scope.setup_target = storage.setup_target;
    $scope.userName = storage.userName;
    $scope.hidebridgetext = false;
    $scope.sensortext = $translate.instant('SENSOR_SETUP_TEXT_2');
    $scope.bridgetext = $translate.instant('BRIDGE_SETUP_TEXT_2');
    $scope.step = 0;
    var form_set = false;

    try{
        if (JSON.parse(storage.contract).firm != "Default"){
            $scope.setup_contract = JSON.parse(storage.contract).firm;
        } else {
            $scope.setup_contract = "";
        }
    }catch(err){}
    $scope.server = {};
    $scope.data = {};
    storage.setup_step = "";
    $scope.data.deviceID = "Please, setup your Luko";

    var goodcolor = "status_green"
    var mediumcolor = "status_orange"
    var badcolor = "status_red"
    var undifcolor = "status_undif"

    $scope.change = function(){
        $scope.server['time_since_home'] = $scope.server['dateSinceHome'].getTime();
        //console.log($scope..server );  
        Option.setOption(storage.token, $scope.server).then(function(out){console.log(out);});     
    }

    $scope.setupUser = function(){
        $state.go('myLuko.setupUser');
    }
    
    $scope.setupHardware = function(){
        if (storage.setup_bridge){
            $state.go('myLuko.statusBridge');
        } else {
            $state.go('myLuko.setupStartBridge');
        }
        storage.setup_step = "bridge";
    }

    $scope.setupSensor = function(){
        if (storage.setup_sensor){
            $state.go('myLuko.statusSensor');
        } else {
            $state.go('myLuko.setupStartSensor');
        }
        storage.setup_step = "sensor";
    }


    $scope.setupContract = function(){
        storage.currentCard = "contract";
        Saving.save(null);
        $state.go('myLuko.appliance');
    }

    
    $scope.setupHome = function(){
        console.log("Luko : Form");
        var options = {
            location: 'yes',
            clearcache: 'yes'
        }
        console.log("Luko : Form");
        if (lang == "fr-FR")// Trouver l'autre lien en FR
        {
            console.log("Luko : Form fr");
            $cordovaInAppBrowser.open('https://luko.typeform.com/to/Zm3Coz','_blank', options);
            $timeout(function(){form_set = true; isFormSet();},100);
        }
        else
        {
            console.log("Luko : Form en");
            $cordovaInAppBrowser.open('https://luko.typeform.com/to/VPggG4','_blank', options);
            $timeout(function(){form_set = true; isFormSet();},100);
        }
        $scope.$broadcast('formWasOpen');

        //$state.go('myLuko.setupHome');
    };

    $scope.setupTarget = function(){
        storage.currentCard = "myTarget";
        $state.go('myLuko.appliance');
    };

    $scope.$on('formWasOpen', function(event, data){
        console.log("triggerevent")
        triggerCongrats();
    });


    isFormSet = function(){
        if (!form_set){
            LukoDevicePairing.checkFormFilled().then(function(ret){
              if (ret != 0){
                if(ret.good == 1){
                  $scope.setup_home = true;
                  $scope.step = 4;
                }
                else {
                  storage.formwasnotset = true;
                  Saving.save();
                  $scope.setup_home = false;
                }
              }
            });
        } else {
            $scope.setup_home = true;
            $scope.step = 4;
        }
    };
    
    $scope.reset = function(){
        storage.clear();
        Saving.save(null);
        $state.go('login');
    }

    $scope.menu = function(){
        $state.go('myluko');
    }

    $scope.refresh = function(){
        console.log("refresh")
        $scope.$broadcast("$ionicView.beforeEnter")
    }

    $scope.$on("$ionicView.beforeEnter", function(event, data){

        Option.getOption(storage.token).then(function(out){
            $scope.setup_target = out.consumption_active;
            console.log("is form set : ", $scope.setup_target)
            storage.setup_target = $scope.setup_target
            Saving.save(null);
        });

        $scope.setup_bridge = storage.setup_bridge;
        $scope.setup_sensor = storage.setup_sensor;
        $scope.setup_target_available = $scope.more_feature; //to change
        $scope.setup_target = storage.setup_target;
        $scope.userName = storage.userName;
        $scope.data.deviceID = "Please, setup your Luko";
        isFormSet();
        console.log("is form set : ", $scope.setup_target)

        lang = $translate.use();
        Globales.getPower3(storage.token, lang).then(function(downData){
                        if(downData.success){
                            storage.consumptionData = JSON.stringify(downData);
                            storage.consumptionTime = Math.floor(Date.now() / 1000);
                            Saving.save(null);
                        };
        });

        Globales.getHardwareStatus(storage.token).then(function(data){
            $scope.$broadcast('scroll.refreshComplete');
            if (data==0){
                console.log("Error in hardware status")
                try{window.plugins.toast.showLongBottom($translate.instant("ANERRORHAPPEN"))}catch(err){}
                //$cordovaDialogs.alert($translate.instant('ANERRORHAPPEN'), $translate.instant('ERROR'), "OK");
            }
            else if (data.data==0){
                console.log("Error in hardware status")
            }
            else{
                data = data.data;
                console.log("hardare status : ",data);
                if (data.sensor_id){
                    storage.setup_sensor = true;
                    if ($scope.step < 2 || !$scope.step){
                        $scope.step = 2;
                        console.log("salut 2")
                    }
                   }
                if (data.bridge_id){
                    storage.setup_bridge = true;
                    if ($scope.step < 1 || !$scope.step){
                        $scope.step = 1;
                        console.log("salut 1")
                    }
                }
                if(data.bridge_state == true){
                   $scope.bridgestate = {
                        color:  goodcolor,
                        value: "OK"
                    };
                }
                else{
                   $scope.bridgestate = {
                        color:  badcolor,
                        value: 'DISCONNECTED'
                    };
                    $scope.bridgetext = ""

                    }
                if(data.sensor_state === null){
                    storage.setup_sensor = false;
                    $scope.sensorstate = {
                        color:  mediumcolor,
                        value: "UNDEFINED"
                    }
                } else {
                    if ($scope.step < 2 || !$scope.step){
                        $scope.step = 2;
                        console.log("salut 2")
                    }
                    storage.setup_sensor = true;
                    if(data.sensor_state == 1){
                        $scope.sensorstate = {
                            color:  goodcolor,
                            value: "OK"
                        }
                    }
                    else if(data.sensor_state == 0.5){
                        $scope.sensorstate = {
                            color:  mediumcolor,
                            value: "TROUBLED"
                        }
                    }
                    else{
                        $scope.sensorstate = {
                            color:  badcolor,
                            value: "DISCONNECTED"
                        }
                        $scope.sensortext = ""
                        if ($scope.step == 2 || !$scope.step){
                            $scope.step = 1;
                            $scope.setup_sensor = false;
                            console.log("salut 1")
                        }
                    }
                }
                
                Saving.save(null);
                $scope.setup_sensor = storage.setup_sensor;
                $scope.setup_bridge = storage.setup_bridge;
            }}, function(err){$scope.$broadcast('scroll.refreshComplete');}
        );

        Globales.getContract().then(function(data){
            if(data==0){
                console.log("contract default or null")
                return;
            }
            else{
                storage.contract = JSON.stringify(data.contract);
                Saving.save(null);
                if(data.contract.firm != "Default"){
                    $scope.setup_contract = JSON.parse(storage.contract).firm;
                    if ($scope.step < 3 || !$scope.step){
                        $scope.step = 3;
                    }
                }
            }
        });


        Globales.getUser(storage.token).then(function(data) {
            storage.userName = data.first_name;
            Saving.save(null);
            $scope.userName = data.first_name;
        });

    });
        
    $scope.$on("$ionicView.afterEnter",function(){
        //if(typeof analytics !== 'undefined') { analytics.trackView($ionicHistory.currentStateName()); } 
        if(typeof analytics !== 'undefined') {
            analytics.identify(
                storage.Email, {
                    name: storage.userName,
                    email: storage.Email
            });
        }
        if(typeof analytics !== 'undefined') {analytics.track("APP :" + $ionicHistory.currentStateName());}
        console.log("afetr enter")
        //triggerCongrats()
    });

    var triggerCongrats = function(){
        setTimeout(function() {
            if($scope.setup_home && !storage.congratsdone && storage.formwasnotset){
                $state.go('myLuko.congrats');
                storage.congratsdone=true;
                Saving.save(null);
            }
        }, 1000);
    }


}
])