angular.module('app.controllers')


.controller('setupHomeCtrl', ['$scope', '$stateParams', 'Option', '$http', '$state','$ionicHistory','Saving','Globales','LukoDevicePairing',
'$cordovaInAppBrowser','$timeout','$translate','segment',// The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams,Option,$http,$state,$ionicHistory,Saving,Globales,LukoDevicePairing,$cordovaInAppBrowser,$timeout,$translate,segment) {
    var analytics = segment;
    var storage = window.localStorage;
    if (storage.house){
        $scope.house = JSON.parse(storage.house);
    } 

    var countrycode = {'Afghanistan':'AF','Albania':'AL','Algeria':'DZ','Andorra':'AD','Angola':'AO','Angola and Barbuda':'AG','Argentina':'AR','Armenia':'AM','Australia':'AU',
        'Austria':'AT','Azerbaijan':'AZ','Bahamas':'BS','Bahrain':'BH','Bangladesh':'BD','Barbados':'BB','Belarus':'BY','Belgium':'BE','Belize':'BZ','Benin':'BJ','Bhutan':'BT','Bolivia':'BO',
        'Bosnia and Herzegovina':'BA','Botswana':'BW','Brazil':'BR','Brunei':'BN','Bulgaria':'BG','Burkina Faso':'BF','Burundi':'BI','Cabo Verde':'CV','Cambodia':'KH','Cameroon':'CM',
        'Canada':'CA','Central African Republic':'CF','Chad':'TD','Chile':'CL','China':'CN','Colombia':'CO','Comoros':'KM',
        'Republic of the Congo':'CG','Costa Rica':'CR','Cote d\'Ivoire':'CI','Croatia':'HR','Cuba':'CU','Cyprus':'CY','Czech Republic':'CZ','Denmark':'DK','Djibouti':'DJ',
        'Dominica':'DM','Dominican Republic':'DO','Ecuador':'EC','Egypt':'EG','El Salvador':'SV','Equatorial Guinea':'GQ','Eritrea':'ER','Estonia':'EE','Eswatini':'SZ',
        'Ethiopia':'ET','Fiji':'FJ','Finland':'FI','France':'FR','Gabon':'GA','Gambia':'GM','Georgia':'GE','Germany':'DE','Ghana':'GH','Greece':'GR','Grenada':'GD','Guatemala':'GT',
        'Guinea':'GN','Guinea-Bissau':'GW','Guyana':'GY','Haiti':'HT','Honduras':'HN','Hungary':'HU','Iceland':'IS','India':'IN','Indonesia':'ID','Iran':'IR','Iraq':'IQ','Ireland':'IE',
        'Israel':'IL','Italy':'IT','Jamaica':'JM','Japan':'JP','Jordan':'JO','Kazakhstan':'KZ','Kenya':'KE','Kiribati':'KI','Kosovo':'XK','Kuwait':'KW','Kyrgyzstan':'KG','Laos':'LA',
        'Latvia':'LV','Lebanon':'LB','Lesotho':'LS','Liberia':'LR','Libya':'LY','Liechtenstein':'LI','Lithuania':'LT','Luxembourg':'LU','Macedonia':'MK','Madagascar':'MG',
        'Malawi':'MW','Malaysia':'MY','Maldives':'MV','Mali':'ML','Malta':'MT','Marshall Islands':'MH','Mauritania':'MR','Mauritius':'MU','Mexico':'MX','Micronesia':'FM','Moldova':'MD',
        'Monaco':'MC','Mongolia':'MN','Montenegro':'ME','Morocco':'MA','Mozambique':'MZ','Myanmar':'MM','Namibia':'NA','Nauru':'NR','Nepal':'NP','Netherlands':'NL','New Zealand':'NZ',
        'Nicaragua':'NI','Niger':'NE','Nigeria':'NG','North Korea':'KP','Norway':'NO','Oman':'OM','Pakistan':'PK','Palau':'PW','Palestine':'PS','Panama':'PA','Papua New Guinea':'PG',
        'Paraguay':'PY','Peru':'PE','Philippines':'PH','Poland':'PL','Portugal':'PT','Qatar':'QA','Romania':'RO','Russia':'RU','Rwanda':'RW','Saint Lucia':'LC',
        'Samoa':'WS','San Marino':'SM','Sao Tome and Principe':'ST','Saudi Arabia':'SA','Senegal':'SN','Serbia':'RS','Seychelles':'SC',
        'Sierra Leone':'SL','Singapore':'SG','Slovakia':'SK','Slovenia':'SI','Solomon Islands':'SB','Somalia':'SO','South Africa':'ZA','South Korea':'KR','South Sudan':'SS','Spain':'ES',
        'Sri Lanka':'LK','Sudan':'SD','Suriname':'SR','Swaziland':'SZ','Sweden':'SE','Switzerland':'CH','Syria':'SY','Taiwan':'TW','Tajikistan':'TJ','Tanzania':'TZ','Thailand':'TH',
        'Timor-Leste':'TL','Togo':'TG','Tonga':'TO','Trinidad and Tobago':'TT','Tunisia':'TN','Turkey':'TR','Turkmenistan':'TM','Tuvalu':'TV','Uganda':'UG','Ukraine':'UA',
        'United Arab Emirates':'AE','United Kingdom':'UK','United States of America':'US','Uruguay':'UY','Uzbekistan':'UZ','Vanuatu':'VU','Vatican City':'VA',
        'Venezuela':'VE','Vietnam':'VN','Yemen':'YE','Zambia':'ZM','Zimbabwe':'ZW'};

    $scope.countries = Object.keys(countrycode);

    var houses = {};
    houses[$translate.instant('HOUSE')]='house';
    houses[$translate.instant('APARTMENT')]='apartment';
    houses[$translate.instant('SEASONALHOUSE')]='seasonal-house';
    houses[$translate.instant('SEASONALAPARTMENT')]='seasonal-apartment';
    
    $scope.housetypes = Object.keys(houses);
    $scope.inhabitants = ['1','2','3','4','5','6','7','8','9','10+'];
    $scope.areass = ['< 70', '< 140', '> 140'];


    var swap = function(json){
          var ret = {};
          for(var key in json){
            ret[json[key]] = key;
          }
          return ret;
        }

    function readTextFile(filepath) {
        var client = new XMLHttpRequest();
        client.open('GET', filepath);
        client.onreadystatechange = function() {
          console.log(client.responseText);
        }
        client.send();
        return client.responseText;
    }

    $scope.$on("$ionicView.beforeEnter", function(event, data){
        if(typeof analytics !== 'undefined') {analytics.track("APP :" + $ionicHistory.currentStateName());}
        data = {
            country: 'FR',
            zipcode: '75000',
            electricmeter: 1,
            building: 'apartment',
            area: '< 140',
            inhabitants: '8',
            construction: 1990,
            appliances: {fridge: 'always', oven: 'sometimes', freezer: 'never'}
        };
        $scope.house = {}
        $scope.house['country' ]= swap(countrycode)[data.country];
        $scope.house['zipcode']=data.zipcode;
        $scope.house['electricmeter']=data.electricmeter;
        $scope.house['building']=swap(houses)[data.building];
        $scope.house['area']=data.area;
        $scope.house['inhabitants']=data.inhabitants;
        $scope.house['construction']=data.construction;
        $scope.house['appliances']=data.appliances;
       /* Globales.getHouse(storage.token).then(function(data) {
            storage.house = JSON.stringify(data);
            Saving.save(null);
            $scope.house = data;
        }); */

    });

    $scope.back = function(){
      console.log("back");
      window.history.go(-1);
    };
        

    $scope.save = function(){
        $scope.newHouse = Object.assign({},$scope.house);
        console.log($scope.house);
        $scope.newHouse.country = countrycode[$scope.house.country];
        $scope.newHouse.building = houses[$scope.house.building];
        console.log($scope.house);
        console.log($scope.newHouse);
     /*   Globales.setHouse(storage.token, $scope.house).then(function(resp){
            if (resp == 0){
                $cordovaDialogs.alert($translate.instant("ERROROCCURRED"), "OK");
            } else {
                console.log($scope.house);
                storage.house = JSON.stringify($scope.house);
                Saving.save(null);
                try{window.plugins.toast.showLongBottom($translate.instant("SAVEDONE"))}catch(err){}    
            }
        }) */

    }

    $scope.changeRadio = function(num){
        $scope.house.electricmeter=num;
    }



}
])