angular.module('app.controllers')

.controller('statusCtrl', ['$scope', '$stateParams', 'Globales', '$state', '$http', '$cordovaDialogs', '$ionicHistory', '$translate', 'Option', 'segment',// The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, Globales, $state, $http, $cordovaDialogs, $ionicHistory, $translate, Option,segment) {
    var analytics = segment;
    var storage = window.localStorage;
    $scope.back = function(){
        console.log("back");
        window.history.go(-1);
    };

    var goodcolor = "status_green"
    var mediumcolor = "status_orange"
    var badcolor = "status_red"
    var undifcolor = "status_undif"

    $scope.refresh = function(){
        console.log("refresh")
        $scope.$broadcast("$ionicView.beforeEnter")
    }

    $scope.bridgestate = {
        color:  goodcolor,
        value: ""
    }
    $scope.wifisignal = {
        color:  goodcolor,
        value: ""
    }
    $scope.sensorsignal = {
        color:  mediumcolor,
        value: ""
    }
    $scope.hardware_version = "2.10"
    $scope.software_version = "2.00"
    $scope.bridgeID = '0'
    $scope.sensorstate = {
        color:  goodcolor,
        value: ""
    }
    $scope.sensorcalibration = {
        color: badcolor,
        value: ""
    }
    $scope.sensorID = '0'
    $scope.appversion = {
        color: goodcolor,
        value: "0"
    }

    $scope.setup = function(){
        if (storage.setup_step == "bridge"){
            $state.go('myLuko.setupStartBridge');    
        } else {
            $state.go('myLuko.setupStartSensor');
        }  
    }


    var applyColor = function(obj){
        if(obj.value === null){
            obj.color = undifcolor;
        }
        else if(obj.value>60){
            obj.color = goodcolor;
        }
        else if (obj.value>25){
            obj.color = mediumcolor;
        }
        else{
            obj.color = badcolor;
        }
        obj.value = obj.value + " %"
    }

    $scope.$on("$ionicView.beforeEnter", function(event, data){
        console.log("beforeEnter")

        try {
            cordova.getAppVersion.getVersionNumber().then(function (version) {
                $scope.appversion = {
                    color: undifcolor,
                    value: version
                }
            });
        }
        catch(err){
            $scope.appversion = {
                color: undifcolor,
                value: $translate.instant("UNDEFINED")
            }
            console.log(err)
        }

        Globales.getHardwareStatus(storage.token).then(function(data){
            $scope.$broadcast('scroll.refreshComplete');
            if (data==0){
                console.log("Error in hardware status")
                try{window.plugins.toast.showLongBottom($translate.instant("ANERRORHAPPEN"))}catch(err){}
                //$cordovaDialogs.alert($translate.instant('ANERRORHAPPEN'), $translate.instant('ERROR'), "OK");
            }
            else if (data.data==0){
                console.log("Error in hardware status")
                try{window.plugins.toast.showLongBottom($translate.instant("ANERRORHAPPEN"))}catch(err){}
                //$cordovaDialogs.alert($translate.instant('ANERRORHAPPEN'), $translate.instant('ERROR'), "OK");
            }
            else{
                data = data.data;
                console.log(data);

                if(data.bridge_state == true){
                   $scope.bridgestate = {
                        color:  goodcolor,
                        value: "OK"
                    };
                }
                else{
                   $scope.bridgestate = {
                        color:  badcolor,
                        value: 'DISCONNECTED'
                    };
                }

                if(data.wifi_signal === null)
                {
                    $scope.wifisignal = {
                        color:  undifcolor,
                        value: "UNDEFINED"
                    }
                }
                else{
                    $scope.wifisignal.value = data.wifi_signal
                    applyColor($scope.wifisignal);
                }
                
                if(data.sensor_signal_reception === null)
                {
                    $scope.sensorsignal = {
                        color:  undifcolor,
                        value: "UNDEFINED"
                    }
                }
                else{
                    $scope.sensorsignal.value = data.sensor_signal_reception
                    applyColor($scope.sensorsignal);
                }
                console.log(data.hardware_version)
                $scope.hardware_version = (data.hardware_version+1).toFixed(2);
                console.log($scope.hardware_version)
                $scope.software_version = (data.software_version).toFixed(2);
                $scope.bridgeID = String(data.bridge_id);

                if(data.sensor_state === null){
                    $scope.sensorstate = {
                        color:  mediumcolor,
                        value: "UNDEFINED"
                    }
                }

                if(data.sensor_state == 1){
                    $scope.sensorstate = {
                        color:  goodcolor,
                        value: "OK"
                    }
                }
                else if(data.sensor_state == 0.5){
                    $scope.sensorstate = {
                        color:  mediumcolor,
                        value: "TROUBLED"
                    }
                }
                else{
                    $scope.sensorstate = {
                        color:  badcolor,
                        value: "DISCONNECTED"
                    }
                }

                if(data.sensor_calibration_done === null){
                    $scope.sensorcalibration = {
                        color:  undifcolor,
                        value: "UNDEFINED"
                    }
                }
                if(data.sensor_calibration_done == true){
                    $scope.sensorcalibration = {
                        color:  goodcolor,
                        value: "RECALDONE"
                    }
                }
                else if(data.sensor_calibration_done == false){
                    $scope.sensorcalibration = {
                        color:  mediumcolor,
                        value: "RECALDOING"
                    }
                }
                if(data.sensor_id === null){
                    $scope.sensorID = $translate.instant("UNDEFINED")
                }
                else{
                    $scope.sensorID = String(data.sensor_id);
                }
            }
        }, function(err){$scope.$broadcast('scroll.refreshComplete');}
        );
    });

}
])
