angular.module('app.controllers')

.controller('timelineCtrl', ['$scope', '$stateParams', '$state', 'Globales','$ionicHistory', '$translate', 'Saving', '$timeout','segment',// The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $state, Globales, $ionicHistory, $translate, Saving, $timeout,segment) {
    var analytics = segment;
	$scope.data = {
		events: [],
		spacerDay: [],
		spacerDayText: []
	};
	$scope.showCards = true;
 	var storage = window.localStorage;

 	var icon_color = 4; //Blue

	var onLoadFunctionTimeline = function(){
		$scope.showCards = true;
		Globales.getEvents(storage.token).then(function(out){
			if(out == 0){
                try {
				 window.plugins.toast.showLongBottom($translate.instant("NOINTERNET"))
                } catch(err){}
			}
			else{
				console.log("events download")
				storage.timelineData = JSON.stringify(out.data)
				Saving.save();
				var timelineData = out.data;
				addDaySpacer(timelineData);
				$scope.data.events = timelineData;
				if($scope.data.events.length > 0){$scope.showCards = true;}
				else{$scope.showCards = false;}
			}
		});
		if("timelineData" in storage){
			try {
	            //console.log(storage.timelineData);
	            var timelineData = JSON.parse(storage.timelineData);
	            console.log("data parsed")
	        }
	        catch(err) {
	            var timelineData = 0;
	            console.log("data error")
	        }
	        if(timelineData!=0){
	        	console.log("settimeline")
	        	//console.log(timelineData.length)
	        	addDaySpacer(timelineData);
				$scope.data.events = timelineData;
	        }
		}
		if ($scope.data.events.length > 0){
			$scope.showCards = true;
		}
		else{
			$scope.showCards = false;
		}
	}

	$scope.$on("$ionicView.beforeEnter",function(){
        onLoadFunctionTimeline();
        //if(typeof analytics !== 'undefined') {        	analytics.trackView($ionicHistory.currentStateName());}
        if(typeof analytics !== 'undefined') {analytics.track("APP :" + $ionicHistory.currentStateName());}
    });

    var old2new = function(old){
    	newID = [4800, 4700, 5100, 3300, 3900, 3518, 3519]
    	return newID[old-1];
    }

	function addDaySpacer(dataEvents){
		var today = new Date();
		today = new Date(today.getFullYear(), today.getMonth(), today.getDate());
		var lastDiff = 0;
		console.log(dataEvents);

		for (var i=0; i<dataEvents.length; i++){
			event1 = dataEvents[i];
			if(event1.event_type_id<999){
				event1.event_type_id = old2new(event1.event_type_id);
			}
			event1.name = $translate.instant("A"+event1.event_type_id)

			if(event1.event_type_id>2999){
				event1.img = (Math.floor(event1.event_type_id/100)*100) + "_0" + icon_color;
			}
			else{
				event1.img = event1.event_type_id + "_0" + icon_color;
			}
			var f = new Date();
    		f.setTime(Date.parse(event1.datecreated));
    		f = new Date(f.getFullYear(), f.getMonth(), f.getDate());
    		var dayDiff = Math.round((today-f)/(1000*60*60*24));
    		if(dayDiff>lastDiff){
    			$scope.data.spacerDay[event1.id] = false;
    			lastDiff = dayDiff;
    			var text = "";

    			var monthNames = [
    				$translate.instant("JANUARY"),
    				$translate.instant("FEBRUARY"),
    				$translate.instant("MARCH"),
    				$translate.instant("APRIL"),
    				$translate.instant("MAY"),
    				$translate.instant("JUNE"),
					$translate.instant("JULY"),
					$translate.instant("AUGUST"),
					$translate.instant("SEPTEMBER"),
					$translate.instant("OCTOBER"),
					$translate.instant("NOVEMBER"),
					$translate.instant("DECEMBER")
				];

    			if(dayDiff==1){
    				text = $translate.instant("YESTERDAY");
    			}
    			else{
    				text = $translate.instant("XDAYSAGO", {nb_days: dayDiff});
    			}
    			text = text + " - " + $translate.instant("DAYANDMONTH", {month: monthNames[f.getMonth()], day: f.getDate()});;
    			$scope.data.spacerDayText[event1.id] = text;
    		}
    		else{
    			$scope.data.spacerDay[event1.id] = true;
    			$scope.data.spacerDayText[event1.id] = "";
    		}
    		if(i>0){
    			if(event1.event_type_id == 2001){
    				if(dataEvents[i-1].event_type_id == 2002){
    					if(event1.duration == 0){
    						//console.log("on build");
    						var f1 = new Date();
    						f1.setTime(Date.parse(event1.datecreated));
    						var f2 = new Date();
    						f2.setTime(Date.parse(dataEvents[i-1].datecreated));
    						event1.duration = Math.round((f2-f1)/(1000));
    					}
    				}
    			}
    		}
		}

		//console.log($scope.data.spacerDay);
		//console.log($scope.data.spacerDayText);

	}

	$scope.daySpacert = function(id){
		var text = id;
		var model = '<ion-list><ion-item class="item-divider">' + text + '</ion-item></ion-list>';
		return model;
	}

    $scope.hoursminutes = function(elem){
    	var f = new Date();
    	f.setTime(Date.parse(elem+"Z"));
    	return(("0" + f.getHours()).slice(-2)+":"+("0" + f.getMinutes()).slice(-2));
    }

    $scope.durationFormat = function(elem){
    	if(elem==null){
    		return
    	}
    	hours = Math.floor(elem/3600);
    	minutes = Math.floor(elem/60)%60;
    	seconde = elem%60;
    	if(hours==0){
    		if (minutes==0){
	    		if (seconde==0){
	    			return;
	    		}
	    		else{
	    			return(seconde+"sec")
	    		}
	    	}
	    	else{
    			return(minutes+"min "+("0" + seconde).slice(-2)+"sec")
    		}
    	}
       	else{
    		return(hours+"h "+("0" + minutes).slice(-2)+"min")
    	}
    }

    $scope.remove = function(event){
    	event.deleted = true;
    	Globales.setEvents(storage.token,event).then(function(out){
			if(out == 0){
				$cordovaDialogs.alert($translate.instant('ERRORFROMOURSERVER'), $translate.instant('SORRY')).then(function(){
                    storage.removeItem('token');
                    Saving.save();
                    $state.go('login');
				});
			}
			else{
				addDaySpacer(out.data);
				$scope.data.events = out.data;
			}
		});
		$scope.data.events = $scope.data.events.filter(function(el) {return el.id !== event.id;});
    }

    timelineApplianceCards = {
        "2001": "activity",
        "2002": "activity",
        "2011": "activity",
        "2012": "activity",
        "2101": "activity",
        "2101": "activity",
        "2201": "activity",
        "2202": "activity"
    }

    $scope.goToApplianceCard = function(event_type_id){
    	var keys = Object.keys(timelineApplianceCards);
        cardInArray = false;
        for(var i=0; i<keys.length; i++){
            if(event_type_id.toString() == keys[i]){
                cardInArray = true;
            }
        };
        if(cardInArray){
            storage.currentCard = timelineApplianceCards[event_type_id.toString()];
            $state.go('myLuko.appliance');
        }
    }
}])
