angular.module('app.controllers')


.controller('setupUserCtrl', ['$scope','Globales','Saving','$translate','$cordovaDialogs','$ionicHistory','segment', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope,Globales,Saving,$translate,$cordovaDialogs,$ionicHistory,segment) {
    var analytics = segment;
    var storage = window.localStorage;
    var countrycode = {'Belgium':'BE','France':'FR','Germany':'DE','Italy':'IT','Spain':'ES','Switzerland':'CH','United Kingdom':'GB',
        'United States of America':'US', 'Other':''};

    var countrynumber = {"":"+","BE": "+32","FR": "+33","DE": "+49","IT": "+39", "ES": "+34","CH": "+41","GB":"+44","US": "+1"}

    var countryflag = {"":"","BE":"🇧🇪","FR":"🇫🇷","DE":"🇩🇪","IT":"🇮🇹","ES":"🇪🇸","CH":"🇨🇭","GB":"🇬🇧","US":"🇺🇸"}

    $scope.wrongnumber = false;

    if (storage.user){
        $scope.user = JSON.parse(storage.user);
    } else {
        $scope.user = {};
    }
    if (storage.phoneCode){
        $scope.phoneCode = JSON.parse(storage.phoneCode)
    } else if (storage.contract){
        var key = countrycode[JSON.parse(storage.contract).country]
        var number = {
            'icon' : countryflag[key],
            'name' : countrynumber[key]
        }
        $scope.phoneCode = number;
    }

    console.log("phoneCode :", $scope.phoneCode)
    
    $scope.number_list = [];
    for(key in countrynumber){
        var number = {
            'icon' : countryflag[key],
            'name' : countrynumber[key]
        }
        $scope.number_list.push(number);
    }
    
    $scope.appversion = storage.version;

    $scope.$on("$ionicView.beforeEnter", function(event, data){
        if(typeof analytics !== 'undefined') {analytics.track("APP :" + $ionicHistory.currentStateName());}
        Globales.getUser(storage.token).then(function(data) {
            storage.user = JSON.stringify(data);
            Saving.save(null);
            $scope.user = data;
        });

        try {
            cordova.getAppVersion.getVersionNumber().then(function (version) {
                storage.version = version;
                Saving.save(null);
                $scope.appversion = version;
            });
        }
        catch(err){
            $scope.appversion = $translate.instant("UNDEFINED");
            console.log(err);
        }
        
    });

    $scope.back = function(){
      console.log("back");
      window.history.go(-1);
    };
        
    $scope.resetPwd = function(){
        $cordovaDialogs.confirm($translate.instant("AREYOUSURERESET"), $translate.instant("RESETPSW")).then(function(result){
            if(result==1){
                Globales.resetPSW(storage.Email).then(function(data){
                    if (data==0){
                        console.log("email not sent");
                        $cordovaDialogs.alert($translate.instant("ERROROCCURRED"), $translate.instant("RESETPSW"));
                    } else {
                        console.log("email sent");
                        $cordovaDialogs.alert($translate.instant("YOUWILLRECEIVEAMAILSOON"), $translate.instant("RESETPSW"));
                    }
                })
            }
        });
    }

    $scope.resetEmail = function(){
        $cordovaDialogs.confirm($translate.instant("PLEASECONTACTUS"), $translate.instant("CHANGEEMAIL")).then(function(result){
            if(result==1){
                var initialMessage = $translate.instant("CHANGEEMAILMESSAGE");
                intercom.displayMessageComposerWithInitialMessage(initialMessage)
            }
        });
    }

    $scope.save = function(){
        console.log($scope.user);
        $scope.user.phone = reformatNumber();
        if ($scope.wrongnumber == true){
            $cordovaDialogs.alert($translate.instant("WRONGNUMBER"), "OK");
            return;
        }
        Globales.setUser(storage.token, $scope.user).then(function(resp){
            if (resp == 0){
                $cordovaDialogs.alert($translate.instant("ERROROCCURRED"), "OK");
            } else {
                console.log($scope.user);
                storage.user = JSON.stringify($scope.user);
                storage.phoneCode = JSON.stringify($scope.phoneCode);
                Saving.save(null);
                try{window.plugins.toast.showLongBottom($translate.instant("SAVEDONE"))}catch(err){}    
            }
        })

    }



    var reformatNumber = function(){
        console.log("reformatnumber : ", $scope.user.phone)
        if ($scope.user.phone[0]=='+'){
            console.log("reformatnumber : ", $scope.user.phone)
            console.log("reformatnumber : ", flagcountry[$scope.phoneCode.icon])
            $scope.user.phone = $scope.user.phone.slice(3);
        }
        console.log("reformatnumber : ", $scope.user.phone)
        console.log(libphonenumber.parseNumber(String($scope.user.phone), flagcountry[$scope.phoneCode.icon]))
        if(Object.keys(libphonenumber.parseNumber(String($scope.user.phone), flagcountry[$scope.phoneCode.icon])).length === 0 && 
            libphonenumber.parseNumber(String($scope.user.phone), flagcountry[$scope.phoneCode.icon]).constructor === Object){
            console.log("here")
            $scope.wrongnumber = true;
        } else {
            $scope.wrongnumber = false;
        }
        try {
            return libphonenumber.formatNumber(libphonenumber.parseNumber(String($scope.user.phone), flagcountry[$scope.phoneCode.icon]), 'E.164');
        } catch(err){
            console.log(err)
            return $scope.user.phone
        }
        
    }

    var swap = function(json){
          var ret = {};
          for(var key in json){
            ret[json[key]] = key;
          }
          return ret;
    }

    var flagcountry = swap(countryflag);

    $scope.updateCountry = function(){
        console.log("updateCountry")
        console.log("updateCountry : ", flagcountry)
        console.log("updateCountry : ", $scope.phoneCode.icon)
        console.log("updateCountry : ", flagcountry[$scope.phoneCode.icon])
        $scope.user.phone = reformatNumber();
        console.log("updateCountry : ", $scope.user.phone)
    }

}
]);