// Initialize the helpers class¬
gViz.shared.data.api = {

  // Get data from API
  resolvedFetch: function(data) {
    return $.Deferred().resolve(data).promise();
  },

  // Get data from API
  fetch: function(appliance, startDate, endDate, precision, timeout, testAppliance, apiKey, registrationToken, endPointing) {

    var defer = $.Deferred();

    // console.log("API Dates: ", new Date(parseInt(`${startDate}000`)), new Date(parseInt(`${endDate}000`)));

    $.ajax({
      url: endPointing+"?start_date="+startDate+"&appliance="+appliance+"&end_date="+endDate+"&precision="+precision,
      beforeSend: function(xhr) {
        xhr.setRequestHeader("X-API-Key", apiKey);
        xhr.setRequestHeader("Authorization", registrationToken);
      },
      type: 'GET',
      dataType: 'json',
      contentType: 'application/json',
      processData: false,
      timeout: timeout == null ? 15000 : timeout,
      success: function (data) {
        if(testAppliance != null) { data.appliance = testAppliance; }
        defer.resolve(data);
      },
      error: function(req, status, err) {
        console.log(err);
        defer.reject(err);
      }
    });

    return defer.promise();
  }

};
