// Module declaration
gViz.shared.modules.consumption = function() {
  "use strict";

  // Get attributes values
  var _var = {};
  var translate = null;
  var registrationToken = "Token eyJhbGciOiJIUzI1NiIsImlhdCI6MTUyMDM1NDEwNywiZXhwIjoxNzQxMTA2MTA3fQ.eyJpZCI6NDQzfQ.toDSii_S1yX7zi1QgEJOKkeBilENLl_R40Z1-ZbtmOY";
  var apiKey = "af144b1eb71729a60a92b0eb7f3983d9fac7629421167d6c5bab8d7d7b64438f";
  var container = ".cons-graph";
  var endPointing = "https://app2.getluko.com/v1/consumption";
  var language = "en-US";
  var chartType = null;
  var appliance = 'all';
  var isForecast = true;
  var promises = [];
  var priceFunction = null;
  var lineColors = null;
  var lineTransparency = null;
  var timeActive = 1;
  var graphActive = 0;
  var zoomLevel = 1;
  var menuItems = null;

  // Actions
  var menuClick = function(id) { console.log('Clicked: ', id); }
  var onChange = function(change) { console.log(change); }

  // Validate attributes
  var validate = function (step) {
    switch (step) {
      case 'build': return true;
      default: return false;
    }
  };

  // Main function
  var main = function (step) {

    // Validate attributes if necessary
    if (validate(step)) {

      switch (step) {

        // Build entire visualizations
        case 'build':

          // Initialize _var
          if(_var == null) { _var = {}; }

          // Update translation language
          if(translate != null) {  gViz.shared.helpers.date.setLocale(translate.use()); }

           // Get container
          _var.container = {
            selector: container,
            d3: d3.select(container),
            el: ((typeof container === 'string' || container instanceof String) ? container : d3.select(container).node()),
            clientRect: d3.select(container).node().getBoundingClientRect(),
            dimensions: {}
          };

          // Set container position to relative
          _var.container.d3.style('position', 'relative');

          // Draw outer wrapper
          _var.outerWrap = _var.container.d3.selectAll('.gViz-outer-wrapper').data(["outer-wrapper"], d => d);
          _var.outerWrap.exit().remove();
          _var.outerWrap = _var.outerWrap.enter().append("div").attr('class', 'gViz-outer-wrapper').merge(_var.outerWrap);

          // Draw inner wrapper
          _var.innerWrap = _var.outerWrap.selectAll('.gViz-inner-wrapper').data(["inner-wrapper"], d => d);
          _var.innerWrap.exit().remove();
          _var.innerWrap = _var.innerWrap.enter().append("div").attr('class', 'gViz-inner-wrapper').merge(_var.innerWrap);

          // Loading
          _var.loading = _var.container.d3.selectAll('.loading-wrapper').data(["loading"], d => d);
          _var.loading.exit().remove();
          _var.loading = _var.loading.enter().append("div").attr('class', 'loading-wrapper').merge(_var.loading);

          // Transparent menu bottom
          _var.transMenu = _var.container.d3.selectAll('.time-selecter-scroller-bottom').data(["transparent-menu"], d => d);
          _var.transMenu.exit().remove();
          _var.transMenu = _var.transMenu.enter().append("div").attr('class', 'time-selecter-scroller-bottom').merge(_var.transMenu);

          // Set menu items
          var items = [
            { value: 0, id: 'NOW', translate: 'NOW', name: 'NOW' },
            { value: 1, id: 'TODAY', translate: 'TODAY', name: 'TODAY' },
            { value: 2, id: '7DAYS', translate: '7DAYS', name: '7 DAYS' },
            { value: 3, id: '30DAYS', translate: '30DAYS', name: '30 DAYS' },
            { value: 4, id: 'YEAR', translate: 'THISYEAR', name: 'THIS YEAR' }
          ];

          // Draw menu
          _var.menu = _var.container.d3.selectAll('.time-selecter-scroller').data(["menu"], d => d);
          _var.menu.exit().remove();
          _var.menu = _var.menu.enter().append("ul").attr('class', 'time-selecter-scroller').merge(_var.menu);
          _var.menu.each(function(d) {

            // Add translate for today date on d3 date
            gViz.shared.helpers.date.translated.today = translate != null ? (translate.instant(items[1].translate) || items[1].name) : items[1].name;

            // Add translation for DATEORDER on d3 date
            gViz.shared.helpers.date.translated.DATEORDER = {};
            items.forEach(function(d) {
              var t = translate != null ? translate.instant('DATEORDER-'+d.translate) : 'default';
              gViz.shared.helpers.date.translated.DATEORDER[d.translate] = t == null || t === '' ? 'default' : t;
            });

            // Get only active items
            var activeItems = items.filter(d => menuItems == null || (menuItems[d.id] != null && menuItems[d.id].active != null && menuItems[d.id].active == true))

            // Set timeActive depending on selection
            if(activeItems.length === 0) { timeActive = -2; }
            else if(activeItems.filter(d => d.value == 1).length === 0) { timeActive = activeItems[0].value; }

            // Draw menu items
            _var.menuItem = d3.select(this).selectAll('.time-selecter').data(activeItems, d => d.id);
            _var.menuItem.exit().remove();
            _var.menuItem = _var.menuItem.enter().append("div").attr('class', 'time-selecter').merge(_var.menuItem);
            _var.menuItem
              .attr('data-id', function(d) { return d.value; })
              .style('text-transform', 'uppercase')
              .text(function(d) { return translate != null ? (translate.instant(d.translate) || d.name) : d.name; })
              .on('click', function(d) {

                // Trigger on click function
                onChange({ type: 'menu', event: 'click', value: d.value, name: d.name, translate: d.translate });

                // Set time active to the clicked id
                timeActive = d.value;

                // Update Menu
                _var.update('menu', d.value);

                // Update charts
                if(graphActive == 0 || graphActive == 1){ _var.update('chart', d.value); }

                // Menu Click callback function
                menuClick(d.value);

              }).classed('time-selected', function(d) { return timeActive == d.value; })

          });

          // Initialize data
          _var.gVizBarData  = {};
          _var.gVizBubbleData  = {};

          // Get data from api
          _var.gVizLineData = window.gViz.shared.data.lineChart.format([]);
          _var.gVizBarData[timeActive.toString()] = window.gViz.shared.data.barChart.format();
          _var.gVizBubbleData  = window.gViz.shared.data.bubbleChart.format();

          // Initialize variables for charts
          _var.lineChart = null;
          _var.barChart = null;
          _var.bubbleChart = null;
          _var.setTimeIntervalFunction = null;
          _var.isNow = true;
          _var.barChartViewMode = "day";
          _var.bubbleChartViewMode = "day";

          // Promises
          var promises = [];

          // Add points to line chart function
          _var.barAddPoints = function(x, direction) {

            // Do nothing if no direction
            if(direction !== 'none') {

              // Trigger on click function
              onChange({ type: 'bar', event: 'drag', x: x, direction: direction });

              // Show loading
              window.gViz.shared.helpers.loading.show('.loading-wrapper');

              // Fetch data from API
              var timeDef = (new Date()).getTime();
              promises.push(timeDef);
              window.gViz.shared.data.barChart.fetch(_var.barChartViewMode, x.x, direction, appliance, isForecast, apiKey, registrationToken, endPointing)
              .then(function() {

                var timeDefIndex = promises.indexOf(timeDef);
                if(promises.length > 0 && timeDefIndex === promises.length-1) {

                  // Parse new data
                  if(direction === 'next') {
                    _var.gVizBarData[timeActive.toString()].data = _var.gVizBarData[timeActive.toString()].data.slice(1).concat(this._data[this._data.length-1] || []);
                  } else if(direction === 'prev') {
                    _var.gVizBarData[timeActive.toString()].data = (this._data || []).concat(_var.gVizBarData[timeActive.toString()].data);
                    _var.gVizBarData[timeActive.toString()].data.pop();
                  }

                  // Draw bar chart
                  drawBarChart();

                  // Clean promises array
                  promises = [];

                  // Hide loading
                  window.gViz.shared.helpers.loading.hide('.loading-wrapper');

                } else if(timeDefIndex !== -1) { promises.splice(timeDefIndex, 1); }

              }).fail(function(err) {

                var timeDefIndex = promises.indexOf(timeDef);
                if(promises.length > 0 && timeDefIndex === promises.length-1) {
                  drawBarChart();
                  promises = [];
                  window.gViz.shared.helpers.loading.hide('.loading-wrapper');
                } else if(timeDefIndex !== -1) { promises.splice(timeDefIndex, 1); }
              });

            }
          }

          // Add points to line chart function
          _var.lineAddPoints = function(x, direction) {

            setTimeout(function() {

              // // Do nothing if no direction
              if(direction !== 'none') {

                // Get informations
                var zoomInfo = gViz.shared.data.lineChart.zoomLevelInfo(zoomLevel);
                var now = (new Date()).getTime();

                // Trigger on click function
                onChange({ type: 'line', event: direction === 'zoom' ? 'zoom' : 'drag', x: x, direction: direction });

                // Reset dates for zoom direction
                if(direction === 'zoom') {

                  // Get dates
                  var midDate = new Date((x.end.getTime() + x.start.getTime())/2)
                  var startDate = new Date(midDate.getTime() - 1.5 * zoomInfo.interval * 1000);
                  var endDate = new Date() <= new Date(midDate.getTime() + 1.5 * zoomInfo.interval * 1000) ? new Date() : new Date(midDate.getTime() + 1.5 * zoomInfo.interval * 1000);
                  _var.gVizLineData.data[0].values = []

                  // Set is now
                  _var.isNow = now <= (new Date(endDate.getTime())).addSeconds(zoomInfo.seconds).getTime();

                  if(_var.isNow) { startDate = new Date(endDate.getTime() - 3 * zoomInfo.interval * 1000); }

                // Get time depending on direction
                } else {

                  // Get dates
                  var startDate = direction === 'prev' ? (new Date(x)).addSeconds(-zoomInfo.interval) : new Date(x);
                  var endDate = direction === 'prev' ? new Date(x) : new Date(Math.min(now, (new Date(x)).addSeconds(zoomInfo.interval).getTime()));

                  // Set is now
                  _var.isNow = now <= (new Date(endDate.getTime())).addSeconds(zoomInfo.seconds).getTime();
                }

                // Show loading
                window.gViz.shared.helpers.loading.show('.loading-wrapper');

                // Fetch data from api
                var timeDef = (new Date()).getTime();
                promises.push(timeDef);
                gViz.shared.data.lineChart.fetch(startDate, endDate, appliance, zoomLevel, apiKey, registrationToken, endPointing)
                .then(function(data) {

                  var timeDefIndex = promises.indexOf(timeDef);
                  if(promises.length > 0 && timeDefIndex === promises.length-1) {

                    // Parse new data from api
                    data.consumption.t.forEach(function(d, i) {
                      var point = window.gViz.shared.data.lineChart.parse([{ x: parseInt(`${d}000`), y: data.consumption.w[i] }])[0];;
                      if(direction === 'next' || direction === 'zoom') { _var.gVizLineData.data[0].values.push(point); }
                      else if(direction === 'prev') { _var.gVizLineData.data[0].values = [point].concat(_var.gVizLineData.data[0].values); }
                    });

                    // Filter unique values
                    _var.gVizLineData.data[0].values = gViz.shared.helpers.array.unique(_var.gVizLineData.data[0].values, 'x')
                    _var.gVizLineData.data[0].values = gViz.shared.helpers.array.sorted(_var.gVizLineData.data[0].values, 'x', 'ascending');

                    // Reduce number of points
                    if(direction !== 'zoom' && _var.gVizLineData.data[0].values.length > zoomInfo.max) {
                      if(direction==='next') {
                        var length = _var.gVizLineData.data[0].values.length;
                        _var.gVizLineData.data[0].values = _var.gVizLineData.data[0].values.slice(length-zoomInfo.max, length);
                      } else if(direction==='prev') {
                        _var.gVizLineData.data[0].values = _var.gVizLineData.data[0].values.slice(0,zoomInfo.max);
                      }
                    }

                    // Draw line chart
                    drawLineChart();

                    // Start updating real time
                    if(_var.isNow) { lineStartNow(_var.gVizLineData.data[0].values[_var.gVizLineData.data[0].values.length-1].x); }

                    // Clean promises array
                    promises = [];

                    // Hide loading
                    window.gViz.shared.helpers.loading.hide('.loading-wrapper');

                  }

                }).fail(function(err) {

                  var timeDefIndex = promises.indexOf(timeDef);
                  if(promises.length > 0 && timeDefIndex === promises.length-1) {
                    drawLineChart();
                    promises = [];
                    window.gViz.shared.helpers.loading.hide('.loading-wrapper');
                  } else if(timeDefIndex !== -1) { promises.splice(timeDefIndex, 1); }

                });

              }

            }, 300);
          }

          // Stop getting real time data
          var lineStopNow = function() { clearInterval(_var.setTimeIntervalFunction); }

          // Start getting real time data
          var lineStartNow = function(x) {

            // Stop real time before starting the interval
            lineStopNow();

            var getDataOnInterval = function() {

              // Get zoomLevelInfo
              var zoomInfo = gViz.shared.data.lineChart.zoomLevelInfo(zoomLevel);

              // If x is null, get time from 30 seconds before
              var startDate = x == null || new Date(x) >= new Date() ? (new Date()).addSeconds(-zoomInfo.interval) : new Date(x);
              var endDate = new Date();
              var lastPoint = _var.gVizLineData.data[0].values[_var.gVizLineData.data[0].values.length-1];

              // Fetch points only If the last point is desired seconds before now
              if(lastPoint == null || endDate.getTime() - lastPoint.parsedX.getTime() > zoomInfo.seconds * 1000) {

                // Trigger on click function
                onChange({ type: 'line', event: 'fetch-real-time-data', x: startDate, direction: 'next' });

                // Show loading
                window.gViz.shared.helpers.loading.show('.loading-wrapper');

                // Fetch data from api
                var timeDef = (new Date()).getTime();
                promises.push(timeDef);
                gViz.shared.data.lineChart.fetch(startDate, endDate, appliance, zoomLevel, apiKey, registrationToken, endPointing)
                .then(function(data) {

                  var timeDefIndex = promises.indexOf(timeDef);
                  if(promises.length > 0 && timeDefIndex === promises.length-1) {

                    // Parse new data from api
                    data.consumption.t.forEach(function(d, i) {
                      var point = window.gViz.shared.data.lineChart.parse([{ x: parseInt(`${d}000`), y: data.consumption.w[i] }])[0];;
                      _var.gVizLineData.data[0].values.push(point);
                    });

                    // Filter unique values
                    _var.gVizLineData.data[0].values = gViz.shared.helpers.array.unique(_var.gVizLineData.data[0].values, 'x');
                    _var.gVizLineData.data[0].values = gViz.shared.helpers.array.sorted(_var.gVizLineData.data[0].values, 'x', 'ascending');

                    // Reduce number of points
                    if(_var.gVizLineData.data[0].values.length > zoomInfo.max) {
                      var length = _var.gVizLineData.data[0].values.length;
                      _var.gVizLineData.data[0].values = _var.gVizLineData.data[0].values.slice(length-zoomInfo.max, length);
                    }

                    // Draw line chart
                    drawLineChart();

                    // Update x
                    var lastPoint = _var.gVizLineData.data[0].values[_var.gVizLineData.data[0].values.length-1];
                    x = lastPoint == null ? x : lastPoint.parsedX.getTime();

                    // Clean promises array
                    promises = [];

                    // Hide loading
                    window.gViz.shared.helpers.loading.hide('.loading-wrapper');

                  }

                }).fail(function(err) {

                  var timeDefIndex = promises.indexOf(timeDef);
                  if(promises.length > 0 && timeDefIndex === promises.length-1) {

                    // Update x
                    var lastPoint = _var.gVizLineData.data[0].values[_var.gVizLineData.data[0].values.length-1];
                    x = lastPoint == null ? x : lastPoint.parsedX.getTime();

                    // Draw line chart
                    drawLineChart();

                    // Clean promises array
                    promises = [];

                    // Hide loading
                    window.gViz.shared.helpers.loading.hide('.loading-wrapper');

                  } else if(timeDefIndex !== -1) { promises.splice(timeDefIndex, 1); }

                });
              }
            }

            // Set time interval
            getDataOnInterval();
            _var.setTimeIntervalFunction = setInterval(function() {
              getDataOnInterval();
            }, 3000);
          }

          _var.lineHandleZoom = function(x, direction) {

            lineStopNow();

            // Update zoom direction
            zoomLevel += direction === 'up' ? (1) : (-1);

            // Bounded zoom level
            if(zoomLevel <= -2) { zoomLevel = -2; }
            else if(zoomLevel >= 5) { zoomLevel = 5; }

            // Add points for zoom direction
            _var.lineAddPoints(x, 'zoom');

          }

          // Draw line chart
          var drawLineChart = function(){

            // Set unit for line chart data specified on the menuItems
            gViz.shared.data.lineChart.setUnit(_var.gVizLineData, (menuItems['NOW'] != null && menuItems['NOW'].unit != null && menuItems['NOW'].unit.trim().length != 0 ? menuItems['NOW'].unit : null));


            // Draw line chart
            _var.lineChart = gViz.viz.lineAreaChart()
              ._var(_var.lineChart)
              .container(d3.select(".cons-graph .gViz-outer-wrapper .gViz-inner-wrapper").node())
              .colors(lineColors)
              .data(_var.gVizLineData)
              .isNow(_var.isNow)
              .opacity(lineTransparency)
              .zoomMode('horizontal') // horizontal or vertical
              .zoomLevel(zoomLevel) // horizontal or vertical
              .yZoom({
                fn: function(x, direction) { },
                enable: true,
                transform: ( _var.lineChart == null ? null : _var.lineChart.yZoom.transform )
              })
              .xZoom({
                fn: function(x, direction) { _var.isNow = false; lineStopNow(); _var.lineAddPoints(x, direction); },
                enable: true,
                transform: ( _var.lineChart != null && _var.lineChart.xZoom != null ? _var.lineChart.xZoom.transform : null )
              })
              .wheelZoom({
                fn: function(x, direction) { _var.lineHandleZoom(x, direction); },
                x: {
                  start: _var.lineChart != null && _var.lineChart.wheelZoom != null && _var.lineChart.wheelZoom.x != null && _var.lineChart.wheelZoom.x.start != null ? _var.lineChart.wheelZoom.x.start : null,
                  end: _var.lineChart != null && _var.lineChart.wheelZoom != null && _var.lineChart.wheelZoom.x != null && _var.lineChart.wheelZoom.x.end != null ? _var.lineChart.wheelZoom.x.end : null
                }
              })
              .build()

          }

          // Handble bar chart click
          var handleBarChartClick = function(node){

            var xLabel, xValue, xSplit, weekValue;

            // Remove all inserted menu items
            d3.select('.time-selecter-scroller').selectAll(".time-selecter[data-mode='inserted']").remove()

            if(_var.barChartViewMode === 'day') {

              // Get x value for next draw
              xValue = d3.timeParse("%Y-%m-%d %H")(`${node.parent} ${parseInt(node.x) + 1}`);

              // Trigger on click function
              onChange({ type: 'bar', currentView: 'day', nextView: 'now',  event: 'bar-click', x: xValue });

              // Change functions
              _var.setLineChartView(xValue);
              menuClick(0);
              _var.update('menu', 0);

            } else if (_var.barChartViewMode === 'week') {

              // Get x value for next draw
              xSplit = node.parent.split('-');
              xValue = d3.timeParse("%Y-%m-%d")(node.parent);
              xLabel = d3.timeParse("%Y-%m-%d")(node.parent);
              weekValue = window.gViz.shared.helpers.date.getWeekDayNumberFromMonday(node.x);

              if(xValue != null) {

                var value = xValue.addDays(weekValue);
                var label = xLabel.addDays(weekValue);

                if(d3.timeFormat("%b %d, %Y")(label) === d3.timeFormat("%b %d, %Y")(new Date())) {

                  // Trigger on click function
                  onChange({ type: 'bar', currentView: 'week', nextView: 'day',  event: 'bar-click', x: 'today', translate: 'TODAY' });

                  // Update Menu
                  _var.update('menu', 1);

                  // Update charts
                  _var.update('chart', 1);

                  // Menu Click callback function
                  menuClick(1);

                } else {

                  // Trigger on click function
                  onChange({ type: 'bar', currentView: 'week', nextView: 'day',  event: 'bar-click', x: xValue });

                  // Initialize bar chart for TODAY perspective
                  _var.setBarChartView('day', d3.timeFormat("%Y-%m-%d")(value), 'both');

                  // Add item to menu
                  _var.update('menu', -1);
                  var isCurrentYear = label.getYear() === (new Date()).getYear();
                  d3.select('.time-selecter-scroller').insert('li', ".time-selecter[data-id='2']")
                    .attr('class', 'time-selecter time-selected')
                    .attr('data-mode', 'inserted')
                    .html(d3.timeFormat("%b %d" + (isCurrentYear ? "" : ", %Y"))(label))
                    .on('click', function() {
                      _var.update('menu', -1);
                      _var.setBarChartView('day', d3.timeFormat("%Y-%m-%d")(value), 'both');
                      d3.select(this).classed('time-selected', true);
                    })
                    .style('opacity', 0)
                    .transition().duration(700)
                      .style('opacity', 1)
                }
              }

            } else if (_var.barChartViewMode === 'month') {

              // Get x value for next draw
              xSplit = node.parent.split('-');
              xValue = d3.timeParse("%Y-%m-%d")(`${xSplit[0]}-${xSplit[1]}-${node.x}`);
              xLabel = d3.timeParse("%Y-%m-%d")(`${xSplit[0]}-${xSplit[1]}-${node.x}`);

              if(xValue != null) {

                var value = xValue;

                if(d3.timeFormat("%b %d, %Y")(xLabel) === d3.timeFormat("%b %d, %Y")(new Date())) {

                  // Trigger on click function
                  onChange({ type: 'bar', currentView: 'month', nextView: 'day',  event: 'bar-click', x: 'today', translate: 'TODAY' });

                  // Update Menu
                  _var.update('menu', 1);

                  // Update charts
                  _var.update('chart', 1);

                  // Menu Click callback function
                  menuClick(1);

                } else {

                  // Trigger on click function
                  onChange({ type: 'bar', currentView: 'month', nextView: 'day',  event: 'bar-click', x: xValue });

                  // Initialize bar chart for TODAY perspective
                  _var.setBarChartView('day',d3.timeFormat("%Y-%m-%d")(value), 'both');

                  // Add item to menu
                  _var.update('menu', -1);
                  var isCurrentYear = xLabel.getYear() === (new Date()).getYear();
                  d3.select('.time-selecter-scroller').insert('li', ".time-selecter[data-id='2']")
                    .attr('class', 'time-selecter time-selected')
                    .attr('data-mode', 'inserted')
                    .html(d3.timeFormat("%b %d" + (isCurrentYear ? "" : ", %Y"))(xLabel))
                    .on('click', function() {
                      _var.update('menu', -1);
                      _var.setBarChartView('week', d3.timeFormat("%Y-%m-%d")(value), 'both');
                      d3.select(this).classed('time-selected', true);
                    })
                    .style('opacity', 0)
                    .transition().duration(700)
                      .style('opacity', 1)
                }
              }

            } else if (_var.barChartViewMode === 'year') {

              // Get x value for next draw
              xValue = d3.timeParse("%b-%Y")(`${node.x}-${node.parent}`);
              xLabel = d3.timeParse("%b-%Y")(`${node.x}-${node.parent}`);

              if(xValue != null) {

                var value = xValue;

                if(d3.timeFormat("%b, %Y")(xLabel) === d3.timeFormat("%b, %Y")(new Date())) {

                  // Trigger on click function
                  onChange({ type:'bar', currentView:'year', nextView:'month',  event:'bar-click', x:xValue, translate:'THISMONTH' });

                  // Update Menu
                  _var.update('menu', 3);

                  // Update charts
                  _var.update('chart', 3);

                  // Menu Click callback function
                  menuClick(3);

                } else {

                  // Trigger on click function
                  onChange({ type: 'bar', currentView: 'year', nextView: 'month',  event: 'bar-click', x: xValue });

                  // Initialize bar chart for TODAY perspective
                  _var.setBarChartView('month',d3.timeFormat("%Y-%m-%d")(value), 'both');

                  // Add item to menu
                  _var.update('menu', -1);
                  var isCurrentYear = xLabel.getYear() === (new Date()).getYear();
                  d3.select('.time-selecter-scroller').insert('li', ".time-selecter[data-id='4']")
                    .attr('class', 'time-selecter time-selected')
                    .attr('data-mode', 'inserted')
                    .style('opacity', 0)
                    .html(d3.timeFormat("%b" + (isCurrentYear ? "" : ", %Y"))(xLabel))
                    .on('click', function() {
                      _var.update('menu', -1);
                      _var.setBarChartView('month', d3.timeFormat("%Y-%m-%d")(value), 'both');
                      d3.select(this).classed('time-selected', true);
                    })
                    .transition().duration(700)
                      .style('opacity', 1)
                }
              }

            }

            return;
          }

          // Draw bar chart
          var drawBarChart = function(){

            // Set unit for line chart data specified on the menuItems
            var menuItem = menuItems[items.filter(d => d.value === timeActive)[0].id];
            gViz.shared.data.barChart.setUnit(_var.gVizBarData[timeActive.toString()], (menuItem != null && menuItem.unit != null && menuItem.unit.trim().length != 0 ? menuItem.unit : null));

            // Draw bar chart
            _var.barChart = gViz.viz.barChart()
              ._var(_var.barChart)
              .container(d3.select(".cons-graph .gViz-outer-wrapper .gViz-inner-wrapper").node())
              .data(_var.gVizBarData[timeActive.toString()])
              .onClick(handleBarChartClick)
              .priceFunction(priceFunction)
              .zoom({
                fn: function(x, direction) { _var.barAddPoints(x, direction); },
                enable: true,
                transform: ( _var.barChart == null ? null : _var.barChart.zoom.transform ),
                startPoint: _var.gVizBarData[timeActive.toString()].data != null && _var.gVizBarData[timeActive.toString()].data.length === 3 ? _var.gVizBarData[timeActive.toString()].data[1].x : null
              })
              .build()

          }

          // Draw bar chart depending on option
          _var.setBarChartView = function(mode, x, direction) {

            // Set chart type
            chartType = 'bar';

            // Remove tooltip when view changed
            d3.selectAll('.gViz-tooltip').remove();

            _var.barChartViewMode = mode;

            // Stop line chart from getting real data
            lineStopNow();

            // Clear previous bar chart
            d3.selectAll(".cons-graph .gViz-outer-wrapper .gViz-inner-wrapper").selectAll("svg").remove();

            // Reset bar chart
            _var.barChart = null;
            _var.gVizBarData[timeActive.toString()] = window.gViz.shared.data.barChart.format();

            // Show loading
            window.gViz.shared.helpers.loading.show('.loading-wrapper');

            // Fetch data from API
            var timeDef = (new Date()).getTime();
            promises.push(timeDef);
            window.gViz.shared.data.barChart.fetch(_var.barChartViewMode, x, direction, appliance, isForecast, apiKey, registrationToken, endPointing).then(function() {

              var timeDefIndex = promises.indexOf(timeDef);
              if(promises.length > 0 && timeDefIndex === promises.length-1) {

                // Update barWidth
                var interval = _var.barChartViewMode === 'day' ? 24 : (_var.barChartViewMode === 'week' ? 7 : (_var.barChartViewMode === 'month' ? 31 : 12));
                var range = d3.select(".cons-graph .gViz-outer-wrapper .gViz-inner-wrapper").node().getBoundingClientRect().width;
                var step = range / (0.9 + interval);
                _var.gVizBarData[timeActive.toString()].attrs.barWidth = 0.9 * step;

                // Store data
                _var.gVizBarData[timeActive.toString()].data = this != null && this._data != null ? this._data : [];

                // Draw bar chart
                drawBarChart();

                // Clean promises array
                promises = [];

                // Hide loading
                window.gViz.shared.helpers.loading.hide('.loading-wrapper');

              }


            }).fail(function(err) {

              console.log(err);

              var timeDefIndex = promises.indexOf(timeDef);
              if(promises.length > 0 && timeDefIndex === promises.length-1) {
                drawBarChart();
                promises = [];
                window.gViz.shared.helpers.loading.hide('.loading-wrapper');
              } else if(timeDefIndex !== -1) { promises.splice(timeDefIndex, 1); }

            });

          }

          // Draw line chart depending on option
          _var.setLineChartView = function(x) {

            // Set chart type
            chartType = 'line';

            // Remove tooltip when view changed
            d3.selectAll('.gViz-tooltip').remove();

            // Clear previous bar chart
            d3.selectAll(".cons-graph .gViz-outer-wrapper .gViz-inner-wrapper").selectAll("svg").remove();

            // Reset line chart
            _var.lineChart = null;
            _var.gVizLineData = window.gViz.shared.data.lineChart.format([]);

            // Stop line real time
            lineStopNow();

            // If its now
            if(x == null || x >= new Date()) {

              _var.isNow = true;

              // Draw line chart
              drawLineChart();

              // Draw line chart on real time mode
              lineStartNow();

            } else {

              // Add previous points
              _var.lineAddPoints(x, 'prev');

              // Draw line chart
              drawLineChart();

            }

          }

          // Draw bubble chart
          var drawBubbleChart = function(){

            // Draw bubble chart
            _var.bubbleChart = gViz.viz.bubbleChart()
              ._var(_var.bubbleChart)
              .container(d3.select(".cons-graph .gViz-outer-wrapper .gViz-inner-wrapper").node())
              .data(_var.gVizBubbleData)
              .onClick(handleBubbleChartClick)
              .build()

          }

          var handleBubbleChartClick = function(d) {

            // Trigger on click function
            onChange({ type: 'bubble', currentView: _var.bubbleChartViewMode, event: 'bubble-click', id: d.id, obj: d });

          }

          // Draw bar chart depending on option
          _var.setBubbleChartView = function(mode, x, direction) {

            // Set chart type
            chartType = 'bubble';

            // Remove tooltip when view changed
            d3.selectAll('.gViz-tooltip').remove();

            _var.bubbleChartViewMode = mode;

            // Stop line chart from getting real data
            lineStopNow();

            // Clear previous bubble chart
            d3.selectAll(".cons-graph .gViz-outer-wrapper .gViz-inner-wrapper").selectAll("svg:not(.bubble-chart)").remove();

            // Reset bubble chart
            //_var.bubbleChart = null;
            _var.gVizBubbleData = window.gViz.shared.data.bubbleChart.format();

            // Show loading
            window.gViz.shared.helpers.loading.show('.loading-wrapper');

            // Fetch data from API
            var timeDef = (new Date()).getTime();
            promises.push(timeDef);
            window.gViz.shared.data.bubbleChart.fetch(_var.bubbleChartViewMode, x, direction, appliance, isForecast, apiKey, registrationToken, endPointing).then(function() {

              var timeDefIndex = promises.indexOf(timeDef);
              if(promises.length > 0 && timeDefIndex === promises.length-1) {

                // Store data
                _var.gVizBubbleData.data = this._data || [];

                // Draw bubble chart
                drawBubbleChart();

                // Clean promises array
                promises = [];

                // Hide loading
                window.gViz.shared.helpers.loading.hide('.loading-wrapper');

              }

            }).fail(function(err) {

              var timeDefIndex = promises.indexOf(timeDef);
              if(promises.length > 0 && timeDefIndex === promises.length-1) {
                drawBubbleChart();
                promises = [];
                window.gViz.shared.helpers.loading.hide('.loading-wrapper');
              } else if(timeDefIndex !== -1) { promises.splice(timeDefIndex, 1); }

            });

          }

          // Set onChange function to be fired
          _var.on_change = function(value) {
            onChange = value;
          }

          // Reset and update menu items :: element = ['menu','chart']
          _var.update = function(element='chart', id=1) {

            // Update menu
            if(element == 'menu') {

              // Reset and Update menu for the correct time period
              d3.selectAll(".time-selecter-scroller .time-selecter").classed('time-selected', false);
              d3.selectAll(`.time-selecter-scroller .time-selecter[data-id='${id}']`).classed('time-selected', true);

              // Remove all inserted items on menu if the click is on the default items
              if(id !== -1) {

                d3.selectAll(".time-selecter-scroller .time-selecter[data-mode='inserted']").transition()
                  .duration(700)
                  .style('opacity', 0)
                  .on('end', function() { d3.select(this).remove(); });

              }

            // Update chart
            } else if(element == 'chart') {

              // NOW :: Draw line chart
              if(id==0 && (menuItems == null || (menuItems['NOW'] != null && menuItems['NOW'].active != null && menuItems['NOW'].active === true))) {

                // Fetch all data if not initialized
                if(_var.lineInitialized == null) {

                  // Show loading
                  window.gViz.shared.helpers.loading.show('.loading-wrapper');

                  // Fetch data from API
                  window.gViz.shared.data.lineChart
                    .fetch(null, new Date(), appliance, zoomLevel, apiKey, registrationToken,  endPointing)
                    .then(function() {

                      // Get today option
                      _var.setLineChartView(null);

                      // Update initialized flag to avoid future caching
                      _var.lineInitialized = true;

                      // Show loading
                      window.gViz.shared.helpers.loading.hide('.loading-wrapper');

                    });

                } else {

                  // Get today option
                  _var.setLineChartView(null);

                }

              // TODAY :: Draw bar chart and get other informations
              } else if (id==1 && (menuItems == null || (menuItems['TODAY'] != null && menuItems['TODAY'].active != null && menuItems['TODAY'].active === true))) {
                if(graphActive === 0) {

                  // Fetch all data if not initialized
                  if(_var.initialized == null) {

                    // Show loading
                    window.gViz.shared.helpers.loading.show('.loading-wrapper');

                    // Fetch data from API
                    window.gViz.shared.data.barChart
                      .fetch('year', null, null, appliance, isForecast, apiKey, registrationToken,  endPointing)
                      .then(function() {

                        // Get today option
                        _var.setBarChartView('day');

                        // Update initialized flag to avoid future caching
                        _var.initialized = true;

                        // Show loading
                        window.gViz.shared.helpers.loading.hide('.loading-wrapper');

                      });

                  } else {

                    // Get today option
                    _var.setBarChartView('day');

                  }

                }
                else if(graphActive === 1) { _var.setBubbleChartView('day'); }

              // WEEK :: Draw bar chart and get other informations
              } else if (id == 2 && (menuItems == null || (menuItems['7DAYS'] != null && menuItems['7DAYS'].active != null && menuItems['7DAYS'].active === true))) {
                if(graphActive === 0) { _var.setBarChartView('week'); }
                else if(graphActive === 1) { _var.setBubbleChartView('week'); }

              // MONTH :: Draw bar chart and get other informations
              } else if (id == 3 && (menuItems == null || (menuItems['30DAYS'] != null && menuItems['30DAYS'].active != null && menuItems['30DAYS'].active === true))) {
                if(graphActive === 0) { _var.setBarChartView('month'); }
                else if(graphActive === 1) { _var.setBubbleChartView('month'); }

              // YEAR :: Draw bar chart and get other informations
              } else if (id == 4 && (menuItems == null || (menuItems['YEAR'] != null && menuItems['YEAR'].active != null && menuItems['YEAR'].active === true))) {
                if(graphActive === 0) { _var.setBarChartView('year'); }
                else if(graphActive === 1) { _var.setBubbleChartView('year'); }
              }
            }

            // Update menu depending on view
            _var.menuItem.filter(d => d.value === 1)
              .text(function(d) {
                var value = graphActive === 1 || graphActive === 2 ? { value: 1, translate: 'YESTERDAY', name: 'YESTERDAY' } : d;
                return translate != null ? (translate.instant(value.translate) || value.name) : value.name;
              })

          }

          // Reset the object (back to Today)
          _var.reset = function() {

            // Update Menu
            _var.update('menu', 1);

            // Update charts
            _var.update('chart', 1);

            // Menu Click callback function
            menuClick(1);

          }

          // Delete the luko-graph object
          _var.delete = function() {
            _var.container.d3.html('');
            promises = [];
            _var = null;
          }

          // Get attributes from library
          _var.get = {

            // Get current chart type
            type: function() { return chartType; },

            // Get current chart left border timestamp
            start: function() {
              if(chartType == 'line' && _var.lineChart != null) { return _var.lineChart.get.start(); }
              else if(chartType == 'bar' && _var.barChart != null) { return _var.barChart.get.start(); }
              return null;
            },

            // Get current chart right border timestamp
            end: function() {
              if(chartType == 'line' && _var.lineChart != null) { return _var.lineChart.get.end(); }
              else if(chartType == 'bar' && _var.barChart != null) { return _var.barChart.get.end(); }
              return null;
            },

            // Get current chart right - left border timestamp
            zoom_h: function() {
              if(chartType == 'line' && _var.lineChart != null) { return _var.lineChart.get.end() - _var.lineChart.get.start(); }
              else if(chartType == 'bar' && _var.barChart != null) { return _var.barChart.get.end() - _var.barChart.get.start(); }
              return null;
            },

            // Get current chart min y value
            min: function() {
              if(chartType == 'line' && _var.lineChart != null) { return _var.lineChart.get.min(); }
              else if(chartType == 'bar' && _var.barChart != null) { return _var.barChart.get.min(); }
              return null;
            },

            // Get current chart max y value
            max: function() {
              if(chartType == 'line' && _var.lineChart != null) { return _var.lineChart.get.max(); }
              else if(chartType == 'bar' && _var.barChart != null) { return _var.barChart.get.max(); }
              return null;
            },

            // Get current chart max - min y value
            zoom_v: function() {
              if(chartType == 'line' && _var.lineChart != null) { return _var.lineChart.get.max() - _var.lineChart.get.min(); }
              else if(chartType == 'bar' && _var.barChart != null) { return _var.barChart.get.max() - _var.barChart.get.min(); }
              return null;
            },

            // Get current appliance value
            appliance: function() { return appliance; },

            // Get current isForecast value
            is_forecast: function() { return isForecast; },

          }

          // Set attributes from library
          _var.set = {

            // Set current appliance value
            appliance: function(value) { appliance = value; },

            // Set current isForecast value
            is_forecast: function(value) { return isForecast = value; },

            // Set current chart type
            type: function(value) {
              if(value === 'line' || value === 'bar') {

                // Update chart type
                chartType = value;

                // Set time active to the clicked id
                timeActive = value === 'line' ? 0 : 1;

                // Set chart view
                graphActive = 0;

                // Update Menu
                _var.update('menu', value === 'line' ? 0 : 1);

                // Update charts
                _var.update('chart', value === 'line' ? 0 : 1);

                // Toggle item on menu
                menuClick(value === 'line' ? 0 : 1);
              }
            },

            // Set specific day view
            day: function(value) {
              _var.setBarChartView('day', d3.timeFormat("%Y-%m-%d")(value.addDays(1)), 'prev');
            },

            // Set specific week view
            week: function(value) {
              _var.setBarChartView('week', d3.timeFormat("%Y-%m-%d")(value.addDays(7)), 'prev');
            },

            // Set specific month view
            month: function(value) {
              _var.setBarChartView('month', d3.timeFormat("%Y-%m-%d")(value.addMonths(1)), 'prev');
            },

            // Set specific year view
            year: function(value) {
              _var.setBarChartView('year', d3.timeFormat("%Y")(value.addYears(1)), 'prev');
            },

            // Set price function
            price_function: function(value) {
              priceFunction = value;
            },

            // Set line transparency
            line_transparency: function(value) {
              lineTransparency = value;
            },

            // Set line colors
            line_colors: function(value) {
              lineColors = value;
            },

            // Set time active value
            time_active: function(value) {
              timeActive = value;
            },

            // Set graph active value
            graph_active: function(value) {
              graphActive = value;
            },

            // Set menu click callback function
            menu_click: function(value) {
              menuClick = value;
            }

          };

          break;
      }
    }

    return _var;
  };

  // Expose global variables
  ['_var','translate','registrationToken','apiKey','container','endPointing','language','appliance','isForecast','promises','priceFunction','lineColors','lineTransparency','timeActive','graphActive','menuClick','onChange','menuItems'].forEach(function (key) {

    // Attach variables to validation function
    validate[key] = function (_) {
      if (!arguments.length) { eval("return "+key); }
      eval(key + " = _");
      return validate;
    };

    // Attach variables to main function
    return main[key] = function (_) {
      if (!arguments.length) { eval("return "+key); }
      eval(key + " = _");
      return main;
    };
  });

  // Secondary functions
  main.build = function (_) { return main("build"); };

  // Execute the specific called function
  main.run = function (_) { return main(_); };

  return main;

}
