// Module declaration
gViz.viz.barChart.axis = function() {
  "use strict";

  // Get attributes values
  var _var = undefined;
  var action = 'create';

  // Validate attributes
  var validate = function validate(step) {

    switch (step) {
      case 'run':
        return true;
      default:
        return false;
    }
  };

  // Main function
  var main = function main(step) {

    // Validate attributes if necessary
    if (validate(step)) {

      switch (step) {

        // Build entire visualizations
        case 'run':

          switch (action) {

            case 'create':

              // Create and update X axis
              _var.x_axis = _var.g.selectAll(".x.axis").data(['x']);
              _var.x_axis.exit().remove();
              _var.x_axis = _var.x_axis.enter().append('g').attr("class", "x axis").merge(_var.x_axis);
              _var.x_axis.call(_var.xAxis.tickSize(5)).attr("transform", 'translate(0,' + _var.height + ')')
              _var.x_axis.selectAll('.tick text')
                .attr('y', 26)
                .attr('x', function(d) { return -(_var.x.bandwidth() / 2) + Math.max((_var.xIn(_var.xIn.domain()[0]) + _var.xIn.bandwidth()/2 - _var.barWidth/2), 10); })
                .attr('text-anchor', 'start')
                .style('font-weight', 600)
                .style('font-size', '14px')
                .style('fill', '#9b9b9b')
                .text(function(d) { return _var.xDomain[d].name; })

              // Update x axis attributes and styles
              _var.updateXAxis = function() {

                // Draw Background rect
                var pathDomain = _var.x_axis.selectAll("path.domain-custom").data(["domain-custom"]);
                pathDomain.exit().remove();
                pathDomain = pathDomain.enter().append('path').attr("class", "domain-custom").merge(pathDomain);
                pathDomain.attr("d", "M 0,0 " + (_var.width + _var.margin.left + _var.margin.right) + ",0")

                _var.x_axis.selectAll('.tick text')
                  .attr('x', function(d) {

                    // Get domain range for specific date
                    var range = [_var.x(_var.xDomain[d].x), _var.x(_var.xDomain[d].x) + _var.x.bandwidth()];

                    // If the initial range is on the right of the most left bound
                    if(range[0] >= -_var.zoom.transform.x) {
                      return -(_var.x.bandwidth() / 2) + Math.max((_var.xIn(_var.xIn.domain()[0]) + _var.xIn.bandwidth()/2 - _var.barWidth/2), 10);

                    // If the initial range is on the left of the most left bound
                    } else {
                      var size  = this.getBBox().width;
                      if(range[1] + _var.zoom.transform.x > size + 20) {
                        return (_var.x.bandwidth() / 2) - (range[1] + _var.zoom.transform.x - 10);
                      } else {
                        return (_var.x.bandwidth() / 2) - (size + 10);
                      }
                    }
                  })

              }

              break;

          }
          break;
      }
    }

    return _var;
  };

  // Exposicao de variaveis globais
  ['_var', 'action'].forEach(function (key) {

    // Attach variables to validation function
    validate[key] = function (_) {
      if (!arguments.length) {
        eval('return ' + key);
      }
      eval(key + ' = _');
      return validate;
    };

    // Attach variables to main function
    return main[key] = function (_) {
      if (!arguments.length) {
        eval('return ' + key);
      }
      eval(key + ' = _');
      return main;
    };
  });

  // Executa a funcao chamando o parametro de step
  main.run = function (_) {
    return main('run');
  };

  return main;
};

function __range__(left, right, inclusive) {
  var range = [];
  var ascending = left < right;
  var end = !inclusive ? right : ascending ? right + 1 : right - 1;
  for (var i = left; ascending ? i < end : i > end; ascending ? i++ : i--) { range.push(i); }
  return range;
}
