// Initialize the visualization class
gViz.viz.barChart.initialize = function () {
  "use strict";

  // Get attributes values
  var _id = null;
  var _var = null;
  var animation = 900;
  var container = null;
  var colors = { main: gViz.shared.helpers.colors.main, aux: gViz.shared.helpers.colors.aux };
  var data = [];
  var hover = null;
  var margin = { top: 10, right: 10, bottom: 10, left: 10 };
  var zoom = {};
  var priceFunction = null;
  var xInDomain = null;

  // Events bindings
  var onHover = function(d) { console.log(d); };
  var onClick = function(d) { console.log(d); };

  // Validate attributes
  var validate = function (step) {
    switch (step) {
      case 'run': return true;
      default: return false;
    }
  };

  // Main function
  var main = function (step) {

    // Validate attributes if necessary
    if (validate(step)) {

      switch (step) {

        // Build entire visualizations
        case 'run':

          // Initialize variables
          if (!_var) { _var = {}; }
          _var._id = _id;
          _var.animation = animation;
          _var.colors = colors;
          _var.margin = margin;
          _var.onHover = onHover;
          _var.onClick = onClick;
          _var.priceFunction = priceFunction;
          _var.userXInDomain = xInDomain;

          // Id for shadows
          _var.shadowId = `vis-shadow-${Math.floor(Math.random() * ((1000000000 - 5) + 1)) + 5}`

          // Zoom
          if (_var.zoom == null) { _var.zoom = { }; }
          Object.keys(zoom).forEach(function (key) { return _var.zoom[key] = zoom[key]; });

           // Get container
          _var.container = {
            selector: container,
            d3: d3.select(container),
            el: ((typeof container === 'string' || container instanceof String) ? container : d3.select(container).node()),
            outerWrapper: d3.select(container).closest('.gViz-outer-wrapper'),
            outerWrapperClientRect: d3.select(container).closest('.gViz-outer-wrapper').node().getBoundingClientRect(),
            dimensions: {}
          };

          // Store data
          _var.data = data;

          // Get bar width from the attrs
          _var.barWidth = _var.data.attrs != null && _var.data.attrs.barWidth != null && !isNaN(+_var.data.attrs.barWidth) ? +_var.data.attrs.barWidth : 10;

          // Map data and get labels
          _var.nodes = {};
          if(_var.data.data != null) { _var.data.data.forEach(function (d) { _var.nodes[d.x] = d; }); }

          break;
      }
    }

    return _var;
  };

  // Expose global variables
  ['_id', '_var', 'animation', 'container', 'colors', 'data', 'hover', 'margin','zoom','onClick','onHover','priceFunction','xInDomain'].forEach(function (key) {

    // Attach variables to validation function
    validate[key] = function (_) {
      if (!arguments.length) {
        eval('return ' + key);
      }
      eval(key + ' = _');
      return validate;
    };

    // Attach variables to main function
    return main[key] = function (_) {
      if (!arguments.length) {
        eval('return ' + key);
      }
      eval(key + ' = _');
      return main;
    };
  });

  // Executa a funcao chamando o parametro de step
  main.run = function (_) { return main('run'); };

  return main;
};
