// Initialize the visualization class
gViz.viz.barChart.zoom = function () {
  "use strict";

  // Get attributes values
  var _var = null;
  var components = {};

  // Validate attributes
  var validate = function (step) {

    switch (step) {
      case 'run': return true;
      default: return false;
    }
  };

  // Main function
  var main = function (step) {

    // Validate attributes if necessary
    if (validate(step)) {

      switch (step) {

        // Build entire visualizations
        case 'run':

          // Zoom functions
          _var.zoom.callback = function(){

            if (d3.event != null && d3.event.transform != null) {

              // Store event
              var event = d3.event;

              // // Get bounds and domain
              // var _bounds = [_var.x(_var.xBounds[0]), _var.x(_var.xBounds[1])];

              // var min = null, max = null;
              // _var.data.data.forEach(function(d) {
              //   var xStart = _var.x(d.x);
              //   var xEnd = _var.x(d.x) + _var.x.bandwidth();
              //   var breakXStart = -d3.event.transform.x;
              //   var breakXEnd = -d3.event.transform.x + _var.width;
              //   if((xStart >= breakXStart && xStart < breakXEnd) || (xStart < breakXStart && xEnd > breakXStart)) {
              //     d.values.forEach(function(v) {
              //       var xInStart = xStart + _var.xIn(v.x);
              //       var xInEnd   = xStart + _var.xIn(v.x) + _var.xIn.bandwidth();
              //       if((xInStart >= breakXStart && xInStart < breakXEnd) || (xInStart < breakXStart && xInEnd > breakXStart)) {
              //         if(min == null || min > +v.y) { min = v.y; }
              //         if(max == null || max < +v.y) { max = v.y; }
              //       }
              //     });
              //   }
              // });

              // _var.y.domain([min,max]);

              // Set event transformation only vertically without zoom
              d3.event.transform.k = 1;
              d3.event.transform.y = _var.margin.top;

              // If there is new data to fetch and this function is enable ('next')
              if(d3.event.transform.x < -_var.calcWidth + _var.width + _var.margin.left && _var.zoom.enable) {

                // Bound zoom to not go over the right side
                d3.event.transform.x = -_var.x.range()[1] + _var.width;

                // Disable fetch new data
                _var.zoom.enable = false;

                // Disable zooming
                _var.zoom.behaviour.on("zoom", null);

                // Get point
                var t = _var.data.data[_var.data.data.length - 1];

                // Set direction to zoom
                _var.zoom.direction = 'next';

                // Run zoom function
                _var.zoom.fn(t, "next");

              // If there is new data to fetch and this function is enable ('prev')
              } else if(d3.event.transform.x > _var.x.range()[0] && _var.zoom.enable) {

                // Bound zoom to not go over the left side
                d3.event.transform.x = _var.x.range()[0];

                // Disable fetch new data
                _var.zoom.enable = false;

                // Disable zooming
                _var.zoom.behaviour.on("zoom", null);

                // Get point
                var _t = _var.data.data[0];

                // Set direction to zoom
                _var.zoom.direction = 'prev';

                // Run zoom function
                _var.zoom.fn(_t, "prev");

              }

              // Update bgClipRect
              _var.defs.selectAll(".bg-clip .bg-rect").attr('x', -d3.event.transform.x + _var.margin.left);

              // Transform outer g
              _var.g.attr("transform", d3.event.transform)
              _var.gBars
                .attr("transform", d3.event.transform)
                .selectAll(".bar-rect")
                  .attr('rx', _var.getRadius)
                  .attr('ry', _var.getRadius)
                  .transition().duration(600)
                    .attr('y', _var.getY)
                    .attr('height', function(d) { return _var.getHeight(d) + _var.getRadius(d); })

              // Set zoom transform
              _var.zoom.transform = d3.event.transform;

              // Update x axis values and ticks
              _var.updateXAxis();

              // Reset hovered node
              _var.hovered = null;

              // Mouseout event
              components.events()
                ._var(_var)
                .action("mouseout")
                .components(components)
                .run();

            }
          }

          // Set zoom transform initialy
          _var.zoom.transform = {
            x: _var.zoom.transform == null ? -((_var.x(_var.zoom.startPoint != null ? _var.zoom.startPoint : _var.xBounds[1]) + _var.x.bandwidth() + _var.getXPadding()) - _var.width) : _var.zoom.transform.x,
            y: _var.zoom.transform == null ? _var.margin.top : _var.zoom.transform.y,
            k: _var.zoom.transform == null ? 1 : _var.zoom.transform.k,
          }

          // Add zoom capabilities
          _var.zoom.behaviour = d3.zoom()
            .scaleExtent([1,1])
            .on("zoom", _var.zoom.callback)
            .on("start", function() { _var.wrap.classed('grabbing', true) })
            .on("end",   function() { _var.wrap.classed('grabbing', false) });

          // Bind zoom to svg
          _var.wrap
            .call(_var.zoom.behaviour)
            .call(_var.zoom.behaviour.transform, d3.zoomIdentity.translate(_var.zoom.transform.x, _var.zoom.transform.y).scale(_var.zoom.transform.k))
            .on("wheel.zoom", null)

          // Bind touch events to bar and trigger onClick attribute function
          var event, endEvent, moved = false;
          _var.wrap
            .selectAll(".bar-rect")
            .on("touchstart", function(e) {
              event = setTimeout(function() {
                if(_var.onClick != null && typeof _var.onClick === "function") { _var.onClick(e); }
              }, 500);
            }).on("touchmove", function(e) {
              clearTimeout(event);
            }).on("touchend", function(e) {
              clearTimeout(event);
            });

         break;
     }
   }

    return _var;
  };

  // Exposicao de variaveis globais
  ['_var','components'].forEach(function (key) {

    // Attach variables to validation function
    validate[key] = function (_) {
      if (!arguments.length) {
        eval('return ' + key);
      }
      eval(key + ' = _');
      return validate;
    };

    // Attach variables to main function
    return main[key] = function (_) {
      if (!arguments.length) {
        eval('return ' + key);
      }
      eval(key + ' = _');
      return main;
    };
  });

  // Executa a funcao chamando o parametro de step
  main.run = function (_) { return main('run'); };

  return main;
};
