// Module declaration
gViz.viz.lineAreaChart.axis = function() {
  "use strict";

  // Get attributes values
  var _var = undefined;
  var action = 'create';

  // Validate attributes
  var validate = function validate(step) {

    switch (step) {
      case 'run':
        return true;
      default:
        return false;
    }
  };

  // Main function
  var main = function main(step) {

    // Validate attributes if necessary
    if (validate(step)) {

      switch (step) {

        // Build entire visualizations
        case 'run':

          switch (action) {

            case 'create':

              // Create and update X axis
              _var.x_axis = _var.g.selectAll(".x.axis").data(['x']);
              _var.x_axis.exit().remove();
              _var.x_axis = _var.x_axis.enter().append('g').attr("class", "x axis").merge(_var.x_axis);
              _var.x_axis.call(_var.xAxis.tickSize(5)).attr("transform", 'translate(0,' + _var.height + ')')

              // Update x axis attributes and styles
              _var.updateXAxis = function() {

                // Create and update Y axis
                _var.y_axis = _var.g.selectAll(".y.axis-text").data([_var.y.invert(_var.height), _var.y.invert(_var.margin.top)], function(d) { return d; });
                _var.y_axis.exit().remove();
                _var.y_axis = _var.y_axis.enter().append('text').attr("class", "y axis-text").merge(_var.y_axis);
                _var.y_axis
                  .attr('y', function(d,i) { return i === 0 ? _var.height - 10 : 30; })
                  .attr('x', 10)
                  .style('font-size', '12px')
                  .style('fill', '#9b9b9b')
                  .style('font-weight', '500')
                  .html(function(d) { return "– \&nbsp;\&nbsp;" + _var.yFormat(d); })

                _var.x_axis.selectAll("path.domain").remove();
                _var.x_axis.selectAll(".tick line").attr('y1', 0)
                _var.x_axis.selectAll(".tick text").attr('dy', 3)

                // Draw Background rect
                var pathDomain = _var.x_axis.selectAll("path.domain-custom").data(["domain-custom"]);
                pathDomain.exit().remove();
                pathDomain = pathDomain.enter().insert('path', ':first-child').attr("class", "domain-custom").merge(pathDomain);
                pathDomain.attr("d", "M 0,0 " + (_var.width + _var.margin.left + _var.margin.right) + ",0")

                // Draw x day text
                var xTitle = _var.g.selectAll("text.x-title").data(["x-title"]);
                xTitle.exit().remove();
                xTitle = xTitle.enter().append('text').attr("class", "x-title").merge(xTitle);
                xTitle
                  .attr('y', _var.height + 36)
                  .attr('x', 10)
                  .attr('text-anchor', 'start')
                  .style('font-weight', 600)
                  .style('font-size', '14px')
                  .text(function(d) {

                    // Today
                    var today = new Date((new Date()).setHours(0,0,0,0));

                    // Yesterday
                    var yesterday = new Date((new Date()).setHours(23,59,59,999));
                    yesterday.setDate(yesterday.getDate() - 2);

                    // Most left value
                    var leftValue = _var._x.invert(-_var.xZoom.transform.x + _var.distance - _var.width);

                    // Check if its the current Year
                    var isCurrentYear = leftValue.getYear() === today.getYear();

                    // Get intervals
                    if(leftValue >= today) { return gViz.shared.helpers.date.translated.today; }
                    else { return d3.timeFormat("%b %d" + (isCurrentYear ? "" : ", %Y"))(leftValue); }

                  });

              }


              break;

          }
          break;
      }
    }

    return _var;
  };

  function capitalizeFirstLetter(string) {
    return string.charAt(0).toUpperCase() + string.slice(1);
}

  // Exposicao de variaveis globais
  ['_var', 'action'].forEach(function (key) {

    // Attach variables to validation function
    validate[key] = function (_) {
      if (!arguments.length) {
        eval('return ' + key);
      }
      eval(key + ' = _');
      return validate;
    };

    // Attach variables to main function
    return main[key] = function (_) {
      if (!arguments.length) {
        eval('return ' + key);
      }
      eval(key + ' = _');
      return main;
    };
  });

  // Executa a funcao chamando o parametro de step
  main.run = function (_) {
    return main('run');
  };

  return main;
};

function __range__(left, right, inclusive) {
  var range = [];
  var ascending = left < right;
  var end = !inclusive ? right : ascending ? right + 1 : right - 1;
  for (var i = left; ascending ? i < end : i > end; ascending ? i++ : i--) { range.push(i); }
  return range;
}
