// Module declaration
gViz.viz.lineAreaChart.style = function() {
  "use strict";

  // Get attributes values
  var _var = undefined;
  var animation = 900;

  // Validate attributes
  var validate = function (step) {

    switch (step) {
      case 'run': return true;
      default: return false;
    }
  };

  // Main function
  var main = function (step) {

    // Validate attributes if necessary
    if (validate(step)) {

      switch (step) {

        // Build entire visualizations
        case 'run':

          _var.getZoomOffset = function() {
            if(_var.zoomLevel === 1) { return 3600000; }
            else { return 3600000; }
          }

          _var.isReferenceLineNow = function(d) {
            return _var.isNow && (new Date() - _var.xLast.parsedX) <= _var.getZoomOffset();
          }

          // Reference line color
          _var.referenceLineColor = function(d) {
            return "#4568cc";
            // if(_var.yMax >= 600) { return "#fa5050"; }
            // else if(_var.yMax < 600 && _var.yMax >= 500) { return d3.scaleLinear().domain([600,500]).range(["#fa5050","#3d62cb"])(_var.yMax); }
            // else if(_var.yMax < 500 && _var.yMax >= 300) { return "#3d62cb"; }
            // else if(_var.yMax < 300 && _var.yMax >= 200) { return d3.scaleLinear().domain([600,500]).range(["#3d62cb","#4ad2a1"])(_var.yMax); }
            // else { return "#4ad2a1"; }
          }

          _var.referenceLineX = function(d) {
            if(_var.referenceLine != null) {
              if(_var.referenceLine.status === 'now') { return _var._x(_var.xData[_var.xData.length-1].parsedX); }
              else if(_var.x(_var.referenceLine.value) != null && !isNaN(_var._x(_var.referenceLine.value))) { return _var._x(_var.referenceLine.value); }
              else { return 0; }
            } else { return 0; }
          }

          _var.referenceLineIsNow = function(d) {
            return _var.referenceLine != null && _var.referenceLine.status === 'now';
          }

          _var.referenceLineDisplay = function(d) {
            if(_var.referenceLine != null) {
              if(_var.referenceLine.status === 'now') { return true; }
              else if(_var._x(_var.referenceLine.value) != null && !isNaN(_var._x(_var.referenceLine.value))) { return true; }
              else { return false; }
            } else { return false; }
          }

          // Set area color
          _var.areaColor = function(d) {
            return d.areaColor != null && d.areaColor !== "" ? d.areaColor : _var.lineColor(d);
          }

          // Set line width
          _var.lineWidth = function(d) {
            return d.strokeWidth != null && !isNaN(d.strokeWidth) ? d.strokeWidth + "px" : "2px";
          }

          // Set line color
          _var.lineColor = function(d) {

            if(d.color != null && d.color !== "") { return d.color; }
            else if(d.startColor != null && d.startColor !== "" && d.stopColor != null && d.stopColor !== "") {

              // Set wrapper gradient
              gViz.shared.visualComponents.gradient()
                ._var(_var)
                .id("gradient-"+gViz.shared.helpers.text.removeSpecial(d.id+d.name))
                .colors([
                  { offset:"0%", color: d.startColor },
                  { offset:"100%", color: d.stopColor }
                ])
                .direction('horizontal')
                .gType('linear')
                .wrap(_var.defs)
                .run();

              return 'url("' + "#gradient-"+gViz.shared.helpers.text.removeSpecial(d.id+d.name) + '")';
            } else { return "#666"; }
          }

          // Set stroke style function
          _var.lineStyle = function(d) {
            var strokeStyle = d.strokeStyle != null ? d.strokeStyle : "solid";
            if(strokeStyle === "dotted") { return "2,2"; }
            else if(strokeStyle === "dashed") { return "7,3"; }
            else { return "0,0"; }
          }

          // Set point color
          _var.pointColor = function(d) {
            if(d.pointColor != null) { return d.pointColor; }
            else if(d._parent.pointColor != null) { return d._parent.pointColor; }
            else if(d._parent.color != null) { return d._parent.color; }
            else { return "#333"; }
          }

          // Set point color
          _var.pointSize = function(d) {
            return d.pointSize != null ? d.pointSize : (d._parent.pointSize != null ? d._parent.pointSize : 3);
          }

          _var.pointX = function(d) {
            return _var.x(d.parsedX) + (_var.xIsDate || _var.xIsNumber ? 0 : _var.x.bandwidth()/2);
          }

          _var.pointY = function(d) {
            return _var.y(+d.y);
          }

          // Set shape path for node
          _var.pointPath = function(d) {

            // Get radius
            var r = _var.pointSize(d);
            var dr = r*2;
            var x  = _var.pointX(d);
            var y  = _var.pointY(d);
            var shape = d.pointShape != null ? d.pointShape : (d._parent.pointShape != null ? d._parent.pointShape : "circle");

            // For each shape style
            switch(shape) {

              // Set rect shape
              case "rect":
                return "M " + ((x != null ? x : 0) - r) + " " + ((y != null ? y : 0) - r) + " " +
                       "l " + dr + ", 0 " +
                       "l 0 , " + dr + " " +
                       "l " + (-dr) + ", 0 " + "Z";
                break;

              // Set diamond shape
              case 'diamond':
                return "M " + (x != null ? x : 0) + " " + ((y != null ? y : 0) - r) + " " +
                       "l " + r + ", " + r + " " +
                       "l " + (-r) + ", " + r + " " +
                       "l " + (-r) + ", " + (-r) + " " + "Z";
                break;

              // Set triangle up shape
              case 'triangle-up':
                return "M " + (x != null ? x : 0) + " " + ((y != null ? y : 0) - r) + " " +
                       "l " + r + ", " + dr + " " +
                       "l " + (-dr) + ", " + 0 + " " + "Z";
                break;

              // Set triangle down shape
              case 'triangle-down':
                return "M " + ((x != null ? x : 0) - r) + " " + ((y != null ? y : 0) - r) + " " +
                       "l " + dr + ", 0 " +
                       "l " + (-r) + ", " + dr + " " + "Z";
                break;

              // Set circle shape
              default:
                return "M " + (x != null ? x : 0) + " " + (y != null ? y : 0) + " " +
                       "m -" + r + ", 0 " +
                       "a " + r + "," + r + " 0 1,0 " + ( r*2) + ",0 " +
                       "a " + r + "," + r + " 0 1,0 " + (-r*2) + ",0 ";
                break;
            }
          }

          break;
      }
    }

    return _var;
  };

  // Exposicao de variaveis globais
  ['_var', 'animation'].forEach(function (key) {

    // Attach variables to validation function
    validate[key] = function (_) {
      if (!arguments.length) { eval("return "+key); }
      eval(key + " = _");
      return validate;
    };

    // Attach variables to main function
    return main[key] = function (_) {
      if (!arguments.length) { eval("return "+key); }
      eval(key + " = _");
      return main;
    };
  });

  // Executa a funcao chamando o parametro de step
  main.run = function(_) { return main('run'); };

  return main;
};
