// Initialize the visualization class
gViz.viz.lineAreaChart.xZoom = function() {
  "use strict";

  // Get attributes values
  var _var = null;
  var components = function (d) { return console.log("components"); };

  // Validate attributes
  var validate = function validate(step) {
    switch (step) {
      case 'run': return true;
      default: return false;
    }
  };

  // Main function
  var main = function main(step) {

    // Validate attributes if necessary
    if (validate(step)) {

      switch (step) {

        // Run
        case 'run':

          // Set combined data from all series
          var data = _var.xData;
          var d3Zoom = null;

          // Update zoom function
          _var.xZoom.updateZoomMode = function() {

            // D3 zoom behaviour
            if(_var.xZoom.behaviour == null) {
              _var.xZoom.behaviour = d3.zoom()
                .duration(0)
                .on("start", _var.xZoom.start)
                .on("end", _var.xZoom.end)
                .on("zoom", _var.xZoom.callback);

              _var.wrap
                .on('.zoom', null)
                .call(_var.xZoom.behaviour)
                .on("dblclick.zoom", null)
            } else {
              _var.xZoom.behaviour
                .on("start", _var.xZoom.start)
                .on("end", _var.xZoom.end)
                .on("zoom", _var.xZoom.callback);
            }

            // Get scale
            var width = _var.width - _var.width/6;
            var _width = (_var.isNow ? width : _var.width);
            _var.xZoom.cached = _var.xZoom.cached || {};

            // Initialize scale and translate tranformations
            _var.xZoom.transform = _var.xZoom.transform || {};
            _var.xZoom.transform.k = _var.width / _var.distance;
            _var.xZoom.transform.y = _var.margin.top;

            // Apply x transformations
            if(_var.xZoom.transform.x == null || _var.isNow) {
              _var.xZoom.transform.x = -(_var.x(_var.xBounds[1]) * _var.xZoom.transform.k) + _width;
              _var.wrap
                .call(
                  _var.xZoom.behaviour.transform,
                  d3.zoomIdentity.scale(_var.xZoom.transform.k).translate(_var.xZoom.transform.x, _var.xZoom.transform.y)
                )
            } else if(_var.wheelZoom.enable != null) {

              // Get x transformation depending on zoom level
              _var.xZoom.transform.x = _var.xZoom.cached[_var.zoomLevel] != null ? _var.xZoom.cached[_var.zoomLevel].x : _var.xZoom.cached[1].x * _var.xZoom.transform.k + _width * (1 - _var.xZoom.transform.k) / 2;

              _var.wrap
                .call(
                  _var.xZoom.behaviour.transform,
                  d3.zoomIdentity.scale(_var.xZoom.transform.k).translate(_var.xZoom.transform.x, _var.xZoom.transform.y)
                )
            } else {
              _var.wrap.call(_var.xZoom.behaviour.translateTo, _var.xZoom.transform.x, _var.xZoom.transform.y)
            }
          }

          // On zoom start function
          _var.xZoom.start = function () {
            _var.wrap.classed("grabbing", true);
          };

          // On zoom end function
          _var.xZoom.end = function () {

            if(_var.xZoom.maxScaled == null) {

              // Prevent dragTimeout function to fire
              if(_var.xZoom.dragTimeout != null) { clearTimeout(_var.xZoom.dragTimeout); }

              // Remove grabbing cursor
              _var.wrap.classed("grabbing", false);

              // Store previous zoom
              _var.xPrevZoom = JSON.parse(JSON.stringify(_var.xZoom.transform));

              // Update clip rect position
              _var.defs.selectAll(".bg-clip").selectAll("rect.bg-rect").transition()
                .duration(_var.animation)
                .ease(d3.easeLinear)
                  .style('x', 0);

              // Update axis
              _var.x_axis.transition()
                .duration(_var.animation)
                .ease(d3.easeLinear)
                .call(_var.xAxis.scale(_var._x));

              // Update elements
              _var = gViz.viz.lineAreaChart.elements()
                ._var(_var)
                .components(gViz.viz.lineAreaChart)
                .run();

              _var.gClip.transition().duration(_var.animation).ease(d3.easeLinear)
                .attr('transform', "translate(0,"+_var.margin.top+")");

              if(d3Zoom != null) {
                if(d3Zoom.type === 'wheel') {

                  // Disable fetch new data
                  _var.xZoom.enable = false;
                  _var.wheelZoom.enable = true;
                  _var.wheelZoom.direction = d3Zoom.direction;

                  // Disable zooming
                  _var.xZoom.behaviour.on("zoom", null);

                  // Set can none to false
                  _var.canNone = false;

                  // Run zoom function
                  _var.wheelZoom.fn(_var.wheelZoom.x, d3Zoom.direction);

                } else {

                  if(d3Zoom.direction === 'prev') {

                    // Get point
                    var _t = data[0].parsedX;

                    // Set can none to false
                    _var.canNone = false;

                    // Run zoom function
                    _var.xZoom.fn(_t, "prev");

                  } else {

                    // Set can none to false
                    _var.canNone = false;

                    // Get point
                    var t = data[data.length - 1].parsedX;

                    // Run zoom function
                    _var.xZoom.fn(t, "next");

                  }
                }
              } else {

                // Remove zoom enable flag
                if(_var.wheelZoom.enable != null) {
                  setTimeout(function() {

                    // Remove zoom enable flag
                    _var.wheelZoom.enable = null;

                  }, _var.animation);
                }
              }
            } else {

              _var.xZoom.behaviour
                .on("end", _var.xZoom.endMaxScaled)
                .on("zoom", _var.xZoom.callbackMaxScaled);

              // Get x transformation depending on zoom level
              _var.wrap
                .call(
                  _var.xZoom.behaviour.transform,
                  d3.zoomIdentity.scale(_var.xZoom.transform.k).translate(_var.xZoom.transform.x / _var.xZoom.transform.k, _var.xZoom.transform.y / _var.xZoom.transform.k)
                )

            }

            // Reset control variables
            d3Zoom = null;
            _var.xZoom.maxScaled = null;

          };

          _var.xZoom.callbackMaxScaled = function () {
          }

          _var.xZoom.endMaxScaled = function () {
            _var.xZoom.prevTransform = JSON.parse(JSON.stringify(_var.xZoom.transform));
            _var.xZoom.behaviour
              .on("end", _var.xZoom.end)
              .on("zoom", _var.xZoom.callback);
          }

          // On zoom function
          _var.xZoom.callback = function () {

            if(_var.xZoom.maxScaled == null && d3Zoom == null && d3.event != null && d3.event.transform != null) {

              if(_var.wheelZoom.enable == null && ((_var.zoomLevel == -2 && _var.xZoom.prevTransform.k > d3.event.transform.k) || (_var.zoomLevel == 5 && _var.xZoom.prevTransform.k < d3.event.transform.k))) {
                _var.xZoom.maxScaled = true;
                return;
              }

              // Store event
              var event = d3.event;

              // Handle zoom
              if(event.sourceEvent != null && _var.xZoom.prevTransform.k !== event.transform.k) {

                // Cache transform for each scale
                if(_var.zoomLevel == 1) {
                  _var.xZoom.cached[_var.zoomLevel] = JSON.parse(JSON.stringify(_var.xZoom.transform));
                }

                // Get zooming direction
                var direction = d3.event.transform.k < _var.xZoom.prevTransform.k ? 'down' : 'up';

                // Set start and end points on screen on zoom start
                if(d3Zoom == null) {
                  _var.wheelZoom.x = {};
                  _var.wheelZoom.x.start = _var.x.invert(-d3.event.transform.x / d3.event.transform.k),
                  _var.wheelZoom.x.end = _var.xLast.parsedX < _var.x.invert(-d3.event.transform.x / d3.event.transform.k + _var.width / d3.event.transform.k) ? _var.xLast.parsedX : _var.x.invert(-d3.event.transform.x / d3.event.transform.k + _var.width / d3.event.transform.k);
                  _var.wheelZoom.x._end = _var.x.invert(-d3.event.transform.x + _var.width / d3.event.transform.k);
                }

                // Update zoom direction
                var zoomLevel = _var.zoomLevel + (direction === 'up' ? (1) : (-1));

                // Bounded zoom level
                if(zoomLevel <= -2) { zoomLevel = -2; }
                else if(zoomLevel >= 5) { zoomLevel = 5; }

                // Reset transform event
                var zoomInfo = gViz.shared.data.lineChart.zoomLevelInfo(zoomLevel);
                _var.xZoom.transform.k = zoomInfo.zoom;

                // Set zoom type and direction to be used on drag end
                d3Zoom = { type: 'wheel', direction: direction };

                // Show loading
                window.gViz.shared.helpers.loading.show('.loading-wrapper');

                return;

              }

              // Get scale from transformation
              _var._x = d3.event.transform.rescaleX(_var.x);

              // Set width
              var width = _var.width - _var.width/6;
              if(_var.isNow) {
                width = _var.width - _var.width/6;
              } else if(_var._x(_var.xLast.parsedX) > _var.width - _var.width/6 && _var._x(_var.xLast.parsedX) < _var.width) {
                width = _var._x(_var.xLast.parsedX);
              } else {
                width = _var.width;
              }

              // Get bounds and domain
              var _bounds = [_var._x(_var.xBounds[0]), _var._x(_var.xBounds[1])];
              var _domain = _var._x.domain();

              // Dragging behaviour
              if(event.sourceEvent != null && _var.xZoom.prevTransform.k === event.transform.k) {

                // Update cached with translations
                var deltaX = _var.xZoom.prevTransform.x - event.transform.x;
                Object.keys(_var.xZoom.cached).forEach(function(k) {
                  _var.xZoom.cached[k].x -= deltaX / event.transform.k;
                });

                // // Set is now
                if(parseInt(_var.x(_var.xBounds[1]) * _var.xZoom.transform.k + _var.xZoom.transform.x) !== parseInt(width) && _var.isNow && _var.canNone) {

              } else if(_var.x(_var.xBounds[1]) * _var.xZoom.transform.k + _var.xZoom.transform.x === width && _var.isNow !== true) {

                _var.isNow = true;
                _var.canNone = false;

              }

              if(event.sourceEvent == null || event.sourceEvent.type !== 'wheel') {

                // If there is new data to fetch and this function is enable
                if (_domain[0] < data[0].parsedX && data[0].parsedX >= _var.xBounds[0] && _var.xZoom.enable && _domain[0] < _var.xLimits[0]) {

                  // Disable fetch new data
                  _var.xZoom.enable = false;

                  // Disable zooming
                  _var.xZoom.behaviour.on("zoom", null);

                  // Set zoom type and direction to be used on drag end
                  d3Zoom = { type: 'drag', direction: 'prev' };

                  // Show loading
                  window.gViz.shared.helpers.loading.show('.loading-wrapper');

                // If there is new data to fetch and this function is enable
                } else if (
                  (_var.isNow !== true || ((new Date()).getTime() - _var.xLast.parsedX) >= _var.getZoomOffset()) && _var.canNone === true &&
                  +_domain[1] > _var.xLast.parsedX &&
                  _var.xLast.parsedX <= _var.xBounds[1] &&
                  _var.xZoom.enable &&
                  +_domain[1] > _var.xLimits[1] &&
                  ((_var.lastXPosition != null && _var._x(_var.xLast.parsedX) < _var.lastXPosition && _var._x(_var.xLast.parsedX) < _var.width && _var.lastXPosition > _var.width) || (_var._x(_var.xLast.parsedX) < _var.width && _var._x(_var.xLast.parsedX) < width) )
                ) {

                  // Disable fetch new data
                  _var.xZoom.enable = false;

                  // Disable zooming
                  _var.xZoom.behaviour.on("zoom", null);

                  // Set zoom type and direction to be used on drag end
                  d3Zoom = { type: 'drag', direction: 'next' };

                  // Show loading
                  window.gViz.shared.helpers.loading.show('.loading-wrapper');

                }
              }

              if (_bounds[1] < width || _bounds[0] >= 0) {

                // Reset event transform
                event.transform.x = _var.xZoom.transform.x;

                // Get scale from transformation
                _var._x = event.transform.rescaleX(_var.x);

              }

              // Store previous transformation
              _var.xZoom.transform.k = event.transform.k;
              _var.xZoom.transform.x = event.transform.x;

              _var.canNone = true;
              _var.lastXPosition = _var._x(_var.xLast.parsedX);

              // Dragging behaviour
              if(event.sourceEvent != null && _var.xZoom.prevTransform.k === d3.event.transform.k) {

                // Update axis
                _var.x_axis.call(_var.xAxis.scale(_var._x));

                // Update transform only, not the elements
                var xTransform = _var.isNow ? 0 : _var.xZoom.transform.x - (_var.xPrevZoom == null ? _var.width/6 : _var.xPrevZoom.x);
                _var.gClip.attr('transform', 'translate('+(xTransform)+","+_var.margin.top+")");
                _var.defs.selectAll(".bg-clip").selectAll("rect.bg-rect").style('x', -xTransform);

                // If the drag stops after 500 seconds, fires the end zoom function
                if(_var.xZoom.dragTimeout != null) { clearTimeout(_var.xZoom.dragTimeout); }
                _var.xZoom.dragTimeout = setTimeout(function() {
                  _var.xZoom.end();
                }, 500);

              } else {

                // Update axis
                _var.x_axis.transition()
                  .duration(_var.animation)
                  .ease(d3.easeLinear)
                  .call(_var.xAxis.scale(_var._x));

                // Update elements
                _var = gViz.viz.lineAreaChart.elements()
                  ._var(_var)
                  .components(gViz.viz.lineAreaChart)
                  .run();

              }
            }

            // Store previous transformation
            _var.xZoom.prevTransform = JSON.parse(JSON.stringify(d3.event.transform));
          };

          break;
      }
    }

    return _var;
  };

  // Exposicao de variaveis globais
  ['_var', "components"].forEach(function (key) {

    // Attach variables to validation function
    validate[key] = function (_) {
      if (!arguments.length) {
        eval("return " + key);
      }
      eval(key + " = _");
      return validate;
    };

    // Attach variables to main function
    return main[key] = function (_) {
      if (!arguments.length) {
        eval("return " + key);
      }
      eval(key + " = _");
      return main;
    };
  });

  // Executa a funcao chamando o parametro de step
  main.run = function (_) {
    return main('run');
  };

  return main;
};
