angular.module('app.routes', [])

.config(function($stateProvider, $urlRouterProvider) {

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider


  .state('myLuko.appliance', {
    url: '/appliance',
    cache: false,
    views: {
      'side-menu21': {
        templateUrl: 'templates/applianceCard.html',
        controller: 'applianceCtrl'
      }
    }
  })


  .state('myLuko.alertCard', {
    url: '/alertcard',
    views: {
      'side-menu21': {
        templateUrl: 'templates/alertCard.html',
        controller: 'alertCardCtrl'
      }
    }
  })

  .state('myLuko.consumption', {
    url: '/consumption',
    views: {
      'side-menu21': {
        templateUrl: 'templates/consumption.html',
        controller: 'consumptionCtrl'
      }
    }
  })


  .state('myLuko.timeline', {
    url: '/timeline',
    views: {
      'side-menu21': {
        templateUrl: 'templates/timeline.html',
        controller: 'timelineCtrl'
      }
    }
  })

  .state('myLuko.settings', {
    url: '/settings',
    views: {
      'side-menu21': {
        templateUrl: 'templates/settings_v2.html',
        controller: 'settingsCtrl'
      }
    }
  })

  .state('myLuko', {
    url: '/side-menu21',
    templateUrl: 'templates/myLuko.html',
    controller: 'myLukoCtrl'
  })

  .state('myLuko.login', {
    url: '/login',
    views: {
      'side-menu21': {
      templateUrl: 'templates/login.html',
      controller: 'loginCtrl'
      }
    }
  })

  .state('login', {
    url: '/login',
    templateUrl: 'templates/login.html',
    controller: 'loginCtrl'
  })


  .state('signUp', {
    url: '/signUp',
    templateUrl: 'templates/signUp.html',
    controller: 'signUpCtrl'

  })

  .state('myLuko.setupStart', {
    url: '/setupStart',
    views: {
      'side-menu21': {
        templateUrl: 'templates/setup/setupStart.html',
        controller: 'setupStartCtrl'
      }
    }
  })

    .state('myLuko.setupStartBridge', {
    url: '/setupStart',
    views: {
      'side-menu21': {
        templateUrl: 'templates/setup/setupStart_bridge.html',
        controller: 'setupStartCtrl'
      }
    }
  })

    .state('myLuko.setupUser', {
    url: '/setupStart',
    views: {
      'side-menu21': {
        templateUrl: 'templates/setupUser.html',
        controller: 'setupUserCtrl'
      }
    }
  })

      .state('myLuko.setupStartSensor', {
    url: '/setupStart',
    views: {
      'side-menu21': {
        templateUrl: 'templates/setup/setupStart_sensor.html',
        controller: 'setupStartCtrl'
      }
    }
  })

  .state('myLuko.scannQRcode', {
    url: '/scannQRcode',
    views: {
      'side-menu21': {
        templateUrl: 'templates/setup/SetupiOS_1.0.scannQRcode.html',
        controller: 'scannQRcode'
      }
    }
  })

  .state('myLuko.PlugTheBridge', {
    url: '/PlugTheBridge',
    views: {
      'side-menu21': {
        templateUrl: 'templates/setup/SetupiOS_1.1.PlugTheBridge.html',
        controller: 'plugTheBridgeCtrl'
      }
    }
  })

  .state('myLuko.AllowGeoLoc', {
    url: '/AllowGeoLoc',
    views: {
      'side-menu21': {
        templateUrl: 'templates/setup/SetupAnd_1.11.AllowGeoLoc.html',
        controller: 'allowGeoLocCtrl'
      }
    }
  })
  

  .state('myLuko.ConnectLukoconfig', {
    url: '/ConnectLukoconfig',
    views: {
      'side-menu21': {
        templateUrl: 'templates/setup/SetupiOS_1.2.ConnectLukoconfig.html',
        controller: 'connectLukoconfigCtrl'
      }
    }
  })

  .state('myLuko.needInternet', {
    url: '/needInternet',
    views: {
      'side-menu21': {
        templateUrl: 'templates/setup/needInternet.html',
        controller: 'needInternetCtrl'
      }
    }
  })

  .state('myLuko.SelectDomesticWifi', {
    url: '/SelectDomesticWifi',
    views: {
      'side-menu21': {
        templateUrl: 'templates/setup/SetupiOS_1.21.SelectDomesticWifi.html',
        controller: 'selectDomesticWifiCtrl'
      }
    }
  })

  .state('myLuko.CongratsBridgeSuccess', {
    url: '/CongratsBridgeSuccess',
    views: {
      'side-menu21': {
        templateUrl: 'templates/setup/SetupiOS_1.3.CongratsBridgeSuccess.html',
        controller: 'congratsBridgeSuccessCtrl'
      }
    }
  })

  .state('myLuko.MeterPhoto', {
    url: '/MeterPhoto',
    views: {
      'side-menu21': {
        templateUrl: 'templates/setup/SetupiOS_1.41.MeterPhoto.html',
        controller: 'meterPhotoCtrl'
      }
    }
  })

  .state('myLuko.PlugSensor', {
    url: '/PlugSensor',
    views: {
      'side-menu21': {
        templateUrl: 'templates/setup/SetupiOS_1.5.PlugSensor.html',
        controller: 'plugSensorCtrl'
      }
    }
  })

  .state('myLuko.PhotoSensorAndLuko', {
    url: '/PhotoSensorAndLuko',
    views: {
      'side-menu21': {
        templateUrl: 'templates/setup/SetupiOS_1.51.PhotoSensorAndLuko.html',
        controller: 'photoSensorAndLukoCtrl'
      }
    }
  })

  .state('myLuko.WaitingForValidation', {
    url: '/WaitingForValidation',
    views: {
      'side-menu21': {
        templateUrl: 'templates/setup/SetupiOS_1.6.WaitingForValidationSensor_v2.html',
        controller: 'waitingForValidationCtrl'
      }
    }
  })

  .state('myLuko.SetupSuccess', {
    url: '/SetupSuccess',
    views: {
      'side-menu21': {
        templateUrl: 'templates/setup/SetupiOS_1.7.SetupSuccess.html',
        controller: 'setupSuccessCtrl'
      }
    }
  })

  .state('myLuko.status', {
    url: '/status',
    views: {
      'side-menu21': {
      templateUrl: 'templates/status.html',
      controller: 'statusCtrl'
      }
    }
  })


  .state('myLuko.statusBridge', {
    url: '/statusBridge',
    views: {
      'side-menu21': {
      templateUrl: 'templates/statusBridge.html',
      controller: 'statusCtrl'
      }
    }
  })

  .state('myLuko.statusSensor', {
    url: '/statusBridge',
    views: {
      'side-menu21': {
      templateUrl: 'templates/statusSensor.html',
      controller: 'statusCtrl'
      }
    }
  })

  .state('myLuko.homesettings', {
    url: '/homesettings',
    views: {
      'side-menu21': {
      templateUrl: 'templates/homesettings.html',
      controller: 'homesettingsCtrl'
      }
    }
  })

  .state('myLuko.setcontract', {
    url: '/setcontract',
    views: {
      'side-menu21': {
      templateUrl: 'templates/setcontract.html',
      controller: 'setcontractCtrl'
      }
    }
  })

  .state('myLuko.intro', {
    url: '/intro',
    views: {
      'side-menu21': {
      templateUrl: 'templates/intro.html',
      controller: 'introCtrl'
      }
    }
  })

  .state('myLuko.congrats', {
    url: '/congrats',
    views: {
      'side-menu21': {
      templateUrl: 'templates/congrats.html',
      controller: 'congratsCtrl'
      }
    }
})


  .state('myLuko.setupHome', {
    url: '/setupHome',
    views: {
      'side-menu21': {
      templateUrl: 'templates/setupHome.html',
      controller: 'setupHomeCtrl'
      }
    }

  })


$urlRouterProvider.otherwise('/login')



});
