angular.module('app.services',  [])

.factory('BlankFactory', [function(){

}])

.service('Pricing', ['$http', function($http){
    var serverURL = 'https://app.getluko.com'
    var api_key = "877d252fa35a43cbe82a11d74bc37faef7cc6d3fb9724d1ce3e2e5160a9f0604"

    var ret = {
        getAll: function(date){
            console.log(date);
            var token = window.localStorage.token;
            var api_url = serverURL + '/v1/consumption?start_date=' + date.start_date + '&appliance=all&end_date=' + date.end_date + '&precision=3600';
            var req = {
                 method: 'GET',
                 url: api_url,
                 headers: {
                    'x-api-key': api_key,
                    'Authorization': 'Token '+ token,
                    'Content-Type': 'application/json'
                 },
                 timeout: 20000
            }

            return $http(req).then(function(resp){
                // console.log(resp);
                return resp.data.consumption;
            }, function(){ return(0);});

        },
        getAllForecast: function(date){
            console.log(date);
            var token = window.localStorage.token;
            var api_url = serverURL + '/v1/consumption?start_date=' + date.start_date + '&appliance=forecast&end_date=' + date.end_date + '&precision=3600';
            var req = {
                 method: 'GET',
                 url: api_url,
                 headers: {
                    'x-api-key': api_key,
                    'Authorization': 'Token '+ token,
                    'Content-Type': 'application/json'
                 },
                 timeout: 8000
            }

            return $http(req).then(function(resp){
                // console.log(resp);
                return resp.data.consumption;
            }, function(){ return(0);});

        }
    }
    return ret;

}])

.service('Globales', ['$http', function($http){
    var coverURL = 'https://cover.getluko.com'
    var serverURL = 'https://app.getluko.com'
    var serverURL2 = 'https://app2.getluko.com'

    var ret = {


        logIn: function(data){
            var api_url = serverURL + '/auth/login/api';
            var req = {
                 method: 'POST',
                 url: api_url,
                 headers: {
                    'Content-Type': 'application/json'
                 },
                 timeout: 8000,
                 data: '{"email":"'+ data.Email + '","password":"'+data.Password+'"}'
            }

            return $http(req).then(function(resp){
                // console.log(resp);
                return resp.data;
            }, function(resp){
                console.log("error login : ", resp)
                return(0);}); 
        },

        logInToken: function(data){
           var api_url = serverURL + '/auth/login/api';
           var token  = 'jwt ' + window.localStorage.token;
           var req = {
                method: 'GET',
                url: api_url,
                headers: {
                   'Content-Type': 'application/json',
                   'Authorization': token
                },
                timeout: 8000
           }

           return $http(req).then(function(resp){
               // console.log(resp);
               return resp.data;
           }, function(resp){
               console.log("error login : ", resp)
               return(0);});
        },

        addContract: function(data){
            var token  = window.localStorage.token;
            var api_url = serverURL + '/api/contract/get_all_approved';
            var req = {
                 method: 'POST',
                 url: api_url,
                 headers: {
                    'Authorization': 'jwt '+ token,
                    'Content-Type': 'application/json'
                 },
                 timeout: 8000,
                 data: JSON.stringify(data)
            }

            return $http(req).then(function(resp){
                // console.log(resp);
                return resp.data;
            }, function(){ return(0);});
        },

        getContract: function(){
            var token  = window.localStorage.token;
            var api_url = serverURL + '/api/contract/get_contract';
            var req = {
                 method: 'GET',
                 url: api_url,
                 headers: {
                    'Authorization': 'jwt '+ token,
                    'Content-Type': 'application/json'
                 },
                 timeout: 5000
            }
            return $http(req).then(function(resp){
                console.log("Contract : ");
                console.log(resp);
                return resp.data;
            }, function(){ return(0);});
        },


        setZIP: function(zip_code){
            var token  = window.localStorage.token;
            var api_url = serverURL + '/api/contract/set_zip';
            var req = {
                 method: 'POST',
                 url: api_url,
                 headers: {
                    'Authorization': 'jwt '+ token,
                    'Content-Type': 'application/json'
                 },
                 timeout: 8000,
                 data: JSON.stringify({zip: zip_code})
            }

            return $http(req).then(function(resp){
                // console.log(resp);
                return resp.data;
            }, function(){ return(0);});
        },

        getContractList: function(){
            var token  = window.localStorage.token;
            var api_url = serverURL + '/api/contract/get_all_approved';
            var req = {
                 method: 'GET',
                 url: api_url,
                 headers: {
                    'Authorization': 'jwt '+ token,
                    'Content-Type': 'application/json'
                 },
                 timeout: 8000
            }

            return $http(req).then(function(resp){
                // console.log(resp);
                return resp.data;
            }, function(){ return(0);});
        },

        setContract: function(data){
            var token  = window.localStorage.token;
            var api_url = serverURL + '/api/contract/get_contract';
            var req = {
                 method: 'POST',
                 url: api_url,
                 headers: {
                    'Authorization': 'jwt '+ token,
                    'Content-Type': 'application/json'
                 },
                 timeout: 8000,
                 data: JSON.stringify({contract_id: data})
            }

            return $http(req).then(function(resp){
                // console.log(resp);
                return resp.data;
            }, function(){ return(0);});
        },

        valideMuffin: function(token){
            var api_url = serverURL + '/api/users/cert';
            var req = {
                     method: 'GET',
                     url: api_url,
                     headers: {
                        'Authorization': 'jwt '+ token
                     },
                     timeout: 8000,
                }
            return $http(req).then(function(resp){
                //console.log(resp);
                if(resp.data.good == 1){
                    return(1);
                }else{
                    return(2);
                }
            },function(){return(0);});
        },

        valideMuffinAndVersion: function(token, ver){
            var api_url = serverURL + '/api/users/cert';
            var req = {
                     method: 'POST',
                     url: api_url,
                     headers: {
                        'Authorization': 'jwt '+ token
                     },
                     timeout: 8000,
                     data: JSON.stringify({version: ver})
                }
            return $http(req).then(function(resp){
                //console.log(resp);
                if(resp.data.good == 1){
                    return(1);
                }
                else if(resp.data.good == 10){
                    return(10);
                }
                else{
                    return(2);
                }
            },function(){return(0);});
        },

        signNewUser: function(data){
            var api_url = serverURL + '/auth/register/api';
            var req = {
                 method: 'POST',
                 url: api_url,
                 headers: {
                    'Content-Type': 'application/json'
                 },
                 timeout: 5000,
                 data: '{"email":"'+data.eMail+'", "phone":"'+data.Phone+'", "password":"'+data.mdp+'","first_name":"'+data.name+'"}'

            }
            //console.log(req);
            return $http(req).then(function(resp){
                //console.log('out scope');
                //console.log(resp);
                return resp.data;
            }, function(){ return(0);});

        },

        getEvents: function(token){
            var api_url = serverURL + '/api/users/self/events';
            var req = {
                 method: 'GET',
                 url: api_url,
                 headers: {
                    'Authorization': 'jwt '+ token,
                    'Content-Type': 'application/json'
                 }
            }
            //console.log(req);
            return $http(req).then(function(resp){
                //console.log('out scope');
                //console.log(resp);
                return resp.data;
            }, function(){ return(0);});

        },

        setEvents: function(token,data){
            var api_url = serverURL + '/api/users/self/events';
            var req = {
                 method: 'POST',
                 url: api_url,
                 headers: {
                    'Authorization': 'jwt '+ token,
                    'Content-Type': 'application/json'
                 },
                 data: '{"data": '+ JSON.stringify(data) + '}'
            }
            //console.log(req);
            return $http(req).then(function(resp){
                //console.log('out scope');
                //console.log(resp);
                return resp.data;
            }, function(){ return(0);});

        },

        getAlerts: function(token){
            var api_url = serverURL + '/api/users/self/alerts';
            var req = {
                 method: 'GET',
                 url: api_url,
                 headers: {
                    'Authorization': 'jwt '+ token,
                    'Content-Type': 'application/json'
                 }
            }
            //console.log(req);
            return $http(req).then(function(resp){
                //console.log('out scope');
                //console.log(resp);
                return resp.data;
            }, function(){ return(0);});

        },

        getAlertById: function(token, id){
            var api_url = serverURL + '/api/users/self/alertById';
            var req = {
                 method: 'POST',
                 url: api_url,
                 headers: {
                    'Authorization': 'jwt '+ token,
                    'Content-Type': 'application/json'
                 },
                 data : {"id" : id}
            }
            // console.log(JSON.stringify(req));
            return $http(req).then(function(resp){
                //console.log('out scope');
                //console.log(resp);
                return resp.data;
            }, function(){ return(0);});

        },

        resetPSW: function(email){
            //var api_url = serverURL + '/auth/reset/api';
            var api_url = coverURL + '/v1/auth/reset_password';
            var token="";
            var req = {
                 method: 'POST',
                 url: api_url,
                 headers: {
                    'Content-Type': 'application/json'
                 },
                 data: '{"email": "' +email+ '", "token": "' +token+ '"}'
            }
            //console.log(req);
            return $http(req).then(function(resp){;
                return resp.data.good;
            }, function(err){ console.log(err); return(0);});

        },

        getUser: function(token){
            var api_url = serverURL + '/api/users/self';
            var req = {
                 method: 'GET',
                 url: api_url,
                   headers: {
                    'Authorization': 'jwt '+ token,
                    'Content-Type': 'application/json'
                 }
            }
            //console.log(req);
            return $http(req).then(function(resp){
                console.log("GetUser resp : ");
                console.log(resp.data.data);
                return resp.data.data;
            }, function(resp){console.log("getUser: " + resp); return(0);});

        },


        setUser: function(token, data){
            var api_url = serverURL + '/api/users/self/changeInfo';
            var req = {
                 method: 'POST',
                 url: api_url,
                   headers: {
                    'Authorization': 'jwt '+ token,
                    'x-api-key': 'luko_main_key',
                    'Content-Type': 'application/json'
                 },
                 data: `{ "first_name": "${data.first_name}", "phone": "${data.phone}"}`
            }
            //console.log(req);
            return $http(req).then(function(resp){
                console.log("GetUser resp : ");
                console.log(resp.data.data);
                return resp.data.data;
            }, function(resp){console.log("getUser: " + resp); return(0);});

        },


        setAlerts: function(token,data){
            var api_url = serverURL + '/api/users/self/alerts';
            var req = {
                 method: 'POST',
                 url: api_url,
                 headers: {
                    'Authorization': 'jwt '+ token,
                    'Content-Type': 'application/json'
                 },
                 data: '{"data": '+ JSON.stringify(data) + '}',
            }
                //console.log(req);
            return $http(req).then(function(resp){
                //console.log('out scope');
                //console.log(resp);
                return resp.data;
            }, function(){ return(0);});

        },

        noMore: function(token, data){
            var api_url = serverURL + '/api/users/self/nomore';
            var req = {
                 method: 'POST',
                 url: api_url,
                 headers: {
                    'Authorization': 'jwt '+ token,
                    'Content-Type': 'application/json'
                 },
                 data: '{"data": '+ JSON.stringify(data) + '}'
            }
            //console.log(req);
            return $http(req).then(function(resp){
                //console.log('out scope');
                //console.log(resp);
                return resp.data;
            }, function(){ return(0);});
        },

        getHardwareStatus: function(token){
            var api_url = serverURL + '/api/users/self/real_device_info';
            var req = {
                 method: 'GET',
                 url: api_url,
                 headers: {
                    'Authorization': 'jwt '+ token,
                    'Content-Type': 'application/json'
                 },
                 timeout: 2500
            }

            return $http(req).then(function(resp){
                    return resp.data;
                }, function(err){
                    console.log("error : ", err)
                    if(err.status > 499 && err.status < 600){
                        return(500);
                    }
                    return(0);
            });
        },

        getPower2: function(token){
            var api_url = serverURL + '/api/users/self/getPower2';
            var req = {
                 method: 'POST',
                 url: api_url,
                 headers: {
                    'Authorization': 'jwt '+ token,
                    'Content-Type': 'application/json'
                 }
            }
            //console.log(req.data);
            return $http(req).then(function(resp){
                // console.log(resp);
                if(resp.data.good == 1){
                    var out = {
                        success: true,
                        data: resp.data.data
                    };
                    return out;
                }
                else{
                    var out = {
                        success: false
                    };
                    return out;
                }
            });
        },

        getPower3: function(token, lang){
            var api_url = serverURL + '/api/users/self/getPower3';
            // api_url = "https://prod-env-3.eu-west-1.elasticbeanstalk.com/api/users/self/getPower3"
            var req = {
                 method: 'POST',
                 url: api_url,
                 headers: {
                    'Authorization': 'jwt '+ token,
                    'Content-Type': 'application/json'
                 },
                 data: '{"language": "'+ lang+ '"}',
                 timeout: 10000
            }
            //console.log(req.data);
            return $http(req).then(function(resp){
                // console.log(resp);
                if(resp.data.good == 1){
                    var out = {
                        success: true,
                        data: resp.data.data
                    };
                    return out;
                }
                else{
                    var out = {
                        success: false
                    };
                    return out;
                }
            }, function(result){
                if(result.status == 401){
                    return("forbidden");
                }
                else if (result.status == 500){
                    return("server_error");
                }
                return(null)
            });
        },

        getPowerNow: function(token){
            var api_url = serverURL + '/api/users/self/getPowerNow';
            // api_url = "https://prod-env-3.eu-west-1.elasticbeanstalk.com/api/users/self/getPowerNow"
            var req = {
                 method: 'POST',
                 url: api_url,
                 headers: {
                    'Authorization': 'jwt '+ token,
                    'Content-Type': 'application/json'
                 },
                 timeout: 5000
            }
            //console.log(req.data);
            return $http(req).then(function(resp){
                // console.log(resp);
                if(resp.data.good == 1){
                    var out = {
                        success: true,
                        data: resp.data.data
                    };
                    return out;
                }
                else{
                    var out = {
                        success: false
                    };
                    return out;
                }
            }, function(result){
                if(result.status == 401){
                    return("forbidden");
                }
                return(null)
            });
        },

        lowCostTS: function(country,zip_code,city_id){
            var token  = window.localStorage.token;
            var api_url = serverURL + '/api/contract/get_time_slot';
            var datain = {};
            if (city_id!=0){
                datain= {
                    country: country,
                    zip: zip_code,
                    city_id: city_id
                }
            }
            else{
                datain= {
                    country:country,
                    zip: zip_code
                }
            }
            var req = {
                 method: 'POST',
                 url: api_url,
                 headers: {
                    'Authorization': 'jwt '+ token,
                    'Content-Type': 'application/json'
                 },
                 data: datain
            }
            //console.log(req.data);
            return $http(req).then(function(resp){
                // console.log(resp);
                if(resp.data.good == 1){
                    return resp.data.data;
                }
                else{
                    return 0;
                }
            },function(resp){return 0;});
        },

        setLowCostTS: function(lowCostTimeSlot){
            var token  = window.localStorage.token;
            var api_url = serverURL + '/api/contract/get_time_slot';
            var datain = {};
            datain= {
                time_slot: lowCostTimeSlot,
            }
            var req = {
                 method: 'POST',
                 url: api_url,
                 headers: {
                    'Authorization': 'jwt '+ token,
                    'Content-Type': 'application/json'
                 },
                 data: datain
            }
            // console.log(JSON.stringify(req.data));
            return $http(req).then(function(resp){
                // console.log(resp);
                if(resp.data.good == 1){
                    return resp.data.data;
                }
                else{
                    return 0;
                }
            },function(resp){return 0;});
        },

        sendPhoto: function(data_URL){
            var token  = window.localStorage.token;
            var api_url = serverURL + '/api/users/self/upload_contract';
            var datain = {};
            datain= {
                files: data_URL,
            }
            var req = {
                 method: 'POST',
                 url: api_url,
                 headers: {
                    'Authorization': 'jwt '+ token,
                    'Content-Type': 'multipart/form-data'
                 },
                 data: datain
            }
            return $http(req).then(function(resp){
                // console.log(resp);
                if(resp.data.success == 1){
                    return 1;
                }
                else{
                    return 0;
                }
            },function(resp){return 0;});
        },

        pingg: function(){
            var req = {
                 method: 'HEAD',
                 url: "https://www.google.com/",
                 timeout: 2000
            }
            return $http(req).then(function(resp){
                return true;
            },function(resp){return false;});
        }

    }
    return ret;

}])

.service('Option', ['$http', function($http){
        var serverURL = 'https://app.getluko.com'
        //var serverURL = 'http://127.0.0.1:5000'

        var ret = {
            getOption: function(token){
                var api_url = serverURL + '/api/users/self/options';
                var req = {
                     method: 'GET',
                     url: api_url,
                     headers: {
                        'Authorization': 'jwt '+ token
                     }
                }
                return $http(req).then(function(resp){
                        return resp.data.data;
                    }, function(){ return(0);}
                    );
            },

            getDeviceID: function(token){
                var api_url = serverURL + '/api/users/self/getDevice';
                var req = {
                     method: 'GET',
                     url: api_url,
                     headers: {
                        'Authorization': 'jwt '+ token
                     },
                     timeout: 3000
                }
                return $http(req).then(function(resp){
                    console.log("resp data : " + resp.data);
                    return resp.data;
                }, function(resp){
                    console.log("resp data error : " + resp.data);
                    return 0;
                });
            },

            setOption: function(token,data){
                var api_url = serverURL + '/api/users/self/options';
                var req = {
                     method: 'POST',
                     url: api_url,
                     headers: {
                        'Authorization': 'jwt '+ token,
                        'Content-Type': 'application/json'
                     },
                     data: '{"data": '+JSON.stringify(data)+'}'
                }
                // console.log(req.data);
                return $http(req).then(function(resp){
                    return resp.data;
                });
            }
        }
    return ret;

}])

.service('Price', ['$http', '$translate', function($http, $translate){
    var euro_by_kwh = 0;
    var euro_by_kWh_low = 0;
    var euro_by_year =0;
    var storage = window.localStorage;
    try{
        var contract = JSON.parse(storage.contract);
    }
    catch(err) {
        var contract = {};
    }
    var ret = {

        day: function(high, low){
            try{
                contract = JSON.parse(storage.contract)
            }
            catch(err) {
                contract = {};
            }
            if(contract.hour_dependant==0){
                if(contract.day_dependant==0){
                    priceArray = JSON.parse(contract.price);
                    euro_by_kwh = priceArray[0];
                    euro_by_year = priceArray[1];
                }
                else{
                    priceArray = JSON.parse(contract.price);
                    euro_by_kwh = priceArray[0][0][0];
                    euro_by_year = priceArray[1];
                }
                return ((high+low)*euro_by_kwh+euro_by_year/365)
            }
            else if(contract.hour_dependant==1){
                if(contract.day_dependant==0){
                    priceArray = JSON.parse(contract.price);
                    euro_by_kwh = priceArray[0][0];
                    euro_by_kWh_low = priceArray[0][1];
                    euro_by_year = priceArray[1];
                }
                else{
                    priceArray = JSON.parse(contract.price);
                    euro_by_kwh = priceArray[0][0][0];
                    euro_by_kWh_low = priceArray[0][0][1];
                    euro_by_year = priceArray[1];
                }
                return ((high*euro_by_kwh)+(low*euro_by_kWh_low)+euro_by_year/365)
            }
            else{
                return 0;
            }
        },

        auto: function(high, low, time_type){
            var includ_fixed = 1;
            var fixed_divider = 1;
            if(time_type==0){ //instant : so no fixe time
                includ_fixed = 0;
            }
            else if(time_type==1){ //day
                includ_fixed = 1;
                fixed_divider = 365;
            }
            else if(time_type==2){ //week
                includ_fixed = 1;
                fixed_divider = 365/7;
            }
            else if(time_type==3){ //month
                includ_fixed = 1;
                fixed_divider = 12;
            }
            else if(time_type==4){ //year
                includ_fixed = 1;
                fixed_divider = 1;
            }
            else{
                includ_fixed = 0;
            }

            try{
                contract = JSON.parse(storage.contract)
            }
            catch(err) {
                contract = {};
            }
            if(contract.hour_dependant==0){
                if(contract.day_dependant==0){
                    priceArray = JSON.parse(contract.price);
                    euro_by_kwh = priceArray[0];
                    euro_by_year = priceArray[1];
                }
                else{
                    priceArray = JSON.parse(contract.price);
                    euro_by_kwh = priceArray[0][0][0];
                    euro_by_year = priceArray[1];
                }
                return ((high+low)*euro_by_kwh+euro_by_year/fixed_divider*includ_fixed)
            }
            else if(contract.hour_dependant==1){
                if(contract.day_dependant==0){
                    priceArray = JSON.parse(contract.price);
                    euro_by_kwh = priceArray[0][0];
                    euro_by_kWh_low = priceArray[0][1];
                    euro_by_year = priceArray[1];
                }
                else{
                    priceArray = JSON.parse(contract.price);
                    euro_by_kwh = priceArray[0][0][0];
                    euro_by_kWh_low = priceArray[0][0][1];
                    euro_by_year = priceArray[1];
                }
                return ((high*euro_by_kwh)+(low*euro_by_kWh_low)+euro_by_year/fixed_divider*includ_fixed)
            }
            else{
                return 0;
            }
        },

        month: function(total){
            try{
                contract = JSON.parse(storage.contract)
            }
            catch(err) {
                contract = {};
            }
            return total*euro_by_kwh;
        },

        cur: function(value){
            try{
                contract = JSON.parse(storage.contract)
            }
            catch(err) {
                contract = {};
            }
            if (value==null){
                value="";
                if(contract.currency=="pound"||contract.currency=="gbp"){
                    return("£")
                }
                else if(contract.currency=="euro"){
                    return("€")
                }
                else if(contract.currency=="usd"){
                    return("$")
                }
                else{
                    return("¤")
                }
            }
            value = this.formatLargeNumber(value, 2);
            if(contract.currency=="pound"||contract.currency=="gbp"){
                return("£ "+value)
            }
            else if(contract.currency=="euro"){
                return(value + " €")
            }
            else if(contract.currency=="usd"){
                    return("$ " + value)
            }
            else{
                return(value + " ¤")
            }
        },
        formatLargeNumber: function(value, nb_digits){
            if($translate.use() == "fr-FR"){
                return value.toFixed(nb_digits).replace(".", ",").replace(/\B(?=(\d{3})+(?!\d))/g, ".");
            }else{
                return value.toFixed(nb_digits).replace(/\B(?=(\d{3})+(?!\d))/g, ",");
            };
        }
    }
    return ret;

}])

.service('Saving', ['$ionicPlatform', function($ionicPlatform){

    var db = null;
    var tableCreated = false;

    $ionicPlatform.ready(function() {
        // console.log("depuis service")
        try {
            // console.log("open db in service")
            db = window.sqlitePlugin.openDatabase({name:"nextflow.db",location:'default'});
            // console.log("db opened")
        } catch (error) {
            // console.log("open db error")
            // console.log(JSON.stringify(error));
        }
    });

    var ret = {
        setValueSlow: function(key,value){
            //console.log("Add element : " + key + " | " + value)
            db.transaction(function(tr) {
                tr.executeSql('CREATE TABLE IF NOT EXISTS saveData (key TEXT PRIMARY KEY, value TEXT)',[],function(){
                   //console.log("Table created");
                    tableCreated = true;
                    tr.executeSql("SELECT value FROM saveData WHERE key = '"+ key +"';", [], function(tr, rs) {
                        if (rs.rows.length > 0) {
                            //console.log("update")
                         //   console.log("updated " + JSON.stringify(rs));
                            tr.executeSql("UPDATE saveData SET value = '"+ value +"' WHERE key = '"+ key +"';",[],function(tr, rs) {/*console.log("updated " + JSON.stringify(rs));*/});
                        }
                        else{
                         //   console.log("insert")
                            tr.executeSql("INSERT INTO saveData (key, value) VALUES ('"+ key +"', '"+ value +"')",[],function(tr, rs) {/*console.log("updated " + JSON.stringify(rs));*/});
                        }
                        return(null);
                    });
                });
            });
        },

        setValueQuick: function(key,value){
            //console.log("Add quick element : " + key + " | " + value)
            db.transaction(function(tr) {
                tr.executeSql("SELECT value FROM saveData WHERE key = '"+ key +"';", [], function(tr, rs) {
                    if (rs.rows.length > 0) {
                       // console.log("update")
                       // console.log("updated " + JSON.stringify(rs));
                       //console.log(value)
                       //console.log(value.length);
                       //console.log("UPDATE saveData SET value = '"+ value +"' WHERE key = '"+ key +"';");
                        tr.executeSql("UPDATE saveData SET value = '"+ value +"' WHERE key = '"+ key +"';",[],function(tr, rs) {/*console.log("updated " + JSON.stringify(rs));*/});
                    }
                    else{
                       // console.log("insert")
                        tr.executeSql("INSERT INTO saveData (key, value) VALUES ('"+ key +"', '"+ value +"')",[],function(tr, rs) {/*console.log("updated " + JSON.stringify(rs));*/});
                    }
                    return(null);
                });
            });
        },

        set: function(key,value){
            if (tableCreated){
                ret.setValueQuick(key,value);
            }
            else{
                ret.setValueSlow(key, value);
            }
        },

        get: function(key, callback){
           // console.log("Get element")
            db.transaction(function(tr) {
                tr.executeSql("SELECT value FROM saveData WHERE key = '"+ key +"';", [], function(tr, rs) {
                    console.log(JSON.stringify(rs));
                    if (rs.rows.length > 0) {
                       // console.log(rs.rows.item(0).value);
                        callback(rs.rows.item(0).value);
                    }
                    else{
                        console.log("no data");
                        callback(null);
                    }
                });
            });
        },

        save: function(callback){
            // console.log("Saving storage in DB")
            try{
                if((callback == null)||(callback === undefined)){
                    callback = function(){};
                }
                var storage  = window.localStorage;
                //console.log(JSON.stringify(storage));
                var keys  = Object.keys(storage);
                //console.log(keys);
                for(var k in keys){
                    //console.log(keys[k] + " | " + storage[keys[k]]);
                    if(keys[k]== "consumptionData"){
                        //console.log(keys[k] + " | " + storage[keys[k]]);
                        ret.set(keys[k],storage[keys[k]]);
                    }
                    else{
                        ret.set(keys[k],storage[keys[k]]);
                    }
                }
                // console.log("Storage done !");
            }
            catch(err) {
                // console.log("no db : " + JSON.stringify(err))
            }
            callback();
        },

        load: function(callback){
            // console.log("Loading DB in stor@ge")
            try{
                var storage  = window.localStorage;
                //console.log("here");
                db.transaction(function(tr) {
                    //console.log("here");
                    if (!tableCreated){
                        tr.executeSql('CREATE TABLE IF NOT EXISTS saveData (key TEXT PRIMARY KEY, value TEXT)',[],function(){
                            //console.log("create base");
                            tableCreated = true;
                            ret.load(callback);
                        });
                    }
                    else{
                        tr.executeSql("SELECT * FROM saveData;", [], function(tr, rs) {
                            //console.log("here");
                            for(var i=0; i< rs.rows.length; i++) {
                                //console.log(rs.rows.item(i).key + " | " + rs.rows.item(i).value)
                                storage[rs.rows.item(i).key] = rs.rows.item(i).value;
                            }
                            //console.log("here");
                            callback();
                        });
                    }
                });
            }
            catch(err) {
                // console.log("no db : " + JSON.stringify(err));
                callback();
            }
        }
    }
    return ret;

}])


.service('LukoDevicePairing', ['$http', function($http){

    var api_url = 'http://192.168.4.1';
    // var api_url = 'http://127.0.0.1:5000/hard'
    //var api_url = 'https://app.getluko.com/hard'
    if (!String.prototype.includes) {
      String.prototype.includes = function(search, start) {
        'use strict';
        if (typeof start !== 'number') {
          start = 0;
        }

        if (start + search.length > this.length) {
          return false;
        } else {
          return this.indexOf(search, start) !== -1;
        }
      };
    }

    var ret = {

        setDeviceID: function(deviceID, token){
            var req = {
                 method: 'POST',
                 url: 'https://app.getluko.com/api/users/self/setDevice',
                 headers: {
                    'Content-Type': 'application/json',
                    'Authorization': 'jwt '+ token
                 },
                 data: '{"sensorID":'+deviceID+'}'
            }
            // console.log(JSON.stringify(req));
            return $http(req).then(function(resp){
                //console.log('out scope');
                // console.log(JSON.stringify(resp));
                return resp.data;
            }, function(resp){
              // console.log(JSON.stringify(resp)); 
              return(0);
            });
        },

        check433Online: function(date, token){
            var req = {
                 method: 'POST',
                 url: 'https://app.getluko.com/api/users/self/check433',
                 headers: {
                    'Content-Type': 'application/json',
                    'Authorization': 'jwt '+ token
                 },
                 data: '{"date":'+date+'}'
            }
            //console.log(JSON.stringify(req));

            return $http(req).then(function(resp){
                  //  console.log(JSON.stringify(resp));
                    return resp.data;
                }, function(resp){
                    //console.log(JSON.stringify(resp));
                    return(0);
                });
        },

        checkServerOnline: function(){
            var token  = window.localStorage.token;
            var req = {
                 method: 'GET',
                 url: 'https://app.getluko.com/api/users/self/checkServer',
                 headers: {
                    'Content-Type': 'application/json',
                    'Authorization': 'jwt '+ token
                 },
                 timeout: 3000
            }
            // console.log(JSON.stringify(req));

            return $http(req).then(function(resp){
                    // console.log(JSON.stringify(resp));
                    return resp.data.good;
                }, function(resp){
                    // console.log(JSON.stringify(resp));
                    return(null);
            });
        },

        pingg: function(){
            var req = {
                 method: 'HEAD',
                 url: "https://www.google.com/",
                 timeout: 4000
            }
            return $http(req).then(function(resp){
                return true;
            },function(resp){return false;});
        },

        listWifi: function(){

            function ISOtoUTF(iso){
                // console.log(iso);
                utfstring = unescape(encodeURIComponent(iso));
                // console.log(encodeURIComponent(iso));
                // console.log(escape(iso));
                // console.log(unescape(escape(iso)));

                //utf2 = decodeURIComponent(escape(iso));
                // console.log(utfstring);
                return(escape(iso))
            }

            function appendTransform(defaults, transform) {
              // We can't guarantee that the default transformation is an array
                defaults = angular.isArray(defaults) ? defaults : [defaults];
                transform = angular.isArray(transform) ? transform : [transform];
              // Append the new transformation to the defaults
                return transform.concat(defaults);
            }

            var req = {
                method: 'GET',
                url: api_url +'/listWiFi',
                headers: {},
                timeout: 2500,
                transformResponse: appendTransform($http.defaults.transformResponse, function(value) {
                    return ISOtoUTF(value);
                })
            }

            //console.log(req);
            return $http(req).then(function(resp){
                // console.log(resp);
                try{
                    out = JSON.parse(unescape(resp.data));
                    return out;
                }
                catch(err){
                    return(1);
                }
            }, function(error, status){
                // console.log({ message: error, status: status});
                try{
                    if(error.message.includes("JSON")){
                        return(1);
                    }
                    else{
                        return(0);
                    }
                }
                catch(err){
                    return(0);
                }
                return(0);
            });
        },
        setWifi: function(info){
            //console.log('eMail='+data.eMail+'&Phone='+data.Phone+'&mdp='+data.mdp);
            var password = info.pwd;
            var ssid = info.ssid;

            var url = api_url +"/setWifi?p=" + encodeURIComponent(password) +"&s=" + encodeURIComponent(ssid);
            // console.log(url);

            var req = {
                 method: 'GET',
                 url: url,
                 headers: {},
                 timeout: 2500,
                 //params: {s: info.ssid, p: info.pwd}
            }

            return $http(req).then(function(resp){
                //console.log('out scope');
                // console.log(resp.data);
                return resp.data;
            }, function(){ return(0);});

        },
        verifElecSensorId: function(data){
            var token = window.localStorage.token;
            var req = {
                 method: 'POST',
                 url: 'https://app.getluko.com/hard/ElecSensorId',
                 headers: {
                    'Authorization': 'jwt '+ token,
                    'Content-Type': 'application/json'
                 },
                 data: JSON.stringify(data),
                 timeout: 2500
            }
            return $http(req).then(function(resp){
                // console.log(resp);
                return resp.data;
            }, function(){ return(0);});

        },
        getID: function(){
            //console.log('eMail='+data.eMail+'&Phone='+data.Phone+'&mdp='+data.mdp);
            var req = {
                 method: 'GET',
                 url: api_url +'/getLukoID',
                 headers: {},
                 timeout: 2500,
            };
            //console.log("retreiving id");
            //console.log(req);
            return $http(req).then(function(resp){
                //console.log('out scope');
                //console.log(resp);
                return resp.data;
            }, function(){ return(0);});

        },
        getWifiState: function(){
            //console.log('eMail='+data.eMail+'&Phone='+data.Phone+'&mdp='+data.mdp);
            var req = {
                 method: 'GET',
                 url: api_url +'/getWifiState',
                 headers: {},
                 timeout: 2500,
            }

            return $http(req).then(function(resp){
                //console.log('out scope');
                //console.log(resp);
                return resp.data;
            }, function(){ return(0);});

        },

       getReceptionState: function(){
            //console.log('eMail='+data.eMail+'&Phone='+data.Phone+'&mdp='+data.mdp);
            var req = {
                 method: 'GET',
                 url: api_url +'/receptionState',
                 headers: {},
                 timeout: 2500,
            }

            return $http(req).then(function(resp){
                //console.log('out scope');
                console.log(resp.data);
                return resp.data;
            }, function(){ return(0);});

        },

        shutdownServer: function(){
            //console.log('eMail='+data.eMail+'&Phone='+data.Phone+'&mdp='+data.mdp);
            var req = {
                 method: 'GET',
                 url: api_url +'/shutdownServer',
                 headers: {},
                 timeout: 2500,
            }

            return $http(req).then(function(resp){
                //console.log('out scope');
                // console.log(JSON.stringify(resp.data));
                return resp.data;
            }, function(){ return(0);});

        },

        getServerConnection: function(){
            //console.log('eMail='+data.eMail+'&Phone='+data.Phone+'&mdp='+data.mdp);
            var req = {
                 method: 'GET',
                 url: api_url +'/serverConnection',
                 headers: {},
                 timeout: 2500,
            }

            return $http(req).then(function(resp){
                //console.log('out scope');
                //console.log(resp);
                return resp.data;
            }, function(){ return(0);});

        },

        checkFormFilled: function(){
            var token = window.localStorage.token;
            var req = {
                 method: 'GET',
                 url: 'https://app.getluko.com/api/users/self/checkFormFilled',
                 headers: {
                   'Authorization': 'jwt '+ token,
                   'Content-Type': 'application/json'
                 },
                 timeout: 2500,
            }

            return $http(req).then(function(res){
                console.log("check form filled")
                console.log(res);
                return res.data;
            }, function(){ return(0);});

        },
    }
    return ret;

}])


.service('Feedback', ['$http', function($http){
        var serverURL = 'https://app.getluko.com'
        //var serverURL = 'http://127.0.0.1:5000'

        var ret = {
            sendFeedback: function(token, data){
              if (data.hasOwnProperty('appliance')){
                var api_url = serverURL + '/api/users/self/upload_feedback_appliance';
              }
              else if (data.hasOwnProperty('alertId')){
                var api_url = serverURL + '/api/users/self/upload_feedback_alert';
              }
                var req = {
                     method: 'POST',
                     url: api_url,
                     headers: {
                        'Authorization': 'jwt '+ token,
                        'Content-Type': 'application/json'
                     },
                     data: JSON.stringify(data),
                     timeout: 2500
                }
                //console.log(req.data);
                return $http(req).then(
                    function(resp){
                        return resp.data;
                    },
                    function(err){
                        return(0);
                    }
                );
            }
        }
    return ret;

}])


.service('Advice', ['$http', function($http){
        var serverURL = 'https://app.getluko.com'
        //var serverURL = 'http://127.0.0.1:5000'

        var ret = {
            getAdvice: function(token){
                var api_url = serverURL + '/api/users/self/advice';
                var req = {
                     method: 'GET',
                     url: api_url,
                     headers: {
                        'Authorization': 'jwt '+ token
                     }
                }
                return $http(req).then(function(resp){
                    return resp.data.data;
                },
                    function(err){
                        return(0);
                    }
                );
            },

            setAdvice: function(token,data){
                var api_url = serverURL + '/api/users/self/advice';
                var req = {
                     method: 'POST',
                     url: api_url,
                     headers: {
                        'Authorization': 'jwt '+ token,
                        'Content-Type': 'application/json'
                     },
                     data: JSON.stringify(data)
                }
                // console.log("setAdvice", req.data);
                return $http(req).then(function(resp){
                    return resp.data;
                });
            }
        }
    return ret;

}])
